/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


EXPORTED_SYMBOLS.push("gApplication");
function Application()
{
}
Application.prototype =
{
    brandingManager : null,
    deviceManager : null,
    cdManager : null,
    addonManager : null,
    login : null,
    cart : null,
    urlHandler : null,
    homeServices : null,
    itemFactory : null,
    tlvvocfetcher : null,
    settings : null,
    startupURI : null,

    _initialized : false,
    _loginDeviceRel : null,
    _autoLogin : null,
    _stringBundle : null,
    _generalErrorListener : null,
start : function()
    {
        if (this._initialized)
            return;
        this._initialized = true;{}
var starttime = new Date();
        this._stringBundle = getStringBundle("chrome://tthome/locale/logic/app.properties");
        this.settings = new GlobalSettings();
        this.settings.start();
        try {
            prefService().setCharPref(
                "general.useragent.extra.tthome",
                "TomTomHOME/" + this.settings.version);
        } catch (e) {
            unimportantError(e);
        }
        checkFirstRun();
        this._startHOMEServicesDLL();
        this.tlvvocfetcher = new TLVVocabularyFetcher();
        this.tlvvocfetcher.start();
        this.deviceManager = new DeviceManager();
        this.deviceManager.start();
        this.brandingManager = new BrandingManager();
        this.cdManager = new CDManager();
        this.cdManager.start();
        this.addonManager = new AddonManager();
        this.addonManager.start();
        this.settings.initLocalItems();
        this.login = new Login();
        this.login.start();
        this._autoDeviceUpdate = new AutoDeviceUpdate();
        this._autoDeviceUpdate.start();
        this._loginDeviceRel = new LoginDeviceRelationship();
        this._loginDeviceRel.start();
        this._autoLogin = new AutoLogin();
        this._autoLogin.start();
        this._tripUpload = new TripUpload();
        this._tripUpload.start();
        this.cart = new Cart();
        this.cart.start();
        this.urlHandler = new URLHandler();
        this.urlHandler.start();
        this.itemFactory = new ttItemFactory();{}
{}
},
    _startHOMEServicesDLL : function()
    {
var module = Cc["@home2.tomtom.com/services/service;1"];
        if (!module)
            throw this._stringBundle.GetStringFromName("dllNotFound");
        this.homeServices = module.getService(CI.ttIHomeService);
        this._generalErrorListener = new GeneralErrorListener();
        try
        {
            this.homeServices.init(this.settings.uiLocale, this.settings.profileDir, this._generalErrorListener);
        }
        catch (e)
        {
            if (e.result == 0x8075001b)
            {
                this.homeServices.errorListener = this._generalErrorListener;{}
}
            else
            {
                throw e;
            }
        }
},
getSomeMainWindow : function()
    {
        var mainWindow = getMainWindowByType();
        if (mainWindow)
            return mainWindow.gMainWindow;
        else
            return null;
    },
assertRunnable : function(task, params)
    {
        function chromeURLExists(aURL)
        {
            var ioService = Cc["@mozilla.org/network/io-service;1"]
                .getService(CI.nsIIOService);
            var scriptableStream = Cc["@mozilla.org/scriptableinputstream;1"]
                .getService(CI.nsIScriptableInputStream);
            try {
                var input = ioService.newChannel(aURL, null, null).open();
                scriptableStream.init(input);
                scriptableStream.read(0);
                return true;
            } catch (e if e.name == "NS_ERROR_FILE_NOT_FOUND") {
                return false;
            } finally {
                try {
                    scriptableStream.close();
                } catch (e2) { unimportantError(e2); }
            }
        }

        var loader = Cc["@mozilla.org/moz/jssubscript-loader;1"]
            .getService(CI.mozIJSSubScriptLoader);
        if (task.indexOf("/") < 0)
            task = "chrome://tthome/content/ui/task/" + task + "/" + task + ".xul";

        var preconditionsUrl = task.replace(/\/[^\/]+$/, "/preconditions.js");
        if (chromeURLExists(preconditionsUrl))
        {
            var env = {};
            loader.loadSubScript(preconditionsUrl, env);
            env.assertRunnable(params);
        }
    },
quitApplication : function(aForceQuit, aRestart)
    {
        var windowManager = Cc['@mozilla.org/appshell/window-mediator;1']
                            .getService(CI.nsIWindowMediator);
        var enumerator = windowManager.getEnumerator(null);
        var appStartup = Cc['@mozilla.org/toolkit/app-startup;1'].
                       getService(CI.nsIAppStartup);

        if (!aForceQuit)
        {
            while (enumerator.hasMoreElements())
            {
                var domWindow = enumerator.getNext();
                if (("canClose" in domWindow) && !domWindow.canClose())
                    return false;
                if (("tryToClose" in domWindow) && !domWindow.tryToClose())
                    return false;
                domWindow.close();
            }
        }

        try {
            var quitMode = 0;
            if (aRestart)
                quitMode |= CI.nsIAppStartup.eRestart;

            if (aForceQuit)
                appStartup.quit(quitMode | CI.nsIAppStartup.eForceQuit);
            else
                appStartup.quit(quitMode | CI.nsIAppStartup.eAttemptQuit);

            return true;
        } catch (e if !aForceQuit) {
            try {
                appStartup.quit(quitMode | CI.nsIAppStartup.eForceQuit);
                return true;
            } catch(e) {
                error(e);
            }

        } catch(e) {
            error(e);
        }

        return false;
    },

    __end : null
}

const gApplication = new Application();
