/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function Cart()
{
    this._cart = new Array();
    this._observers = new Array();
}
Cart.prototype =
{

    _cart : null,
    _observers : null,
    get isEmpty()
    {
        return this._cart.length == 0;
    },

    get totalSize()
    {
        return this._cart.reduce(function(accum, item) accum + item.size, 0);
    },

    get totalPrice()
    {
        if (this._cart.length == 0)
        {
            var dummy = new ttCurrency();
            dummy.free = true;
            return dummy;
        }

        var result = this._cart[0].price.copy();
        for (var i = 1; i < this._cart.length; i++)
        {
            result = ttCurrency.prototype.add(result, this._cart[i].price);
        }
        return result;
    },
get contentsFlat()
    {
        return this._cart;
    },
get contentsWithAmount()
    {
        var map = new Object();
        for (var i = 0; i < this._cart.length; i++)
        {
            var item = this._cart[i];
            if (typeof map[item.id] == "undefined")
                map[item.id] = { item: item, amount: 1 };
            else
                map[item.id].amount++;
        }
        var result = new Array();
        for (var id in map)
            result.push(map[id]);
        return result;
    },
addItem : function(item, amount)
    {
        if (!(item instanceof ttItem))
            throw new Bug("Can only add ttItem to cart");
        if (!amount && amount !== 0)
            amount = 1;

        for (var i = 0; i < amount; i++)
        {
            this._cart.push(item);
        }

        this._notifyChange();{}
},

    removeItem : function(item, amount)
    {
        if (!(item instanceof ttItem))
            throw new Bug("Can only add ttItem to cart");
        if (!amount && amount !== 0)
            amount = 1;

        for (var i = 0; i < amount; i++)
        {
            ArrayRemoveFirst(this._cart, item);
        }

        this._notifyChange();{}
},

    itemInCart : function(item)
    {
        for (var i = 0; i < this._cart.length; i++)
        {
            if (item.id == this._cart[i].id)
                    return true;
        }
        
        return false;
    },
clear : function()
    {
        this._cart = new Array();
        this._notifyChange();
    },

    addObserver : function(observer)
    {
        this._observers.push(observer);
    },
    removeObserver : function(observer)
    {
        ArrayRemoveAllMatching(this._observers, observer);
    },
start : function()
    {
    },

    _notifyChange : function()
    {
        for (var i = 0; i < this._observers.length; i++)
        {
            try {
                this._observers[i].changed();
            } catch (e) { error(e); }
        }
    },

    __end : null
}
