/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


EXPORTED_SYMBOLS.push("fetchHTTP");
var fetchHTTP =
{
fetch : function(ucURL, headerArgs, post, uploadbody, successCallback, errorCallback)
    {
        var call = new FetchHTTPCall();
        call.start(ucURL, headerArgs, post, uploadbody, successCallback, errorCallback);
        return call;
    },
    __end : null
}
function FetchHTTPCall()
{
}
FetchHTTPCall.prototype =
{
    _mFinishedCallback : null,
    cancelException : null,

    start : function(ucURL, headerArgs, post, uploadbody, successCallback, errorCallback)
    {
        this.uri = makeSafe.url(ucURL);
        if (!headerArgs)
            headerArgs = {};
        var uploadbodyString = null;
        if (uploadbody)
            uploadbodyString = (typeof uploadbody == "xml" ? uploadbody.toXMLString() : uploadbody.toString());{}
if (uploadbodyString){}
post = makeSafe.bool(post);
        if (successCallback != null && typeof successCallback != "function")
            throw new InvalidArgument("successCallback is not a function");
        if (errorCallback != null && typeof errorCallback != "function")
            throw new InvalidArgument("errorCallback is not a function");
        this.successCallback = successCallback;
        this.errorCallback = errorCallback;
        var mimetype = null;
        if (typeof(uploadbody) == "xml")
            mimetype = "text/xml";

        this.request = new XMLHttpRequest();
        this.request.open(post ? "POST" : "GET", this.uri.spec);
        this.request.channel.loadGroup = null;
        if (mimetype)
            this.request.setRequestHeader("Content-Type", mimetype);
        this.request.setRequestHeader("Accept-Language", gApplication.settings.networkLocale);
        this.request.setRequestHeader("TT-Generic-Country", gApplication.settings.country);
        for (var headerArg in headerArgs)
            this._setHeaderArg(this.request, headerArg, headerArgs[headerArg]);
        this.post = post;
        this.headers = headerArgs;
        this.uploadbody = uploadbody;

        this.request.send(uploadbodyString);

        var me = this;
        this.request.onload = function() { me._done(true); }
        this.request.onerror = function() { me._done(false); }
    },
    setFinishedCallback : function (aFinishedCallback)
    {
        this._mFinishedCallback = aFinishedCallback;
    },
    cancel : function(ex)
    {
        this.request.abort();
        this.cancelException = ex ? ex : new UserCancelledException();
        this.success = false;
        this._doneCallbacks();
    },
    _done : function(success)
    {
if (success && this.request.status >= 200 && this.request.status < 300)
        {
            try
            {
                var mimetype = this.request.getResponseHeader("Content-Type");
                mimetype = mimetype ? mimetype.split(";")[0] : "";
                if (mimetype == "text/xml" ||
                    mimetype == "application/xml" ||
                    mimetype == "text/rdf")
                {
                    var text = this.request.responseText;
                    text = text.replace(/<\?xml[^>]*\?>/, "");
                    this.result = new XML(text);
                }
                else
                {
this.result = this.request.responseText;
                }
this.success = true;
            }
            catch (e)
            {
                this.success = false;
                this.errorStr = rpc.stringBundle.GetStringFromName("badXMLResponse");
                this.errorCode = -4;
            }
        }
        else
        {
            this.success = false;
try {
} catch (e) {}

            try {
                this.errorCode = -this.request.status;
                this.errorStr = this.request.statusText;
            } catch (e) {
                this.cancelException = NetUtil.exceptionForStatusCode(this.request.channel.status, this.uri.spec);
                unimportantError(e);
            }
        }

        this._doneCallbacks();
    },
    _doneCallbacks : function()
    {
        if (this.success)
        {
            try {
                this.successCallback(this.result);
            } catch (e) {
                this.errorCallback(e);
            }
        }
        else
        {
            try {
                var e;
                if (this.cancelException)
                {
                    e = this.cancelException
                }
                else
                {
                    let uri = null;
                    if (this.uri instanceof CI.nsIURL)
                        uri = this.uri.prePath + this.uri.filePath;
                    else if (this.uri)
                        uri = this.uri.spec;
                    e = new ServerError(this.errorStr, this.errorCode, uri, undefined,
                                {
                                    method: this.post ? "POST" : "GET",
                                    headers: this.headers,
                                    uploadbody: this.uploadbody
                                });
                }

                this.errorCallback(e);
            } catch (e) {
                error(e);
            }
        }

        if (this._mFinishedCallback)
            this._mFinishedCallback(this);
    },
_setHeaderArg : function(request, name, value)
    {
        name = makeSafe.alphanumdash(name);
        name = name.replace(/_/g, "-");
        value = makeSafe.string(value + "");
        value = this._encodeHeaderValue(value);
        request.setRequestHeader(name, value);
    },
_encodeHeaderValue : function(str)
    {
        str = encodeURIComponent(str);
        str = str.replace(/\%20/g, " ");
        return str;
    },
    __end : null
}

extend(FetchHTTPCall, NetworkCall);
