/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function checkFirstRun()
{
    var curVersion = gApplication.settings.version;
    var first = true;
    var lastRun = "0.0";
    try {
        first = prefService().getBoolPref("tomtom.app.firstrun");
    } catch (e) {}
    try {
        if (!first)
            lastRun = prefService().getCharPref("tomtom.app.firstrun.version");
    } catch (e) {}
    if (first)
    {
        if (!doFirstRunActions())
        {
            return;
        }
    }
    else
    {
        if (versionNewerThan(curVersion, lastRun))
        {
            doUpgradeActions(curVersion, lastRun);
        }
    }

    var curVersion = gApplication.settings.version;
    prefService().setCharPref("tomtom.app.firstrun.version", curVersion);
    prefService().setBoolPref("tomtom.app.firstrun", false);
}
function doFirstRunActions()
{
    if (!acceptEULA())
    {
        return false;
    }
var urlid = "firstrun";
    getStaticURL(idMapping[urlid], function (urlString)
    {
        var extps = Cc["@mozilla.org/uriloader/external-protocol-service;1"]
            .getService(CI.nsIExternalProtocolService);
        var uri = getIOService().newURI(urlString, null, null);

        try
        {
            extps.loadURI(uri, null);
        }
        catch (e)
        {
            unimportantError(e, "Failed to open webbrowser to set Eiffel cookie during firstrun. Exception is: ");
        }
    },
    function (e)
    {
debug (e);
    }, null);
    try {
        migrate();
    }
    catch(e) { unimportantError(e, "An error occrured during Prefs migration. Exception is : "); }
    try
    {
        if (!BackgroundProcessManager.isEnabled())
            BackgroundProcessManager.enable();
    } catch(e) { unimportantError(e, "An error occured trying to enable and launch HomeRunnerLogin."); }

    return true;
}
function doUpgradeActions(curVersion, lastRun)
{
    if (versionOlderThan(lastRun, "2.4"))
    {
        var prefs = Cc["@mozilla.org/preferences-service;1"]
            .getService(CI.nsIPrefService);
        var devicePrefs = prefs.getBranch("tomtom.device.").getChildList("", {});

        var deviceIDs = {};
        for each (var entry in devicePrefs)
        {
            if (!entry.match(/^all/))
                deviceIDs[entry.split(".")[0]] = true;
        }

        for (deviceID in deviceIDs)
        {
             var firstTimeNagPrefName = "tomtom.device." + deviceID + ".doLMGFirstTimeNag";
             if (!prefService().prefHasUserValue(firstTimeNagPrefName))
                 prefService().setBoolPref(firstTimeNagPrefName, false);
        }
    }
}

function acceptEULA()
{
    var winFlags = "chrome,modal,dialog=no";
    var params = { eulaaccepted: false };
    openDialog(null, "chrome://tthome/content/ui/license/eulaWin.xul", "eulawin", winFlags, params);
    if (params.eulaaccepted == true)
    {
        return true;
    }
    gApplication.quitApplication();

    var sb = getStringBundle("chrome://tthome/locale/ui/mainwin/mainWin.properties");
    var e = new Exception(sb.GetStringFromName("EULA.decline.text"));
    e.severity = Exception.SEVERITY_IGNORE;
    throw e;
}
