/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function Login()
{
    this._observers = new Array();
    this._validators = new Array();
    this._actionQueue = new Array();
}
Login.prototype =
{
    _currentUser : null,
    _currentPassword : null,
    _currentRealname : null,
    _LM : null,
    _kLoginDomain : "http://home2.tomtom.com",
    _kPrefUsername : "tomtom.account.username",
    _observers : null,
    _validators : null,
_actionQueue : null,

    get isLoggedIn()
    {
        return this._currentUser != null;
    },
    get currentUsername()
    {
        return this._currentUser;
    },
    get currentPassword()
    {
        return this._currentPassword;
    },
    get currentRealname()
    {
        return this._currentRealname;
    },
set currentUsername(username)
    {
        if (username != null)
            assert("Cannot set username to non-null value manually, use login()");

        this._setToNull();
    },
shouldLoginDenied : false,
start : function()
    {
    },
login : function (username, password, successCallback, errorCallback)
    {
        let me = this;
let callProxy =
        {
            __proto__ : NetworkCall.prototype,
            _finishedCallback : null,
            _call : null,

            get call() this._call,
            set call(call)
            {
                this._call = call;
                this._call.setFinishedCallback(makeCallback(this, function()
                {
                    if (this._finishedCallback)
                    {
                        try {
                            this._finishedCallback(this);
                        } catch (e) { error(e); }
                    }
                    me._executeNextCall();
                }));
            },

            setFinishedCallback : function(finishedCallback)
            {
                this._finishedCallback = finishedCallback;
            },

            cancel: function(ex)
            {
                if (this.call)
                    this.call.cancel(ex);
                else
                {
                    let index = me._actionQueue.indexOf(action);
                    if (index < 0)
                        return;

                    me._actionQueue.splice(index, 1);
                    errorCallback(ex);

                    if (this._finishedCallback)
                    {
                        try {
                            this._finishedCallback(this);
                        } catch (e) { error(e); }
                    }
                }
            }
        };
let action = function()
        {
            callProxy.call = rpc.login(username, password, function()
                {
                    me._validate(username,
                                 function()
                                 {
                                    username,
                                    me._setTo(username, password);
                                    successCallback();
                                 },
                                 errorCallback);
                }, errorCallback);
        };

        this._actionQueue.push(action);

        if (this._actionQueue.length == 1)
            this._executeNextCall();

        return callProxy;
    },
_executeNextCall : function()
    {
        if (this._actionQueue.length == 0)
            return;

        this._actionQueue.shift()();
    },
logout : function ()
    {
        var me = this;

        this._actionQueue.push(function()
            {
                rpc.logout(makeCallback(me, me._setToNull), error);
            }
        );

        if (this._actionQueue.length == 1)
            this._executeNextCall();
    },
addValidator : function (validatorFunction)
    {
        this._validators.push(validatorFunction);
    },
removeValidator : function(validatorFunction)
    {
        ArrayRemoveAllMatching(this._validators, validatorFunction);
    },
tryStoredLogin : function(successCallback, noLoginCallback, errorCallback, fallbackDefault)
    {
        var user = fallbackDefault == false ? this.getDefaultUsernameForDevice(gApplication.deviceManager.activeDevice)
                                            : this.getDefaultUsername();

        var password = this.getPassword(user);
        var rememberPassword = false;

        try {
            rememberPassword = prefService().getBoolPref("tomtom.account.rememberPassword");

            if (prefService().prefHasUserValue("tomtom.account." + user + ".rememberPassword"))
                rememberPassword = prefService().getBoolPref("tomtom.account." + user + ".rememberPassword");
        } catch (e) {}
if (user && password && rememberPassword)
        {
            return this.login(user, password, successCallback, function(e)
            {
                unimportantError(e);
                if (e instanceof ServerError &&
                    e.code > 400 && e.code < 500)
                {
                    noLoginCallback();
                }
                else
                {
                    errorCallback(e);
                }
            });
        }
        else
        {
            noLoginCallback();
            return new NoOpCall();
        }
    },
getDefaultUsername : function()
    {
        var deviceUser = this.getDefaultUsernameForDevice(gApplication.deviceManager.activeDevice);
        if (deviceUser != "")
            return deviceUser;
        else
        {
            try {
                return prefService().getCharPref(this._kPrefUsername);
            } catch (e) {}
        }

        return "";
    },
getDefaultUsernameForDevice : function(dev)
    {
        if (dev)
        {
            try {
                return prefService().getCharPref("tomtom.device." + dev.id + ".username");
            } catch (e) {}
            try {
                var u = dev.userLoginName;
                if (u)
                    return u.toLowerCase();
            } catch (e) { unimportantError(e); }
        }

        return "";
    },
getPassword : function(username)
    {
        var host = {value: null};
        var user =  {value: null};
        var pwd = {value: null};

        try {
            var lm = this._getLoginManager();
            var loginInfo = this._getLoginInfo(lm, username);
            if (loginInfo)
                return loginInfo.password;
            else
                return null;
        }
        catch (e) {
            unimportantError(e);
            return null;
        }
    },
savePassword : function(username, password)
    {
        try {
            var lm = this._getLoginManager();
            this.deletePassword(username);

            var nsLoginInfo = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1",
                                            CI.nsILoginInfo,
                                            "init");

            var loginInfo = new nsLoginInfo(this._kLoginDomain, null, this._kLoginDomain,
                                username, password,
                                "", "");
            lm.addLogin(loginInfo);
        } catch (e) { unimportantError(e); }
    },
deletePassword : function(username)
    {
        try {
            var lm = this._getLoginManager();
            var loginInfo = this._getLoginInfo(lm, username);
            if (loginInfo)
                lm.removeLogin(loginInfo);
        } catch (e) { unimportantError(e); }
    },

    addObserver : function(observer)
    {
        this._observers.push(observer);
    },
    removeObserver : function(observer)
    {
        ArrayRemoveAllMatching(this._observers, observer);
    },

    _getLoginInfo : function(lm, username)
    {
        var logins = lm.findLogins({}, this._kLoginDomain, null, this._kLoginDomain);
        for (var i = 0; i < logins.length; i++)
            if (!username || logins[i].username == username)
                return logins[i];

        return null;
    },

    _setToNull : function()
    {
        if (this._currentUser == null)
            return;
        this._currentUser = null;
        this._currentPassword = null;
        this._notifyChange();
    },
    _setTo : function(username, password)
    {
        if (this._currentUser == username && this._currentPassword == password)
            return;
        this._currentUser = username;
        this._currentPassword = password;
        this._notifyChange();
    },
    _notifyChange : function()
    {
        for (var i = 0; i < this._observers.length; i++)
        {
            try {
                this._observers[i].changed();
            } catch (e) { error(e); }
        }
    },

    _getLoginManager : function()
    {
        if (this._LM == null)
        {
            if (!("@mozilla.org/login-manager;1" in Cc))
                return null;

            this._LM = Cc["@mozilla.org/login-manager;1"]
                        .getService(CI.nsILoginManager);
        }
        return this._LM;
    },

    _validate : function(validatingUsername, validationSuccessful, validationFailed)
    {
        var validatorsIter = Iterator(this._validators);

        function validateNext()
        {
            try {
                let [index, validator] = validatorsIter.next();
                validator(validatingUsername, validateNext, validationFailed)
            }
            catch (e if e instanceof StopIteration)
            {
                validationSuccessful();
            }
            catch (e)
            {
                validationFailed(e);
            }
        }

        validateNext();
    },

    __end : null
};
