/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/

function migrate()
{
    var m;
    if (gApplication.settings.isOSWindows())
        m = new MigratorWin();
    else if (gApplication.settings.isOSMacOSX())
        m = new MigratorMac();
    else
    {
return;
    }
    m.start();
}
function Migrator()
{
}
Migrator.prototype =
{
    migrateSettings : function()
    {
this.string("LoginName", "tomtom.account.username");
        this.string("CurrentLocationsGeo", "tomtom.emulator.currentGPSLocation");

        this.file("DownloadDirectory", "tomtom.localitems.download.folder", "Downloads");
        this.file("ReverseInstallsDirectory", "tomtom.localitems.fromdevice.folder", "FromDevice");
        this.file("BackupsDirectory", "tomtom.backup.folder", "Backups");
    },
    __end : null
}
function MigratorWin()
{
}
MigratorWin.prototype =
{
    registry : null,
    defaultRootDir : null,

    start : function()
    {
        this.registry = Cc["@mozilla.org/windows-registry-key;1"]
                        .createInstance(CI.nsIWindowsRegKey);
        var keyexists = false;
        try {
            this.registry.open(this.registry.ROOT_KEY_CURRENT_USER,
                               "Software\\TomTom\\HOME\\",
                               this.registry.ACCESS_READ);
            keyexists = true;
        } catch (e) {}
        if (!keyexists)
        {
return;
        }
        try {
            var directoryService = Cc["@mozilla.org/file/directory_service;1"]
                                   .getService(CI.nsIProperties);
            this.defaultRootDir = directoryService.get("Pers", CI.nsIFile);
            this.defaultRootDir.append("TomTom");
            this.defaultRootDir.append("HOME");
        } catch (e) {
            this.defaultRootDir = null;
        }

        this.migrateSettings();

        this.registry.close();
    },
    bool : function(oldprefname, mozpref)
    {
        if (!this.registry.hasValue(oldprefname))
            return;
        var val = this.registry.readIntValue(oldprefname);
        prefService().setBoolPref(mozpref, val != 0);
    },
    int : function(oldprefname, mozpref)
    {
        if (!this.registry.hasValue(oldprefname))
            return;
        var val = this.registry.readIntegerValue(oldprefname);
        prefService().setIntPref(mozpref, val);
    },
    string : function(oldprefname, mozpref)
    {
        if (!this.registry.hasValue(oldprefname))
            return;
        var val = this.registry.readStringValue(oldprefname);
        prefService().setCharPref(mozpref, val);
    },
    file : function(oldprefname, mozpref, defaultName)
    {
        var file;
        if (this.registry.hasValue(oldprefname))
        {
            var str = this.registry.readStringValue(oldprefname);
            var env = Cc["@mozilla.org/process/environment;1"].createInstance(CI.nsIEnvironment);
            str = str.replace(/%(\w+)%/g, function(match, variable)
            {
                if (env.exists(variable))
                {
                    return env.get(variable);
                }
                else
                {
                    return match;
                }
            });
            file = getFile(str);
        }
        else if (this.defaultRootDir)
        {
            file = this.defaultRootDir.clone();
            file.append(defaultName);
            if (!file.exists())
            {
                return;
            }
        }
        prefService().setComplexValue(mozpref, CI.nsILocalFile, file);
    },
    __end : null
}
extend(MigratorWin, Migrator);
function MigratorMac()
{
}
MigratorMac.prototype =
{
    properties : null,
    defaultRootDir : null,

    start : function()
    {
        var directoryService = Cc["@mozilla.org/file/directory_service;1"]
                               .getService(CI.nsIProperties);
        var usrLibDir = directoryService.get("UsrPrfs", CI.nsIFile);
        usrLibDir.append("HOME Preferences");{}
if (!usrLibDir.exists())
        {
return;
        }

        this.properties = new Map();
        var prefsBundle = getStringBundle(getIOService().newFileURI(usrLibDir).spec);
        var props = IteratorToArray(prefsBundle.getSimpleEnumeration(), CI.nsIPropertyElement);
        for (var i = 0; i < props.length; i++)
            this.properties.addValue(props[i].key, props[i].value);
        try {
            this.defaultRootDir = directoryService.get("UsrDocs", CI.nsIFile);
            this.defaultRootDir.append("TomTom");
            this.defaultRootDir.append("HOME");
        } catch (e) {
            this.defaultRootDir = null;
        }

        this.migrateSettings();
    },
    bool : function(oldprefname, mozpref)
    {
        var ucVal = this.properties.getValue(oldprefname);
        if (!ucVal)
            return;
        var val = makeSafe.bool(ucVal);
        prefService().setBoolPref(mozpref, val);
    },
    int : function(oldprefname, mozpref)
    {
        var ucVal = this.properties.getValue(oldprefname);
        if (!ucVal)
            return;
        var val = makeSafe.integer(ucVal);
        prefService().setIntPref(mozpref, val);
    },
    string : function(oldprefname, mozpref)
    {
        var ucVal = this.properties.getValue(oldprefname);
        if (!ucVal)
            return;
        var val = makeSafe.string(ucVal);
        prefService().setCharPref(mozpref, val);
    },
    file : function(oldprefname, mozpref, defaultName)
    {
        var ucVal = this.properties.getValue(oldprefname);
        if (ucVal)
        {
            var str = makeSafe.string(ucVal);{}
var file = getFile(str);
        }
        else if (this.defaultRootDir)
        {
            file = this.defaultRootDir.clone();
            file.append(defaultName);
            if (!file.exists())
            {
                return;
            }
        }
        prefService().setComplexValue(mozpref, CI.nsILocalFile, ensureDirExists(file));
    },
    __end : null
}
extend(MigratorMac, Migrator);
