/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


EXPORTED_SYMBOLS.push("ttAudioSampleMixin");
function ttAudioSampleMixin() {}

ttAudioSampleMixin.prototype =
{
    _audioSample : null,
    _audioSampleMimetype : null,

    _importFromXMLTTAudioSample : function (xml)
    {
        for each (var sample in xml.audio.(@usage == "preview"))
        {
            try {
                this._audioSampleMimetype = makeSafe.mimetype(sample.@mimetype, 6);
                this._audioSample = makeSafe.url(sample.@url, rpc.contentBaseURI());
            } catch (e) { unimportantError(e); this._audioSampleMimetype = null; }
        }
    },
    get audioSample()
    {
        return this._audioSample;
    },
    get audioSampleMimetype()
    {
        return this._audioSampleMimetype;
    },
    set audioSample(newVal)
    {
        assert(newVal instanceof CI.nsIURI || newVal == null, "AudioSample must be a nsIURI");
        this._audioSample = newVal ? makeSafe.url(newVal.spec, rpc.contentBaseURI()) : null;
        this._ensureXML();
        for each (var sample in this._xml.audio.(@usage == "preview"))
        {
            delete this._xml.children()[sample.childIndex()];
        }
        if (this._audioSample)
        {
            var xml = <audio/>;
            xml.@url = this._audioSample.spec;
            xml.@usage = "preview";
            this._xml.appendChild(xml);
        }
    },
    set audioSampleMimetype(newVal)
    {
        assert(newVal, "AudioSampleMimetype must not be null");
        this._audioSampleMimetype = makeSafe.mimetype(newVal, 6);
        this._ensureXML();
        for each (var sample in this._xml.audio.(@usage == "preview"))
        {
            sample.@mimetype = newVal;
            break;
        }
    }
};
