/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


EXPORTED_SYMBOLS.push("ttEmulator");
function ttEmulator()
{
    ttAddon.apply(this);
}
ttEmulator.prototype =
{
    _navcoreVersionFrom: null,
    _navcoreVersionTo: null,
    _navcoreBuildFrom: null,
    _navcoreBuildTo: null,
    _binaryName: null,

    _listEntry:
    {
        modelType : ttEmulator,
        xmlTag : "emulator",
        tocTag: "Emulator",
        priority : 18,
        extensionManagerType : 0x8000
    },
get navcoreVersionFrom()
    {
        return this._navcoreVersionFrom;
    },
get navcoreVersionTo()
    {
        return this._navcoreVersionTo;
    },
get navcoreBuildFrom()
    {
        return this._navcoreBuildFrom;
    },
get navcoreBuildTo()
    {
        return this._navcoreBuildTo;
    },
get binaryName()
    {
        return this._binaryName;
    },
get binaryFile()
    {
        if (!this._updateItem || !this._binaryName)
            return null;

        var extensionManager = Cc["@mozilla.org/extensions/manager;1"].getService(CI.nsIExtensionManager);
        return extensionManager.getInstallLocation(this._updateItem.id).getItemFile(this._updateItem.id, this._binaryName);
    },
importFromXML: function(xml)
    {
        ttAddon.prototype.importFromXML.apply(this, arguments);

        if ("@navcoreversionfrom" in xml)
            this._navcoreVersionFrom = makeSafe.version(xml.@navcoreversionfrom);
        if ("@navcoreversionto" in xml)
            this._navcoreVersionTo = makeSafe.version(xml.@navcoreversionto);
        if ("@navcorebuildfrom" in xml)
            this._navcoreBuildFrom = makeSafe.version(xml.@navcorebuildfrom);
        if ("@navcorebuildto" in xml)
            this._navcoreBuildTo = makeSafe.version(xml.@navcorebuildto);
    },
importFromExtensionManager: function(item)
    {
        this._updateItem = item;
        var ds = this.installManifest;
        if (ds)
        {
            var rdfService = Cc["@mozilla.org/rdf/rdf-service;1"].getService(CI.nsIRDFService);
            var ttresource = function(label)
            {
                return rdfService.GetResource("http://www.tomtom.com/2007/em-rdf#" + label);
            }

            var root = rdfService.GetResource("urn:mozilla:install-manifest");
            var emulatorInfo = ds.GetTarget(root, ttresource("emulator"), true);
            if (!emulatorInfo)
                throw new Exception("No emulator metadata found, not a valid emulator extension.");

            var getString = function(label)
            {
                var target = ds.GetTarget(emulatorInfo, ttresource(label), true);
                if (!target)
                    throw new Exception("Expected value " + label + " not found in emulator extension metadata.");

                return target.QueryInterface(CI.nsIRDFLiteral).Value;
            }

            this._navcoreVersionFrom = makeSafe.version(getString("navcoreversionfrom"));
            this._navcoreVersionTo = makeSafe.version(getString("navcoreversionto"));
            this._navcoreBuildFrom = makeSafe.version(getString("navcorebuildfrom"));
            this._navcoreBuildTo = makeSafe.version(getString("navcorebuildto"));
            this._binaryName = makeSafe.filename(getString("binary"));
        }

        ttAddon.prototype.importFromExtensionManager.apply(this, arguments);
    },
canUseWithDevice: function(device)
    {
        if ((this._navcoreVersionFrom && versionNewerThan(this._navcoreVersionFrom, device.versionNavCore)) ||
            (this._navcoreVersionTo && versionNewerThan(device.versionNavCore, this._navcoreVersionTo)) ||
            (this._navcoreBuildFrom && buildNewerThan(this._navcoreBuildFrom, device.buildNumberNavCore)) ||
            (this._navcoreBuildTo && buildNewerThan(device.buildNumberNavCore, this._navcoreBuildTo)))
        {
            return false;
        }
        return true;
    }
}
extend(ttEmulator, ttAddon);
AddSubtypeV1(ttEmulator.prototype._listEntry);
