/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


EXPORTED_SYMBOLS.push("ttFuelPrice");
function ttFuelPrice()
{
    ttNavItem.apply(this);
    ttSubscription.apply(this);
    this._availableFuelTypes = new Array();
}
ttFuelPrice.prototype =
{
_fuelType : null,
_availableFuelTypes : null,
    _listEntry :
    {
        modelType : ttFuelPrice,
        xmlTag : "fuelprice",
        tocTag : "FuelPrices",
        priority : 145,
        itemtypeEnum : CI.ttIItem.kItemFuelPrices,
        idlType : CI.ttIFuelPrices
    },

    importFromXML : function(xml)
    {
        ttNavItem.prototype.importFromXML.apply(this, arguments);
        ttSubscription.prototype.importSubscriptionFromXML.apply(this, arguments);

        for each (var type in xml.fueltype)
        {
            var fuelId = null;
            if ("@idnumeric" in type)
            {
                fuelId = type.@idnumeric;
            }
            else if ("@filename" in type)
            {
                let filename = makeSafe.filename(type.@filename);
                fuelId = /(\d+)(\.fpf)?$/.test(filename) ? RegExp.$1 : null;
            }

            if (fuelId)
            {
                let currentId = makeSafe.integer(fuelId);
                this._availableFuelTypes.push({
                    id : currentId,
                    name : makeSafe.string(type.text())
                });

                try {
                    if ("@select" in type && makeSafe.bool(type.@select) && !this._fuelType)
                        this._fuelType = currentId;
                } catch (e) {
                    unimportantError(e);
                }
            }
        }
        if (!this._fuelType && this._availableFuelTypes.length)
            this._fuelType = this._availableFuelTypes[0].id;
    },

    importFromDLL : function(item)
    {
        ttNavItem.prototype.importFromDLL.apply(this, arguments);
        item = item.QueryInterface(CI.ttIFuelPrices);

        if (item.currentFuelType && item.currentFuelType != CI.ttIFuelPrices.kInvalidFuelType)
            this._fuelType = item.currentFuelType;
    },

    createTOC : function()
    {
        var table = ttNavItem.prototype.createTOC.apply(this, arguments);
        var toc = table.elements()[0];
        toc.CurrentFuelType = this._fuelType;

        return table;
    },
get fuelType()
    {
        return this._fuelType;
    },
get availableFuelTypes()
    {
        return this._availableFuelTypes;
    },
setFuelType : function(fuelType, successCallback, errorCallback)
    {
        assert(typeof successCallback == "function", "successCallback must be a function");
        assert(typeof errorCallback == "function", "errorCallback must be a function");

        try
        {
            if (this._availableFuelTypes.length > 0)
            {
                var fuelTypeIsAvailable = false;
                for each (var availableFuelType in this._availableFuelTypes)
                {
                    if (fuelType == availableFuelType.id)
                    {
                        fuelTypeIsAvailable = true;
                        break;
                    }
                }
                if (!fuelTypeIsAvailable)
                {
                    errorCallback(new Exception("Selected type is not an available fuel type"));
                    return;
                }
            }

            if (this.locationType == 1 || this.locationType == 2)
            {
                var me = this;
                var fuelTypeProgressListener = new ProgressListener(function() {},
                                                                    function() {
                                                                        me._fuelType = fuelType;
                                                                        successCallback();
                                                                    }, errorCallback);
                this._dll.QueryInterface(CI.ttIFuelPrices).setCurrentFuelType(fuelType, fuelTypeProgressListener);
            }
            else
            {
                this._fuelType = fuelType;
                successCallback();
            }
        } catch (e) {
            errorCallback(e);
        }
    }
}
extend(ttFuelPrice, ttNavItem);
extendMixIn(ttFuelPrice, ttSubscription);
AddSubtypeV1(ttFuelPrice.prototype._listEntry);
