/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


EXPORTED_SYMBOLS.push("ttMap");
function ttMap()
{
    ttNavItem.apply(this);
}
ttMap.prototype =
{
_buildNumber: null,
_regions: null,
_baseMap : null,

    _listEntry :
    {
        modelType : ttMap,
        xmlTag : "map",
        tocTag: "Map",
        priority : 160,
        itemtypeEnum : CI.ttIItem.kItemMap,
        idlType : CI.ttIMap
    },

    get significantIDs()
    {
        let result = ttNavItem.prototype.__lookupGetter__("significantIDs").apply(this);
        if (this._baseMap)
            result.push("_basemap/" + this._baseMap);
        else
            result.push("_basemap/" + this._idstr);
        return result;
    },

    get version()
    {
        var result = ttNavItem.prototype.__lookupGetter__("version").call(this);
        if (this._buildNumber)
        {
            result += "." + this._buildNumber;
        }
        return result;
    },
    set version(val)
    {
        return ttNavItem.prototype.__lookupSetter__("version").call(this, val);
    },

    get basemap()
    {
        return this._baseMap;
    },

    createTOC : function()
    {
        var table = ttNavItem.prototype.createTOC.apply(this, arguments);
        var toc = table.elements()[0];

        if (this.basemap)
            toc.@basemap = this.basemap;

        return table;
    },

    importFromXML : function(xml)
    {
        ttNavItem.prototype.importFromXML.apply(this, arguments);
        if ("build" in xml)
        {
            this._buildNumber = makeSafe.integer(xml.build);
        }
        if ("regions" in xml)
        {
            this._regions = [];
            for each (let region in xml.regions.region)
            {
                let regionItem = new ttRegion();
                regionItem.importFromXML(region);
                this._regions.push(regionItem);
            }
        }
        if ("@basemap" in xml)
            this._baseMap = makeSafe.contentidstr(xml.@basemap);
    },

    importFromDLL : function(item)
    {
        ttNavItem.prototype.importFromDLL.apply(this, arguments);
        this._dll = this._dll.QueryInterface(CI.ttIMap);
        if (this._dll.buildNumber)
            this._buildNumber = makeSafe.integer(this._dll.buildNumber);
        else{}
if (this.locationType == 3 && !this._hasHOME2Metadata)
        {
            this._drm = true;
            this._drmScheme = "activation-code";
            this._drmNeedsKey = true;
        }
    },
createCopyWithActivationCode : function(activationCode)
    {
        assert(this._drm && this._drmScheme == "activation-code" && this._drmNeedsKey, "item missing activation code expected");

        return this._createModifiedItem(function(item) {
            item.drmActivationCode = activationCode;
            item.drmNeedsKey = false;
            item.drmDeviceCode = gApplication.deviceManager.activeDevice.deviceCode;
        });
    },

  __end : null
}
extend(ttMap, ttNavItem);
AddSubtypeV1(ttMap.prototype._listEntry);
