/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


EXPORTED_SYMBOLS.push("ttTheme");
function ttTheme()
{
    ttAddon.apply(this);
}
ttTheme.prototype =
{
    _listEntry:
    {
        modelType : ttTheme,
        xmlTag : "theme",
        tocTag: "Theme",
        priority : 19,
        extensionManagerType : CI.nsIUpdateItem.TYPE_THEME
    },

    get enabled()
    {
        var selectedTheme = prefService().getCharPref("general.skins.selectedSkin");
        var extensionManager = Cc["@mozilla.org/extensions/manager;1"].getService(CI.nsIExtensionManager);
        var ds = extensionManager.datasource;
        try
        {
            var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"]
                .getService(Components.interfaces.nsIRDFService);
            var source = rdfService.GetResource("urn:mozilla:item:" + this._idstr);
            var link = rdfService.GetResource("http://www.mozilla.org/2004/em-rdf#internalName");
            var myInternalName = ds.GetTarget(source, link, true).QueryInterface(CI.nsIRDFLiteral).Value;
            return (myInternalName == selectedTheme);
        }
        catch(e)
        {
            unimportantError(e);
            return false;
        }
    },
setEnabled : function(enable)
    {
        if (this.enabled == enable)
            return;

        assert(enable, "Cannot disable an active theme, select another theme instead");

        ttAddon.prototype.setEnabled.apply(this, arguments);

        prefService().setCharPref("extensions.lastSelectedSkin", ttTheme.getInternalNameForIdstr(this._idstr));
        prefService().setBoolPref("extensions.dss.switchPending", true);
    }
}

ttTheme.getInternalNameForIdstr = function(idstr)
{
    var ds = Cc["@mozilla.org/extensions/manager;1"].getService(CI.nsIExtensionManager).datasource;
    var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"]
        .getService(Components.interfaces.nsIRDFService);

    return ds.GetTarget(rdfService.GetResource("urn:mozilla:item:" + idstr),
                        rdfService.GetResource("http://www.mozilla.org/2004/em-rdf#internalName"),
                        true).QueryInterface(CI.nsIRDFLiteral).Value;
}

ttTheme.getDefaultSkin = function()
{
    return Cc["@mozilla.org/preferences-service;1"]
                .getService(CI.nsIPrefService)
                .getDefaultBranch("").getCharPref("general.skins.selectedSkin");
}

ttTheme.restoreCustomTheme = function()
{
    if (prefService().prefHasUserValue("tomtom.app.customSkin"))
    {
        var extensionManager = Cc["@mozilla.org/extensions/manager;1"].getService(CI.nsIExtensionManager);
        var previousTheme = extensionManager.getItemForID(prefService().getCharPref("tomtom.app.customSkin"));
        if (previousTheme)
        {
            var theme = new ttTheme();
            theme.importFromExtensionManager(previousTheme);
            if (!theme.enabled)
            {
                theme.setEnabled(true);
                return true;
            }
            else
                return false;
        }
        else
            prefService().clearUserPref("tomtom.app.customSkin");
    }
    return ttTheme.restoreDefaultTheme();
}

ttTheme.restoreDefaultTheme = function()
{
    var defaultPref = ttTheme.getDefaultSkin();
    if (prefService().getCharPref("general.skins.selectedSkin") != defaultPref)
    {
        prefService().setCharPref("extensions.lastSelectedSkin", defaultPref);
        prefService().setBoolPref("extensions.dss.switchPending", true);
        return true;
    }
    if (prefService().getBoolPref("extensions.dss.switchPending"))
    {
        prefService().clearUserPref("extensions.dss.switchPending");
        prefService().clearUserPref("extensions.lastSelectedSkin");
    }
    return false;
}

extend(ttTheme, ttAddon);
AddSubtypeV1(ttTheme.prototype._listEntry);
