/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/

EXPORTED_SYMBOLS.push("ttDependencyTreeBuilder");
function ttDependencyTreeBuilder()
{
    ttItemListFilter.apply(this);
}
ttDependencyTreeBuilder.prototype =
{
    checkItem: function(item)
    {
        item.subitems.splice(0);

        for each (let existingItem in this.itemlist.contents)
        {
            if (existingItem.dependencies.length > 0 && existingItem.dependencies.some(function(dep) dep.matches(item)))
                item.subitems.push(existingItem);
            if (item.dependencies.length > 0 && item.dependencies.some(function(dep) dep.matches(existingItem)))
            {
                existingItem.subitems.push(item);
                this.itemlist.updateItem(existingItem);
            }
        }
        return [item];
    },

    resetItem: function(item)
    {
        for each (let existingItem in this.itemlist.contents)
        {
            let index = existingItem.subitems.indexOf(item);
            if (index >= 0)
                existingItem.subitems.splice(index, 1);
        }
    }
}
extend(ttDependencyTreeBuilder, ttItemListFilter);
