/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function ttItemFactory()
{
}
ttItemFactory.prototype =
{
createItemFromServer : function(xml)
  {
    var listEntry = this.findSubtype("xmlTag", xml.localName());
    if (!listEntry)
    {
}
    var result = listEntry ? new listEntry.modelType() : new ttItem();
    try {
        result.importFromServer(xml);
    } catch (e if e instanceof Exception) {
        let newId = e.id;
        newId += (newId.indexOf("#") >= 0 ? "," : "#") + "createItemFromServer";
        let wrapper = new Exception(null, newId);
        wrapper.debugInfo = "XML source = " + xml.toXMLString();
        wrapper.inner = e;
        throw wrapper;
    }
    return result;
  },
createItemFromDLL : function(item, _onlyType)
  {
    assert(item instanceof CI.ttIItem, "need ttIItem");
    var listEntry = this.findSubtype("itemtypeEnum", item.itemType);
    if (_onlyType && (!listEntry || listEntry.xmlTag != _onlyType))
        return null;
    var result = listEntry ? new listEntry.modelType() : new ttNavItem();
    try {
        result.importFromDLL(item);
    } catch (e if e instanceof Exception) {
        let newId = e.id;
        newId += (newId.indexOf("#") >= 0 ? "," : "#") + "createItemFromDLL";
        let wrapper = new Exception(null, newId);
        wrapper.debugInfo = "Malformed Item info:\n name = " + item.name + "\n id = "
                            + item.id + "\n version = " + item.version +"\n "
                            + "locationType = " + item.locationType + "\n ";

        if (item.installLocation)
            wrapper.debugInfo += "install location physicalType = " + item.installLocation.physicalType + "\n ";

        try {
            wrapper.debugInfo += "metadata =\n" + item.QueryInterface(CI.ttINavItem).metadata;
        } catch (e1) {
            let wrapper1 = new Exception("Item metadata could not be retrieved. Throwing exception without it.");
            wrapper1.inner = e1;
            unimportantError(wrapper1);
        }
        wrapper.inner = e;
        throw wrapper;
    }
    return result;
  },
createItemListFromServer : function(xml)
  {
    var result = new Array();
    var errorShown = false;
    for each (var content in xml.contentlist.elements())
    {
        try {
            result.push(this.createItemFromServer(content));
        } catch (e) {
            if (!errorShown)
            {
                errorShown = true;
                error(e);
            }
        }
    }
    return result;
  },
createItemListFromDLL : function(items, onlyType)
  {
    assert(items instanceof CI.ttIItemList, "need ttIItemList");
    var result = new Array();
    var errorShown = false;
    for (var i = items.iterator; i.hasMoreElements(); )
    {
        try {
            var dllitem = i.getNext().QueryInterface(CI.ttIItem);
            var modelitem = this.createItemFromDLL(dllitem, onlyType);
            if (!modelitem)
                continue;
            result.push(modelitem);
        } catch (e) {
            if (!errorShown)
            {
                errorShown = true;
                error(e);
            }
        }
    }
    return result;
  },
  findSubtype : function(propertyName, valueMatch)
  {
    for (var i = 0; i < gItemSubtypes.length; i++)
      if (gItemSubtypes[i][propertyName] == valueMatch)
        return gItemSubtypes[i];
    return null;
  },
  __end : null
}
function AddSubtypeV1(obj)
{
  try {
  obj.xmlTag = makeSafe.alphanum(obj.xmlTag);
  obj.tocTag = makeSafe.alphanum(obj.tocTag);
  if ("itemtypeEnum" in obj)
  {
      obj.itemtypeEnum = makeSafe.rangeInt(obj.itemtypeEnum,
            CI.ttIItem.kItem_BASE,
            CI.ttIItem.kItem_CEIL + 500);
  }
  var entry =
  {
    modelType : obj.modelType,
    xmlTag : obj.xmlTag,
    tocTag : obj.tocTag,
    itemtypeEnum : obj.itemtypeEnum,
    idlType : obj.idlType
  }
  gItemSubtypes.push(entry);
  } catch (e) { error(e); }
}
var gItemSubtypes = new Array();
