/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function TripUpload()
{
}
TripUpload.prototype =
{
    start : function()
    {
        gApplication.deviceManager.addObserver(this);
        if (gApplication.deviceManager.activeDevice)
        {
            this.checkSetting();
            this.tripUpload();
        }
    },
changed : function(deviceChanged, installLocationChanged)
    {
        if (!deviceChanged)
            return;
        if (!gApplication.deviceManager.activeDevice)
            return;
        this.checkSetting();
        this.tripUpload();
    },
checkSetting : function()
    {
        try {
var dev = gApplication.deviceManager.activeDevice;

            if (!dev.hasCapability("Caymann"))
            {
return;
            }
            if (dev.tripRecordingPref == CI.ttIDevice.kTripRecordingPrefEnabled)
            {
return;
            }
            var alreadyAsked = false;
            try {
                alreadyAsked = prefService().getBoolPref("tomtom.tripUpload.didAskInHOME");
            } catch (e) { unimportantError(e); }
            if (alreadyAsked && dev.tripRecordingPref != CI.ttIDevice.kTripRecordingPrefUnknown)
            {
return;
            }
            var now = new Date().getTime() / 1000;
            var firstconnect = now;{}
try {
                firstconnect = prefService().getIntPref("tomtom.tripUpload.firstConnect");
            }
            catch (e)
            {
                prefService().setIntPref("tomtom.tripUpload.firstConnect", now);
            }
if (now - firstconnect < 14*24*60*60)
            {
return;
            }
            runAsync(function() {
                var args = {result: 1};
                openDialog(null, "chrome://tthome/content/ui/dialogs/device/deviceTripUpload.xul",
                                  "deviceTripUpload",
                                  "chrome,centerscreen,resizable=no,modal",
                                  args);
                var response = args.result;{}
dev.tripRecordingPref =
                        response == 0
                        ? CI.ttIDevice.kTripRecordingPrefEnabled
                        : CI.ttIDevice.kTripRecordingPrefDisabled;
    
                prefService().setBoolPref("tomtom.tripUpload.didAskInHOME", true);
            });
        } catch (e) { unimportantError(e) }
    },
tripUpload : function()
    {
        try {
var dev = gApplication.deviceManager.activeDevice;
            if (dev.tripRecordingPref != CI.ttIDevice.kTripRecordingPrefEnabled)
            {
return;
            }

            var tripRecordingUpload = dev.tripRecordingUpload;
            if (!tripRecordingUpload || !tripRecordingUpload.dataAvailable)
            {
return;
            }

            rpc.init(function()
            {
                var serverURL = rpc.serviceBaseURL("tripRecording");{}
tripRecordingUpload.readData(new ProgressListener(
                    function() {},
                    function()
                    {
                        var uploadItems = [];
                        var dataIter = tripRecordingUpload.data;
                        while (dataIter.hasMoreElements())
                            uploadItems.push(dataIter.getNext().QueryInterface(CI.nsISupportsString).data);

                        var uploadsOk = 0, uploadsFail = 0, uploadsTotal = uploadItems.length;
                        function onDoneUploading()
                        {
                            if (uploadsFail == 0)
                            {
                                tripRecordingUpload.cleanupData();
                            }
                        }

                        for each (var uploadItem in uploadItems)
                        {
                            fetchHTTP.fetch(
                                serverURL.spec, null, true, uploadItem,
                                function()
                                {
                                    uploadsOk++;
                                    if (uploadsOk + uploadsFail == uploadsTotal)
                                        onDoneUploading();
                                },
                                function(e)
                                {
                                    unimportantError(e);

                                    uploadsFail++;
                                    if (uploadsOk + uploadsFail == uploadsTotal)
                                        onDoneUploading();
                                }
                            )
                        }
                    },
                    function(e) {
                        unimportantError(e);
                    }));
            },
            function(e)
            {
unimportantError(e);
            });
        } catch (e) { unimportantError(e) }
    },
    __end : null
}
