/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function ttDialog(aWizardFooterElementID)
{
    this._wizfooterID = aWizardFooterElementID;

    this._isWindow = (window == top);
    window.addEventListener("DOMContentLoaded", makeCallback(this, function() {
        if (this._isWindow)
        {
            document.documentElement.className += " windowDialog";
        }
        else
        {
            document.documentElement.className += " layerDialog";
        }
    }), false);
    window.gMainWindow = ("gMainWindow" in top ? top.gMainWindow : gApplication.getSomeMainWindow());

    window.addEventListener("load", makeCallback(this, this._onLoad), false);
    window.addEventListener("unload", makeCallback(this, this._onUnLoad), false);
}
ttDialog.prototype =
{
    _isWindow : true,
    _loadCallback : true,
    _params : true,
    _closeHasAlreadyBeenCalled : false,
    _wizfooterID : null,
    _combinedCall : null,
    _loaded : false,
    abortingCalls : false,
setupPage : function(params, loadCallback)
    {
        assert( ! this._isWindow, "There's window.opener, but setupPage() is called");
        assert( ! this._loaded, "setupPage() needs to be called before _onLoad(). Check load handler firing order.");

        this._params = params;
        this._loadCallback = loadCallback;
    },
_onLoad : function()
    {
        try {
            this._loaded = true;

            var params = null;
            var loadCallback = null;
            if (this._isWindow)
            {
                params = window.arguments[0];
                assert(window.arguments[1].value == null, "need result object from Dialogs::openDialogAsWindow()");
                var handle = window.arguments[2];
                assert(handle && handle._window == null, "need handle object from Dialogs::openDialogAsWindow()");
                handle._window = window;
                loadCallback = window.arguments[3];
            }
            else
            {
                params = this._params;
                loadCallback = this._loadCallback;
            }
this.onLoad(params);
            if (loadCallback)
                loadCallback(window);
        } catch (e) {
            error(e);
        }
    },
onLoad : function(params) {},
close : function(result)
    {
        try {
            assert(!this._closeHasAlreadyBeenCalled, "dialog.close() called twice", "TTDialog/MultipleClose");
            this._closeHasAlreadyBeenCalled = true;{}
if (this._wizfooterID)
            {
                var wizfooter = E(this._wizfooterID);
                wizfooter.getRightButton().disabled = true;
                wizfooter.getMiddleButton().disabled = true;
                wizfooter.getLeftButton().disabled = true;
            }

            this.abortCalls();

            if (this._isWindow)
            {
                window.arguments[1].value = result;
                window.close();
            }
            else
            {
                gMainWindow.dialogs._closeDialogAsPage(window, result);
            }
        } catch (e) {
            error(e);
        }
    },
_onUnLoad : function()
    {
        if (this._closeHasAlreadyBeenCalled)
            return;
        this.cancel();
    },

    get closed()
    {
        return this._closeHasAlreadyBeenCalled;
    },
cancel : function()
    {
this.close(null);
    },

    networkCall: function(aCall)
    {
        if (!this._combinedCall)
        {
            var wizfooter = (this._wizfooterID ? E(this._wizfooterID) : null);
            assert(wizfooter, "need wizard footer to allow aborting network call");

            this._combinedCall = new CombinedCall();
            wizfooter.setupCombinedCall(this._combinedCall,
                makeCallback(this, this._finishedCombinedCall));
        }

        this._combinedCall.addCall(aCall);

        return aCall;
    },

    _finishedCombinedCall: function()
    {
        this._combinedCall = null;
    },

    abortCalls : function()
    {
        this.abortingCalls = true;
        if (this._combinedCall)
        {
            this._combinedCall.cancel();{}
}
    },
get openerWindow()
    {
        if (this._isWindow)
            return window.opener;
        else
            return top;
    },

    __end : null
};
function ttDialogWithoutOnLoad(aWizardFooterElementID)
{
    ttDialog.call(this, aWizardFooterElementID);
}
ttDialogWithoutOnLoad.prototype =
{
    onLoad : function(params)
    {
    },
    __end : null
};
extend(ttDialogWithoutOnLoad, ttDialog);
