/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function URLHandler()
{
}
URLHandler.prototype =
{
    start : function ()
    {
    },
openURI : function (ucURI)
    {
        function parseURI(uri)
        {
            var parsed = {
                scheme : null,
                subscheme : null,
                content : null,
                query : { __proto__: null }
            };
var re = /^(tomtomhome):([A-Z][A-Z0-9+\-.]*)?:?((?:[\w!$&'()*+,;=\-.~\/:]|%[A-F0-9]{2})*)?(\?(?:[\w!$&'()*+,;=\-.~\/\?:]|%[A-F0-9]{2})*)?$/i;

            var matches = uri.replace(/^vnd-tomtom-([^:]+)/, "tomtomhome:$1")
                             .replace(/^tomtomhome:(address|geo):(?!\?)/, "$&?")
                             .match(re);

            if (matches != null)
            {
                parsed.scheme = makeSafe.string(matches[1]);
                parsed.subscheme = matches[2] ? makeSafe.string(matches[2]) : null;
                parsed.content = matches[3] ? makeSafe.string(matches[3]) : null;

                var ucSearch = matches[4];

                if (ucSearch != undefined)
                {
                    re = /[\?&]([^=]+)=([^&]*)/g;

                    var args = parsed.query, key, ucValue;

                    while ((matches = re.exec(ucSearch)))
                    {
                        key = makeSafe.string(decodeURIComponent(matches[1]));
                        ucValue = decodeURIComponent((matches[2] || ""));

                        if (!(key in args))
                            args[key] = makeSafe.string(ucValue);
                    }
                }
            }
            return parsed;
        }

        try {
var uri = makeSafe.string(ucURI);

            if (uri.match(/^tomtomhome:\/\//))
            {
                if (uri.indexOf("?") == -1)
                    this._legacy02(uri.substr(2));
                else
                    this._legacy11(uri.substr(3));
                return;
            }

            var u = parseURI(uri);

            if (u.scheme != "tomtomhome")
                throw new Exception(this._stringBundle.formatStringFromName("schemeUnknown", [u.scheme], 1))

            if (u.subscheme == "address")
                this.addressURI(u.query, false);
            else if (u.subscheme == "geo")
                this.addressURI(u.query, true);
            else if (u.subscheme == "contentitem")
                this.contentitemURI(u.content, u.query);
            else if (u.subscheme == "contentitems")
                this.contentitemsURI(u.content, u.query);
            else if (u.subscheme == "contentitems-of-type")
                this.contentitemsOfTypeURI(u.content, u.query);
            else if (u.subscheme == "task")
                this.taskURI(u);
            else if (!u.subscheme)
                ;
            else
                throw new Exception(this._stringBundle.formatStringFromName("subschemeUnknown", [u.subscheme], 1));
        } catch (e) { error(e); }
    },
addressURI : function(address, geo)
    {
        if (!address.action ||
            (address.action != "show" &&
             address.action != "navigateto" &&
             address.action != "addfavorite"))
            address.action = "ask";
        if (address.name && !address.addressname)
            address.addressname = address.name;

        if (geo)
        {
            address._geo = true;
            if (!address.long)
                throw new Exception(this._stringBundle.GetStringFromName("longitudeMissing"));
            if (!address.lat)
                throw new Exception(this._stringBundle.GetStringFromName("latitudeMissing"));
            address.long = makeSafe.floatingpoint(address.long);
            address.lat = makeSafe.floatingpoint(address.lat);
        }
var mainwin = gApplication.getSomeMainWindow();
        var curTask = mainwin.currentTask();
        if (curTask && curTask.name == "EmulatorTask")
        {
            if (curTask.emulator)
                curTask.emulator.loadAddress(address);
            else{}
}
        else
            mainwin.loadTaskByName("emulator", { address: address, eiffel: true }, null, 10);
    },
contentitemURI : function(url, query)
    {
        if (query)
            url += this._serializeQuery(query);

        var mainwin = gApplication.getSomeMainWindow();
        mainwin.loadTaskByName("urlHandlerInstall", { one: true, uri: url});
    },
contentitemsURI : function(url, query)
    {
        if (query)
            url += this._serializeQuery(query);

        var mainwin = gApplication.getSomeMainWindow();
        mainwin.loadTaskByName("urlHandlerInstall", { one: false, uri: url});
    },
contentitemsOfTypeURI : function(ucContentType, ucQuery)
    {
        var params = {};
        if (ucContentType)
            params.contentType = makeSafe.alphanum(ucContentType);
        if (ucQuery && "search" in ucQuery)
            params.searchString = makeSafe.nonemptystring(ucQuery.search);

        var type = gApplication.itemFactory.findSubtype("xmlTag", params.contentType);

        if (!type)
            throw new Exception(this._stringBundle.formatStringFromName(
                "itemtypeUnknown", [params.contentType], 1));
        try {
            getStringBundle("chrome://tthome/locale/logic/model/itemTypes.properties")
                .GetStringFromName(params.contentType);
        } catch (e) {
            throw new Exception(this._stringBundle.formatStringFromName(
                "itemtypeUnknown", [params.contentType], 1));
        }

        var mainwin = gApplication.getSomeMainWindow();
        if (type.modelType.prototype instanceof ttAddon && type.modelType != ttEmulator)
            mainwin.loadTaskByName("addons", params);
        else
            mainwin.loadTaskByName("buyAndInstall", params);
    },
taskURI : function(ucURIObj)
    {
        var taskName = makeSafe.alphanum(ucURIObj.content);
        var mainwin = gApplication.getSomeMainWindow();
        var allowedTasks = {
            update: { task: "update"},
            backup: {task: "backup"},
            activatepromotion: {task: "activatePromotionCode"},
            "createaccount": {task: "login", params: {createAccount: true}, isDialog: true}
        };

        let taskInfo = allowedTasks[taskName];

        if (!taskInfo)
            throw new Exception(this._stringBundle.formatStringFromName("taskUnknown", [taskName], 1));

        mainwin.loadTaskByName(taskInfo.task, taskInfo.params, null, 0, taskInfo.isDialog);
    },
    _legacy02 : function(uri)
    {
        throw new Exception(this._stringBundle.GetStringFromName("legacy02notSupported"));
    },
    _legacy11 : function(uri)
    {
var d = uri.indexOf("?");
        if (d < 1)
            throw new Exception(this._stringBundle.GetStringFromName("commandNotFound"));

        var command = uri.substr(0, d).toLowerCase();
        var content = uri.substr(d + 1);{}
var params = content.split("&");
        for (var i = 0; i < params.length; i++)
            params[i] = makeSafe.string(decodeURIComponent(params[i]));{}
this._legacyCommand(command, params);
    },
    _legacyCommand : function(command, params)
    {
        switch (command)
        {
            case "address":
            case "showonmap":
                this._legacyAddress("show", params);
                break;
            case "navigateto":
                this._legacyAddress("navigateto", params);
                break;
            case "addfavorite":
                this._legacyAddress("addfavorite", params);
                break;
            case "install":
            case "execute":
            case "outlookcontact":
            case "switchtab":
            case "tomtompage":
            case "tomtom":
                throw new Exception(this._stringBundle.formatStringFromName("commandNotSupported", [command], 1));
            default:
                throw new Exception(this._stringBundle.formatStringFromName("commandUnknown", [command], 1));
        }
    },
_legacyAddress : function(command, params)
    {
        if (params.length < 3)
            throw new Exception(this._stringBundle.GetStringFromName("oldURIMissingComponents"));
        var address = new Object();
        address.action = command;
        address.city = params[0];
        address.street = params[1];
        address.housenumber = params[2];
        if (params.length > 3)
            address.addressname = params[3];
        this.addressURI(address);
    },
_serializeQuery : function(query)
    {
        let queryParameters = [];
        for (let key in query)
            queryParameters.push(encodeURIComponent(key) + "=" + encodeURIComponent(query[key]));
        return "?" + queryParameters.join("&");
    },

    get _stringBundle()
    {
        return getStringBundle("chrome://tthome/locale/logic/urlHandler.properties");
    },

    __end : null
}
