/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/



function InvalidUserInput(message, badValue)
{
    BadValue.call(this, message, badValue);
    this.name = "Invalid user input";
    this.message = message;
}
InvalidUserInput.prototype =
{
    _id: "Internal/InvalidUserInput",
    severity: Exception.SEVERITY_FATAL,
    allowReportToServer: false
};
extend(InvalidUserInput, BadValue);

var gUserInputStringBundle = getStringBundle("chrome://tthome/locale/logic/userinput.properties");
function checkPasswordSyntax(aPassword)
{
    if (aPassword.length < 6)
    {
        throw new InvalidUserInput(gUserInputStringBundle.GetStringFromName("passwordSize"), "---");
    }
}
function checkNewPasswordSyntax(aPassword, aAllowPartial)
{
    var regExp = new RegExp("^[A-Za-z0-9.,?!@_/;#* -]*$", "g");
    if (!regExp.test(aPassword))
    {
        throw new InvalidUserInput(gUserInputStringBundle.GetStringFromName("newPasswordAllowedChars"), "---");
    }

    if ((!aAllowPartial && aPassword.length < 6) || aPassword.length > 12)
    {
        throw new InvalidUserInput(gUserInputStringBundle.GetStringFromName("newPasswordSize"), "---");
    }
}

function checkEmailAddressSyntax(aEmailAddress)
{
    var regExp = /^[A-Za-z0-9._-]+[@][a-zA-Z0-9._-]+[.][A-Za-z]{2,}$/;
    if (!regExp.test(aEmailAddress))
    {
        throw new InvalidUserInput(gUserInputStringBundle.GetStringFromName("invalidEmail"), aEmailAddress);
    }
}

function checkStringShortSyntax(aString)
{
    if (aString.length > 30)
    {
        throw new InvalidUserInput(gUserInputStringBundle.GetStringFromName("stringShortSize"), aString);
    }
}

function checkStringMediumSyntax(aString)
{
    if (aString.length > 60)
    {
        throw new InvalidUserInput(gUserInputStringBundle.GetStringFromName("stringMediumSize"), aString);
    }
}

function checkStringLongSyntax(aString)
{
    if (aString.length > 255)
    {
        throw new InvalidUserInput(gUserInputStringBundle.GetStringFromName("stringLongSize"), aString);
    }
}

function checkProductcodeSyntax(aProductCode)
{
    var regExp = /^\w{5}\W*\w{5}\W*\w{5}$/;
    if (!regExp.test(aProductCode))
    {
        throw new InvalidUserInput(gUserInputStringBundle.GetStringFromName("invalidProductcode"), aProductCode);
    }
}

function checkPromotionCodeSyntax(aPromotionCode)
{
    var regExp = /^[0-9A-Z]{11}$/;
    if (!regExp.test(aPromotionCode))
    {
        throw new InvalidUserInput(gUserInputStringBundle.GetStringFromName("invalidPromotionCode"), aPromotionCode);
    }
}

function checkStringNotEmpty(aString)
{
    if (aString.length < 1)
    {
        throw new InvalidUserInput(gUserInputStringBundle.GetStringFromName("stringNotEmpty"), aString);
    }
}
