/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function Commit()
{
    ttPage.apply(this, arguments);
    this.parts = new Array();
    this._stringBundle = getStringBundle("chrome://tthome/locale/ui/bindings/commit.properties");
}
Commit.prototype =
{
    _stringBundle : null,

    init : function(length)
    {
        if (gApplication.deviceManager.activeDevice)
        {
            top.gMainWindow.statusbar.deviceStateDisplay.overrideDeviceBusyStatus(true);
        }
    },
    partSetup : function(i, name)
    {
        try {
            var part = new Object();
            this.parts[i] = part;
            part.citem = document.createElement("commititem");
            E("results").appendChild(part.citem);
            part.citem.setAttribute("number", (i + 1) + ".");
            part.citem.setAttribute("name", name);
            part.citem.setAttribute("status", "notstarted");
            part.citem.setAttribute("last", "true");
            if (i > 0)
            {
                this.parts[i - 1].citem.removeAttribute("last");
            }

        } catch (e) { error(e); }
    },
    partStart : function(i)
    {
        try {
            var part = this.parts[i];
            part.citem.setAttribute("status", "inprogress");
            part.citem.setAttribute("progressmode", "undetermined");
            part.citem.setAttribute("progress", 0);
            part.citem.setAttribute("text", this._stringBundle.GetStringFromName("commit.processing"));
            var scroller = E("results").boxObject.QueryInterface(CI.nsIScrollBoxObject);
            scroller.ensureElementIsVisible(part.citem);
        } catch (e) {
            top.gMainWindow.statusbar.deviceStateDisplay.overrideDeviceBusyStatus(false);
            error(e);
        }
    },
    partProgress : function(i, percent, text)
    {
        try {
            var part = this.parts[i];
            if (percent > 0)
            {
                part.citem.setAttribute("progressmode", "determined");
                part.citem.setAttribute("progress", percent);
            }
            part.citem.setAttribute("text", text);
        } catch (e) {
            top.gMainWindow.statusbar.deviceStateDisplay.overrideDeviceBusyStatus(false);
            error(e);
        }
    },
    partDone : function(i, success, textOrException)
    {
        try {
            var part = this.parts[i];
            var text = errorToText(textOrException);
            part.citem.setAttribute("text", text);
            part.citem.setAttribute("tooltiptext", text);
            part.citem.setAttribute("status", success ? "done" : "error");
            if (!success)
            {
                error(textOrException);
            }
        } catch (e) {
            top.gMainWindow.statusbar.deviceStateDisplay.overrideDeviceBusyStatus(false);
            error(e);
        }
    },
    allDone : function(success, iFailed)
    {
        try {
            if (success)
            {
                E("allDone").hidden = false;
            }
            else
            {
                E("disturbedDownload").hidden = false;
            }

            E("disconnectWarning").hidden = true;
            this.subtitle = this._stringBundle.GetStringFromName("commit.clickDone");

            for (var i = iFailed + 1; i < this.parts.length; i++)
            {
                var part = this.parts[i];
                part.citem.setAttribute("text", this._stringBundle.GetStringFromName("commit.failed.earlier"));
                part.citem.setAttribute("status", "error");
            }
        } catch (e) {
            error(e);
        } finally {
            top.gMainWindow.statusbar.deviceStateDisplay.overrideDeviceBusyStatus(false);
        }
    },
    __end : null
}

extend(Commit, ttPage);
window.page = new Commit();
