/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function AboutConfigDialog()
{
    ttDialog.call(this, "footer");
}
AboutConfigDialog.prototype =
{
    onLoad: function(params)
    {
        init();
    },

    __end : null
}
extend(AboutConfigDialog, ttDialog);
var dialog = new AboutConfigDialog();


function init()
{
    var stringbundle = getStringBundle("chrome://tthome/locale/ui/dialogs/aboutApp/configurationDialog.properties");
    E("config.computer.user").textContent = gApplication.login.isLoggedIn
            ? gApplication.login.currentUsername
            : stringbundle.GetStringFromName("user.anonymous");
    E("config.computer.status").textContent = gApplication.login.isLoggedIn ? stringbundle.GetStringFromName("user.loggedIn") : stringbundle.GetStringFromName("user.loggedOut");
    E("config.computer.profileDir").textContent = gApplication.settings.profileDir.path;
    E("config.computer.installDir").textContent = gApplication.settings.installDir.path;
    E("config.computer.pluginsDir").textContent = gApplication.settings.pluginsDir.path;
    E("config.computer.dataDir").textContent = gApplication.settings.dataDir.path;
    E("config.home.version").textContent = gApplication.settings.version;
    E("config.home.locale").textContent = gApplication.settings.uiLocale;
    E("config.home.server").textContent = rpc.serviceBaseURL("redirect").spec;
    try
    {
        var proxyTitle;
        switch (prefService().getIntPref("network.proxy.type"))
        {
            case 1:
                var proxy = prefService().getCharPref("network.proxy.http") + ":" +
                            prefService().getIntPref("network.proxy.http_port");
                proxyTitle = stringbundle.formatStringFromName("proxyTypeManual", [proxy], 1);
                break;
            case 2:
                var url = prefService().getCharPref("network.proxy.autoconfig_url");
                proxyTitle = stringbundle.formatStringFromName("proxyTypeAuto", [url], 1);
                break;
            case 4:
                proxyTitle = stringbundle.GetStringFromName("proxyTypeWPAD");
                break;
            case 0:
            default:
                proxyTitle = stringbundle.GetStringFromName("proxyTypeDirect");
                break;
        }
        E("config.home.proxy").textContent = proxyTitle;
    } catch (e) { unimportantError(e); }

    var addons = ttExtension.prototype.importItemsFromExtensionManager()
                 .concat(ttTheme.prototype.importItemsFromExtensionManager())
                 .concat(ttEmulator.prototype.importItemsFromExtensionManager());
    if (addons.length)
    {
        var descriptions = addons.map(function(addon) { return addon.name + " " + addon.version; });
        E("config.home.addons").textContent = descriptions.join(", ");
    }

    if(gApplication.deviceManager.activeDevice)
    {
        var device = gApplication.deviceManager.activeDevice;

        function reportDeviceAccessError(e)
        {
            unimportantError(e);
            let separator = (E("config.device.installeditems").textContent.length ? ", " : "");
            E("config.device.installeditems").textContent += separator + stringbundle.GetStringFromName("deviceAccessError");
        }

        function doDeviceScan(installLocations)
        {
            if (installLocations.length == 0)
                return;

            let installLocation = installLocations[0];
            let devItems = installLocation.deviceNavItems();

            try {
                devItems.populate(new ScanListener(function(){}, function()
                    {
                        try {
                            let itemlist = gApplication.itemFactory.createItemListFromDLL(devItems);
                            let text = itemlist.map(function(elem) elem.id + " " + elem.version).join(", ");
                            let separator = (E("config.device.installeditems").textContent.length ? ", " : "");
                            E("config.device.installeditems").textContent += separator + text;
                        } catch (e) { reportDeviceAccessError(e); }

                        doDeviceScan(installLocations.slice(1));
                    },
                    reportDeviceAccessError)
                );
            } catch (e) { reportDeviceAccessError(e); }
        }

        E("config.device.name").textContent = device.model.modelName;
        E("config.device.code").textContent = device.deviceCode;
        var devCapabilities = IteratorToArray(gApplication.deviceManager.activeDevice.capabilities, CI.nsISupportsCString);
        E("config.device.capabilities").textContent = devCapabilities.join(" ");
        E("config.device.serial").textContent = device.serial;

        var installLocationInfo = "";
        var installLocs = gApplication.deviceManager.getInstallLocationsForDevice(device);

        doDeviceScan(installLocs);

        for (var i = 0; i < installLocs.length; i++)
        {
            var newLoc = document.createElement("description");
            var locString = "";
            if (i > 0)
            {
                var sep = document.createElement("description");
                sep.textContent = "|";
                E("config.device.installlocations").appendChild(sep);
            }
            locString += installLocs[i].name + " ("+installLocs[i].path.path+")";
            if (gApplication.deviceManager.activeInstallLocation == installLocs[i])
            {
                newLoc.textContent = locString + " - " + stringbundle.GetStringFromName("location.active");
                newLoc.setAttribute("class", "bold-label no-space");
            }
            else
            {
                newLoc.textContent = locString;
                newLoc.setAttribute("class", "no-space");
            }
            E("config.device.installlocations").appendChild(newLoc);
        }
    }

    E("config.errors.incidentIDs").textContent = prefService().getCharPref("tomtom.debug.error.reportedIncidents").split(",").join(", ");
    E("tech-support-data").textContent = gApplication.homeServices.techSupportData;
}

function copyToClipboard()
{
    var win = window.QueryInterface(CI.nsIDOMWindow);
    var selection = win.getSelection();
    var datarows = document.getElementsByTagName("row");
    var copyString = "";
    for (var i = 0; i < datarows.length; i++)
    {
        var even = true;
        for (var j = 0; j < datarows[i].childNodes.length; j++)
        {
            if (even)
            {
                even = false;
                selection.selectAllChildren(datarows[i].childNodes[j]);
                copyString += selection.toString() + " = ";
            }
            else
            {
                even = true;
                selection.selectAllChildren(datarows[i].childNodes[j]);
                copyString += selection.toString() + "\r\n";
            }

        }
    }
    copyString += gApplication.homeServices.techSupportData;

    putStringOnClipboard(copyString);
}
