/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function ResetPasswordDialog()
{
    ttDialog.call(this, "message-footer");

    this._mLoginStringBundle = getStringBundle("chrome://tthome/locale/ui/dialogs/login/resetPassword.properties");
}
ResetPasswordDialog.prototype =
{
    onLoad: function(params)
    {
        assert(params.username, "need username parameter");
        var username = params.username;

        E("userName").value = username;
        var subtitle = this._mLoginStringBundle.GetStringFromName("subtitleWorking");
        E("message-header").setAttribute("subtitle", subtitle);

        var me = this;
        var errorCallback = function(e)
        {
            if (me.abortingCalls)
                return;
            switch(e.code)
            {
                case 401:
                case 402:
                    me.errorResponse(me._mLoginStringBundle.formatStringFromName("error401Reset", [username], 1));
                    break;

                default:
                    error(e);
                    me.close(false);
            }
        };

        this.networkCall(rpc.call("account", "resetPassword",
                     { username: username },
                     null, RPC.METHOD_POST,
                     function(result)
        {
            var subtitle = me._mLoginStringBundle.GetStringFromName("subtitleDone");
            E("message-header").setAttribute("subtitle", subtitle);
            E("message-footer").getRightButton().removeAttribute("disabled");
            E("progressNotification").setAttribute("hidden", "true");
            E("errorNotification").setAttribute("hidden", "true");
            E("successNotification").removeAttribute("hidden");
        },
        errorCallback));
    },

    resetContinue: function()
    {
        this.close(true);
    },

    errorResponse: function(errString)
    {
        var subtitle = this._mLoginStringBundle.GetStringFromName("subtitleDone");
        E("message-header").setAttribute("subtitle", subtitle);
        E("message-footer").getRightButton().removeAttribute("disabled");
        E("progressNotification").setAttribute("hidden", "true");
        E("errorNotification").removeAttribute("hidden");
        E("errorString").textContent = errString;
    }
};
extend(ResetPasswordDialog, ttDialog);
var dialog = new ResetPasswordDialog();
