/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


var gAutostartOld = true;

var gDeviceObserver =
{
    changed : function(deviceChanged, locationChanged)
    {
        if (deviceChanged)
        {
            loadCaymanPref();
        }
    }
}
function PrefsDialog()
{
    ttDialog.call(this, "footer");
}
PrefsDialog.prototype =
{
    onLoad: function(params)
    {
        prefsLoad();
        initAutostart();
        E("listbox-language").value = gApplication.settings.uiLocale;
        E("listbox-country").value = gApplication.settings.country;{}
E("checkbox-remember").checked = prefService().getBoolPref("tomtom.account.rememberPassword");
        
        var currentUser = gApplication.login.currentUsername;
        if (currentUser &&
            prefService().prefHasUserValue("tomtom.account." + currentUser + ".rememberPassword"))
        {
            E("checkbox-remember").checked = prefService().getBoolPref("tomtom.account." + currentUser + ".rememberPassword");
        }

        loadCaymanPref();
        proxyTypeChanged();

        initFolders();

        gApplication.deviceManager.addObserver(gDeviceObserver);
    },

    saveAndClose : function ()
    {
        try {
            changedAutostart(E("checkbox-autostart").checked);
            savePrefs();
            saveFolders();
            saveCaymanPref();
            checkLogin();
            switchLocale();
            top.gMainWindow.toggleLegalText();

            this.close();
        } catch(e) {
            error(e);
        }
    },

    close : function()
    {
        gApplication.deviceManager.removeObserver(gDeviceObserver);
        ttDialog.prototype.close.apply(this, arguments);
    },

    __end : null
}
extend(PrefsDialog, ttDialog);
var dialog = new PrefsDialog();


function countryChanged()
{
    checkValidity();
}

function loadCaymanPref()
{
    var checkbox = E("checkbox-cayman");
    var dev = gApplication.deviceManager.activeDevice;
    checkbox.checked = (dev && dev.tripRecordingPref == CI.ttIDevice.kTripRecordingPrefEnabled);
    checkbox.disabled = !dev;
}

function saveCaymanPref()
{
    var checkbox = E("checkbox-cayman");
    var dev = gApplication.deviceManager.activeDevice;
if (dev && !checkbox.disabled)
    {
        dev.tripRecordingPref =
                    checkbox.checked
                    ? CI.ttIDevice.kTripRecordingPrefEnabled
                    : CI.ttIDevice.kTripRecordingPrefDisabled;
    }
}
function initAutostart()
{
    try {
        var enabled = BackgroundProcessManager.isEnabled();{}
E("checkbox-autostart").checked = enabled;
        gAutostartOld = enabled;
    }
    catch (e) {
        E("checkbox-autostart").disabled = true;
        unimportantError(e);
    }
}
function changedAutostart(checked)
{
    try {
        if (checked)
            BackgroundProcessManager.enable();
        else
            BackgroundProcessManager.disable();
    } catch (e) { unimportantError(e); }

}
function checkLogin()
{
    try {
        var checked = E("checkbox-remember").checked;
        var currentUser = gApplication.login.currentUsername;

        if (currentUser)
        {
            prefService().setBoolPref("tomtom.account." + currentUser + ".rememberPassword", checked);
            if (!checked)
                gApplication.login.deletePassword(currentUser);
        }
        prefService().setBoolPref("tomtom.account.rememberPassword", checked);
    }
    catch(e) {
        error(e);
    }
}

function switchLocale()
{
    var needRestart = false;
    var newCountry = E("listbox-country").value;
    if (gApplication.settings.country != newCountry)
    {
        gApplication.settings.country = newCountry;
        needRestart = true;
    }

    var newLocale = E("listbox-language").value;
    if (gApplication.settings.uiLocale == newLocale && !needRestart)
    {
        return;
    }
    gApplication.settings.uiLocale = newLocale;
    gApplication.settings.networkLocale = newLocale;
    needRestart = true;

    if (needRestart)
    {
        var sbs = Components.classes["@mozilla.org/intl/stringbundle;1"].
                        getService(Components.interfaces.nsIStringBundleService);
        var brandBundle = sbs.createBundle("chrome://branding/locale/brand.properties");
        var shortName = brandBundle.GetStringFromName("brandFullName");
        var titleStr = gPrefsBundle.getString("locale.prompt.title");
        var messageStr = gPrefsBundle.getFormattedString("locale.prompt.message", [shortName]);
        var ret = promptService().confirm(window, titleStr, messageStr);
        if (ret)
        {
            top.gMainWindow.interrupt(function()
            {
                gApplication.quitApplication(true, true);
            });
        }
    }
}
var gOldFolderSettings = null;
var gOldLocalNavitemsDirSettings = null;

const folderPrefs = ["tomtom.localitems.download.folder",
                     "tomtom.backup.folder",
                     "tomtom.localitems.fromdevice.folder",
                     "tomtom.localitems.sharing.folder"];

function initFolders()
{
    for (var i = 0; i < folderPrefs.length; i++)
        setPathLabel(folderPrefs[i]);
    gOldFolderSettings = getFolderSettings();
    gOldLocalNavitemsDirSettings = getLocalNavitemsDirs();
}
function saveFolders()
{
    try {
        moveToFolders();
    }
    catch(e) {
        error(e);
    }
}

function getLocalNavitemsDirs()
{
    var dirs = [];

    ["downloadCompleteItemsDir", "fromdevItemsDir", "sharingItemsDir"].forEach(function(member)
        {
            try {
                dirs.push(gApplication.settings[member]);
            } catch (e) { unimportantError(e); }
        });

    return dirs;
}

function chooseFolder(prefName)
{
    var picker = Cc["@mozilla.org/filepicker;1"]
                 .createInstance(CI.nsIFilePicker);
    var title = gPrefsBundle.getString("browsefolder.fp.title");
    picker.init(window, title, CI.nsIFilePicker.modeGetFolder);

    var folderPref = E(prefName);{}
if (folderPref.value)
    {
        picker.displayDirectory = folderPref.value;
    }
    picker.appendFilters(CI.nsIFilePicker.filterAll);
    if (picker.show() == CI.nsIFilePicker.returnOK)
    {
        var file = picker.file.QueryInterface(CI.nsILocalFile);
        if (!file.exists())
            throw new Exception("Selected location \"" + file.path + "\" must point to an existing directory.");
        if (!file.isDirectory())
            throw new Exception("Selected location \"" + file.path + "\" must be a directory.");
        folderPref.value = file;
        setPathLabel(prefName);
    }
}
function setPathLabel(prefId)
{
    var folderBox = E("box." + prefId);
    var folderPref = E(prefId);
    folderBox.setAttribute("value", prettyFolderName(folderPref.value));
}

function prettyFolderName(aFolder)
{
return aFolder ? aFolder.path : "";
}

function getFolderSettings()
{
    var folderSettings = new Array();

    for (var i = 0; i < folderPrefs.length; i++)
    {
        try
        {
            folderSettings.push(prefService().getComplexValue(folderPrefs[i], CI.nsILocalFile));
        }
        catch (e)
        {
            unimportantError(e, "Failed to retrieve pref \"" + folderPrefs[i] + "\": ");
            folderSettings.push(null);
        }
    }

    return folderSettings;
}

function moveFolder(aSourceFolder, aTargetFolder)
{
    if ((!aSourceFolder || !aTargetFolder) || (aSourceFolder.equals(aTargetFolder)))
        return;{}
if (!aSourceFolder.exists())
        throw new Exception(gPrefsBundle.getFormattedString("sourceDirNonExistent", [aSourceFolder.path]));
    if (!aSourceFolder.isDirectory())
        throw new Exception(gPrefsBundle.getFormattedString("sourceDirNotDir", [aSourceFolder.path]));

    if (!aTargetFolder.exists())
        throw new Exception(gPrefsBundle.getFormattedString("targetDirNonExistent", [aTargetFolder.path]));
    if (!aTargetFolder.isDirectory())
        throw new Exception(gPrefsBundle.getFormattedString("targetDirNotDir", [aTargetFolder.path]));

    for (let sourceChild in getFilesInDir(aSourceFolder))
    {
        if (!sourceChild.equals(aTargetFolder) && !sourceChild.contains(aTargetFolder, true))
        {
            moveFile(sourceChild, aTargetFolder, null);
        }
    }
}

function removeDirsFromLocalNavitems(aTopLevelDirs)
{
    function normalizeFile(file)
    {
        file = file.clone();
        file.normalize();
        return file;
    }
    var topLevelDirs = aTopLevelDirs.map(normalizeFile)
    var removeDirs = IteratorToArray(gApplication.homeServices.localNavItems().folders, CI.nsIFile).map(normalizeFile)
        .filter(function(file) topLevelDirs.some(function(dir) dir.contains(file, true) || dir.equals(file)))
        .forEach(function(dir) { try {gApplication.homeServices.localNavItems().removeFolder(dir);} catch (e) {unimportantError(e)}})
}

function addDirsToLocalNavitems(aTopLevelDirs)
{
    for each (let dir in aTopLevelDirs)
    {
        try {
            gApplication.homeServices.localNavItems().addFolder(dir, true, null);
        } catch (e) { unimportantError(e); }
    }
}

function moveToFolders()
{
    var moveFolders = E("check.tomtom.content.movecurrent").checked;

    var newFolderSettings = getFolderSettings();
    removeDirsFromLocalNavitems(gOldLocalNavitemsDirSettings);

    for (var i = 0; i < gOldFolderSettings.length; i++)
    {
        try
        {
            if (moveFolders)
                moveFolder(gOldFolderSettings[i], newFolderSettings[i]);
        }
        catch (e)
        {
            error(e);
        }
    }
    addDirsToLocalNavitems(getLocalNavitemsDirs());
}
function proxyTypeChanged()
{
    E("proxy").disabled = (E("proxyType").value != 1);
    E("proxyPort").disabled = (E("proxyType").value != 1);
    E("autoconfigURL").disabled = (E("proxyType").value != 2);
    E("autoconfigReload").disabled = (E("proxyType").value != 2);
    checkValidity();
}

function proxyChanged()
{
    E("network.proxy.ssl").value = E("network.proxy.http").value;
    E("network.proxy.ssl_port").value = E("network.proxy.http_port").value;
    checkValidity();
}

function reloadPAC()
{
    try {
        Cc["@mozilla.org/network/protocol-proxy-service;1"].getService(CI.nsIProtocolProxyService2).reloadPAC();
    } catch (e) {
        error(e);
    }
}

function checkValidity()
{
    var valid = true;
    if (E("listbox-country").value == "XXX")
    {
        valid = false;
    }
    if (E("proxyType").value == 1 && (!/\S/.test(E("network.proxy.http").value) || E("network.proxy.http_port").value <= 1))
    {
        valid = false;
    }
    if (E("proxyType").value == 2  && (!/\S/.test(E("network.proxy.autoconfig_url").value)))
    {
        valid = false;
    }
    toggleDoneButton(valid);
}
