/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function BannerManager()
{
    this._observers = new Array();
}

BannerManager.prototype =
{
    _bannerDataURI : null,
    _observers : null,
    _currentLogin : null,
    _currentDevice : null,
    _lastBannerFetch : 0,

    get bannerDataURI()
    {
        return this._bannerDataURI;
    },

    start : function()
    {
        gApplication.deviceManager.addObserver(this);
        gApplication.login.addObserver(this);
        window.addEventListener("unload", makeCallback(this, this.onUnload), false);
        this.fetch();
    },

    onUnload : function()
    {
        gApplication.deviceManager.removeObserver(this);
        gApplication.login.removeObserver(this);
    },
refetchIfTimedout : function()
    {
        if (Math.abs(Date.now() - this._lastBannerFetch) > 30000)
            this.fetch();
    },

    fetch : function()
    {
var login = gApplication.login;
        var previousStartupTime = gApplication.settings.previousStartupTime;
        this._currentLogin = login.currentUsername;

        var serverArgs =
        {
            username: this._currentLogin ? this._currentLogin : login.getDefaultUsername(),
            isLoggedIn: login.isLoggedIn,
            activeMap: null,
            lastStartOfHOME: previousStartupTime ? previousStartupTime.toLocaleFormat("%Y-%m-%d") : "",
            publicBeta: prefService().getBoolPref("tomtom.app.showBetaVersions")
        };

        try {
            var device = null;
            if (gApplication.deviceManager.activeDevice)
            {
                device = gApplication.deviceManager.activeDevice;
                this._currentDevice = device.serial;
            }
            else
                device = gApplication.deviceManager.lastDevice

            if (device)
            {
                serverArgs.deviceModel = device.model.id;
                serverArgs.navCoreVersion = device.versionNavCore;
                serverArgs.navCoreBuild = device.buildNumberNavCore;
                serverArgs.deviceCapabilities = gApplication.deviceManager.activeDeviceCapabilitiesString;
                serverArgs.deviceParameters = gApplication.deviceManager.activeDeviceParametersString;
                serverArgs.mapShareJoined = gApplication.deviceManager.activeDeviceMapShareJoined;
            }
        } catch (e) { unimportantError(e); }

        var retrieveBanner = rpc.call("websiteFunctions", "promotionBanner", serverArgs,
            null, RPC.METHOD_GET & ~RPC.USE_CACHE,
            makeCallback(this, function(result)
            {
                var bannerHTML = result.text();
                this._bannerDataURI = "data:text/html," + encodeURIComponent(bannerHTML);{}
this._lastBannerFetch = Date.now();
                this._notifyChange();
            }),
            unimportantError);
    },

    changed : function()
    {
        var device = gApplication.deviceManager.activeDevice;
        var user = gApplication.login.currentUsername;

        if ((user && (user != this._currentLogin)) ||
            (device && (device.serial != this._currentDevice)))
        {
            this.fetch();
        }
    },

    addObserver : function(observer)
    {
        this._observers.push(observer);
    },

    removeObserver : function(observer)
    {
        ArrayRemoveAllMatching(this._observers, observer);
    },

    _notifyChange : function()
    {
        for each (var observer in this._observers)
        {
            try {
                observer.changed(this.bannerDataURI);
            } catch (e) { unimportantError(e); }
        }
    }
}
