/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


var gMainWindow = null;

function onLoad()
{
    try {
        if (MainWindow.checkExistingWindow())
            return;
        gMainWindow = new MainWindow();
        gMainWindow.start();
    } catch (e) { error(e); }
    centerWindow();
}
function MainWindow()
{
}
MainWindow.prototype =
{
    _homePage : "chrome://tthome/content/ui/dashboard/mainDashboard.xul",
    _helpURL : "chrome://tthome/content/ui/help/help.xul",
    mainBundle : null,
    dialogs : null,
    bannerManager : null,
    _startingUp :  true,
    _delayedTask : null,
    _loginObserver : null,
    _deviceObserver : null,

    get statusbar()
    {
        return MainWindowStatusBar;
    },

    start : function()
    {
        this.dialogs = new Dialogs();
        this.mainBundle = E("mainBundle");

        try {
            gApplication.start();
        } catch (e) {
            error(e);
            gApplication.quitApplication(true, false);
            return;
        }

        try {
            gApplication.brandingManager.start()

            this.handleWindowArgs(window.arguments);

            E("login-button").init();
            this.statusbar.deviceStateDisplay.init();
            E("device-popup").addEventListener("popupshowing", makeCallback(this, this._updateDeviceUI, false, false), false);
            E("mapshare-popup").addEventListener("popupshowing", makeCallback(this, this._updateDeviceUI, false, false), false);

            this._loginObserver = new LoginObserver(this);
            gApplication.login.addObserver(this._loginObserver);
            this._deviceObserver = new DeviceObserver(this);
            gApplication.deviceManager.addObserver(this._deviceObserver);

            this._updateLoginUI();
            this._updateDeviceUI();

            this.bannerManager = new BannerManager();
            this.bannerManager.start();
        } catch (e) { error(e); }

        try {
            this.goHome();
        } catch (e) { error(e); }

        this.toggleLegalText();
        if (gApplication.settings.isOSMacOSX())
        {
            E("main-toolbox").className = "toolbox-plain";
        }
        setTimeout(function() { ApplicationUpdater.initiateUpdate(true); }, 30000);
    },
handleWindowArgs : function(arguments)
    {
        try {
            if (!arguments || arguments.length == 0 || !arguments[0])
                return;
            var ucURIToLoad = null;
            try {
                if (typeof arguments[0] == "string")
                    ucURIToLoad = arguments[0];
                else
                {
                    var cmdLine = arguments[0].QueryInterface(CI.nsICommandLine);
                    ucURIToLoad = cmdLine.handleFlagWithParam("uri", false);
                    if (!ucURIToLoad)
                        ucURIToLoad = cmdLine.handleFlagWithParam("url", false);

                    gApplication.startupURI = makeSafe.string(ucURIToLoad);
                }
            } catch(e) { unimportantError(e); }
            if (ucURIToLoad)
            {
                gApplication.urlHandler.openURI(ucURIToLoad);
            }
        } catch (e) { error(e); }
    },
_loadDelayedStartupTask : function()
    {
        var task = this._delayedTask;
        if (!task) {
            this._startingUp = false;
            return;
        }

        if (gApplication.deviceManager.activeDevice || gApplication.deviceManager.getAllDevices().length == 0)
        {
            this._delayedTask = null;
            this._startingUp = false;
            this.loadTask(task.url, task.params, task.returnUrl, task.priority, task.isDialog);
            return;
        }
        var me = this;
        var observer =
        {
            changed : function(deviceChanged, loginChanged)
            {
                if (deviceChanged)
                {
                    gApplication.deviceManager.removeObserver(observer);
                    me._delayedTask = null;
                    me._startingUp = false;
                    me.loadTask(task.url, task.params, task.returnUrl, task.priority, task.isDialog);
                }
            }
        }
        gApplication.deviceManager.addObserver(observer);
    },
ifMeetsPreconditions: function(preconditions, preconditionsMetCallback, preconditionsUnmetCallback)
    {

        function checkPreconditions()
        {
            if ("capability" in preconditions)
            {
                if (!gApplication.deviceManager.activeDevice)
                    throw new DeviceAbsentException();

                if (!deviceSupportsCapabilitySet(
                    gApplication.deviceManager.activeDevice,
                    preconditions.capability))
                    throw new UnsupportedCapabilityException();
            }
            else if ("task" in preconditions)
            {
                gApplication.assertRunnable(preconditions.task,
                                            preconditions.params);
            }
        }

        try {
            checkPreconditions();
            preconditionsMetCallback();
        } catch (e if e instanceof DeviceAbsentException) {
            this.dialogs.openDialogAsPage("chrome://tthome/content/ui/dialogs/device/deviceRequiredPage.xul",
                null,
                null,
                makeCallback(this, function(result)
                {
                    if (result)
                        this.ifMeetsPreconditions(preconditions,
                                                  preconditionsMetCallback,
                                                  preconditionsUnmetCallback);
                }),
                false, top);
        } catch (e if e instanceof TaskPreconditionsUnmetException) {
            preconditionsUnmetCallback();
        } catch (e) {
            preconditionsUnmetCallback();
            unimportantError(e);
        }
    },
loadTaskByName : function(taskname, params, returnUrl, priority, isDialog)
    {
        let url = "chrome://tthome/content/ui/task/" + taskname + "/" + taskname + ".xul";

        this.loadTask(url, params, returnUrl, priority, isDialog)
    },
loadTask : function(url, params, returnUrl, priority, isDialog)
    {
if (this._startingUp)
        {
            if (typeof(priority) == "undefined")
                priority = 0;

            if (!this._delayedTask || this._delayedTask.priority < priority)
            {
                this._delayedTask = {
                    url: url,
                    params: params,
                    returnUrl: returnUrl,
                    priority: priority,
                    isDialog: isDialog
                };
            }
            return;
        }

        let loadTask;
        if (isDialog)
            loadTask = function() this.dialogs.openDialog(
                           "chrome://tthome/content/ui/dialogs/taskDialog/taskDialog.xul", {
                               url: url,
                               taskParams: params
                           }, null, null, false, top);
        else
            loadTask = function() this._loadTask(url, params, returnUrl);

        this.ifMeetsPreconditions({task: url, params: params},
                                  makeCallback(this, loadTask),
                                  makeCallback(this, function() { this.showUnsupportedCapabilityNotice(); }));
    },

    _loadTask : function(url, params, returnUrl)
    {
        if (!returnUrl)
        {
            if (!("task" in E("main-deck").homeBrowser.contentWindow))
            {
                returnUrl = E("main-deck").homeBrowser.currentURI.spec;
            }
            else
            {
                returnUrl = this._homePage;
            }
        }

        var me = this;
        this.loadContent(url,
        function()
        {
            var task = me.currentTask();
            assert(task, "task not found", "MainWin/TaskNotFound");

            task.init(function()
            {
                me._loadContentBare(returnUrl);
            });
            task.start(params);
        },
        function()
        {
            if (me.currentTask())
                me.currentTask()._debugDestructed();
else{}
});
    },
loadContent : function (url, loadHandler, unloadHandler)
    {
        var me = this;
        this.interrupt(function()
        {
            me._loadContentBare(url, loadHandler, unloadHandler);
        });
    },
_loadContentBare : function(url, loadHandler, unloadHandler)
    {
        var deck = E("main-deck");
        deck.loadMain(url, loadHandler, unloadHandler);
    },
currentTask : function ()
    {
        var deck = E("main-deck");
        var loadedDoc = deck.homeBrowser.contentWindow;
        if (loadedDoc)
        {
            var task = loadedDoc.task;
            if (task)
            {
                return task;
            }
        }
        return null;
    },
interrupt : function (interruptCallback, reason, newTask)
    {
        if (E("main-deck").isBusy)
        {
            return false;
        }

        var task = this.currentTask();
        if (task)
        {
            return task.interrupt(interruptCallback, reason, newTask);
        }
        else
        {
            interruptCallback();
            return true;
        }
    },
toggleLegalText : function()
    {
        var country = gApplication.settings.country;
        this.statusbar.setTextVisible(country == "CA" || country == "US" || country == "MX");
    },

    goHome : function ()
    {
        var me = this;
        this._loadContentBare(this._homePage, function() {
            if (me._startingUp)
                me._loadDelayedStartupTask();
        });
    },

    goLogin : function ()
    {
        this.dialogs.openDialog(
            "chrome://tthome/content/ui/dialogs/taskDialog/taskDialog.xul", {
                url: "chrome://tthome/content/ui/task/login/login.xul",
                taskParams: { loginOptional: false }
            }, null, null, false, top);
    },

    goUseLMG : function ()
    {
        this.loadTaskByName("latestMapGuarantee");
    },

    goExtensions : function ()
    {
        this.loadTaskByName("addons", {contentType: "extension"});
    },

    goThemes : function ()
    {
        this.loadTaskByName("addons", {contentType: "theme"});
    },

    goLogout : function ()
    {
        gApplication.login.logout();
    },

    goPreferencesSettings : function()
    {
        this.dialogs.openDialog("chrome://tthome/content/ui/dialogs/preferences/preferencesSettings.xul", null, null, null, false, top);
    },

    goDeviceDisconnect : function()
    {
        var me = this;
        var doDisconnect = function()
        {
            var title = me.mainBundle.getString("disconnectTitle");
            var msg = "";
            try {
              gApplication.deviceManager._activeDevice.disconnect(false);
              msg = me.mainBundle.getString("disconnectMessage");
              setTimeout(function() {
                ttMessageService().alert(title, msg);
              }, 2000);
            }
            catch(e) {
              error(e);
            }
        };

        if (this.currentTask() && this.currentTask().currentlyNeedDevice)
        {
            this.interrupt(function()
            {
                me.goHome();
                doDisconnect();
            });
        }
        else
        {
            doDisconnect();
        }
    },

    goMapShareEnable : function()
    {
        this.dialogs.openDialog("chrome://tthome/content/ui/dialogs/NY/enable.xul", null, null, null, false, top);
    },

    goMapShareFeedbackSettings : function()
    {
        this.dialogs.openDialog("chrome://tthome/content/ui/dialogs/NY/feedback.xul", null, null, null, false, top);
    },

    goMapSharePreferences : function()
    {
        this.dialogs.openDialog("chrome://tthome/content/ui/dialogs/NY/mapsharePreferences.xul", null, null, null, false, top);
    },

    goMapShareRemove : function()
    {
        this.dialogs.openDialog("chrome://tthome/content/ui/dialogs/NY/removeCorrections.xul", null, null, null, false, top);
    },

    goAppUpdate : function()
    {
        ApplicationUpdater.initiateUpdate(false);
    },

    goHelp : function(page)
    {
        var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
        var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
        var helpWindow = windowManagerInterface.getMostRecentWindow("tthome:help");

        var context = "";
        if (page)
        {
            context = page;
        }
        if (helpWindow)
        {
            helpWindow.loadContext(context, true);
            helpWindow.focus();
        }
        else
        {
            window.openDialog(this._helpURL, "_blank", "chrome,all,dialog=no,centerscreen", context);
        }
    },

    goAbout : function()
    {
       this.dialogs.openDialogAsWindow("chrome://tthome/content/ui/dialogs/aboutApp/about.xul", null, null, null, false, top);
    },

    goConfigInfo : function()
    {
       this.dialogs.openDialogAsWindow("chrome://tthome/content/ui/dialogs/aboutApp/configurationDialog.xul", null, null, null, false, top);
    },
readDeviceManual : function()
    {
        var modelid;
        try
        {
            try {
                var devid = prefService().getCharPref("tomtom.lastConnectedDevice.id");
                modelid = prefService().getCharPref("tomtom.device." + devid + ".modelID");
            } catch (e) {
                throw "Could not find last connected device. Pref reading failed: " + e;
            }

            var main = gApplication.settings.installDir;
            main.append("manual");
            main.append("device");
            if (!main.exists())
                throw "dir manual/device/ not found";
            var dir = main.clone();
            dir.append(modelid);
            if (dir.exists())
            {
}
            else
            {
var link = main.clone();
                link.append(modelid + ".link");
                if (!link.exists())
                    throw "Neither dir nor link found";
                var contents = readFile(link);
                if (contents.length == 0)
                    throw "Link file empty. File " + link.path;
                var seriesid = contents[0].replace(/\s/g, "");{}
modelid = seriesid;
                dir = main.clone();
                dir.append(modelid);
                if (!dir.exists())
                    throw "Link file found, but not the link target directory";
            }
            var filename = modelid + "-" + gApplication.settings.uiLocale + ".pdf";
            var pdf = dir.clone();
            pdf = pdf.QueryInterface(CI.nsILocalFile);
            pdf.append(filename);
            if (!pdf.exists())
                throw "Directory found, but not PDF file for this locale. File: " + pdf.path;{}
pdf.launch();{}
} catch (e)
        {
        unimportantError(e);
        this.readDeviceManualWebsite();
        return;
        }
    },
readDeviceManualWebsite : function()
    {
        launchSystemBrowserWithStaticURL(idMapping["manuals"], null, null);
    },
goBuyAccessories : function()
    {
        launchSystemBrowserWithStaticURL(idMapping["buyaccessories"], null, null);
    },
goHelpdesk : function()
    {
        launchSystemBrowserWithStaticURL(idMapping["onlinehelp"], null, null);
    },
bringToFront : function ()
    {
var wm = Cc["@mozilla.org/appshell/window-mediator;1"]
             .getService(CI.nsIWindowMediator);
        var homeWinType = "tthome:main";
        var thisWin = wm.getMostRecentWindow(homeWinType);
        if (thisWin)
        {
            thisWin.focus();
        }
    },

    goQuitApplication : function()
    {
        return gApplication.quitApplication(false);
    },

    showUnsupportedCapabilityNotice: function() {
        var messageService = new MessageService();
        messageService.alert(this.mainBundle.getString("itemNotSupportedTitle"),
                             this.mainBundle.getString("itemNotSupported"));
    },

    _updateLoginUI : function()
    {
        try {
            var login = gApplication.login;
            if (login.isLoggedIn)
            {
                E("file-menu-login").hidden = true;
                E("file-menu-logout").hidden = false;
            }
            else
            {
                E("file-menu-login").hidden = false;
                E("file-menu-logout").hidden = true;
            }
        } catch (e) { unimportantError(e); }
    },

    _updateDeviceUI : function(deviceChanged, locationChanged)
    {
        var dev = gApplication.deviceManager.activeDevice;
        var haveDevice = dev ? true : false;
        let hasMultipleInstallLocations = gApplication.deviceManager.hasMultipleInstallLocations;
        let isDeviceSelectionPaused = gApplication.deviceManager.isDeviceSelectionPaused;

        E("Device:Disconnect").setAttribute("disabled", !haveDevice || dev.isLocked);
        E("Device:Change").setAttribute("disabled", !haveDevice || !hasMultipleInstallLocations || isDeviceSelectionPaused);

        if (!gApplication.settings.isOSMacOSX())
            E("nav-menubar-device").disabled = !haveDevice;

        E("mapshare-item").disabled = !haveDevice;
        var haveMapShare = dev && dev.mapShare;
        E("HOME:MapShareFeedback").setAttribute("disabled", !haveMapShare);
        E("HOME:MapSharePreferences").setAttribute("disabled", !haveMapShare || !dev.mapShare.mapPatchDownloadsEnabled);
        E("HOME:MapShareRemove").setAttribute("disabled", !haveMapShare);

        if (deviceChanged || locationChanged)
            this.bringToFront();
    },

    __end : null
}
MainWindow.checkExistingWindow = function()
{
    var wm = Cc["@mozilla.org/appshell/window-mediator;1"]
             .getService(CI.nsIWindowMediator);
    for (var allWindows = wm.getEnumerator("tthome:main"); allWindows.hasMoreElements(); )
    {
        var otherWin = allWindows.getNext().QueryInterface(CI.nsIDOMWindow);
        if (otherWin == window || otherWin.closed)
            continue;

        otherWin.focus();
        window.close();
        if (otherWin.gMainWindow)
            otherWin.gMainWindow.handleWindowArgs(window.arguments);
        return true;
    }
    return false;
}
function canClose()
{
    return gMainWindow.interrupt(function() {});
}

function onUnload()
{
    if (gMainWindow)
    {
        try {
            var task = gMainWindow.currentTask();
            if (task)
                task.abort();
        } catch(e) {}

        gApplication.login.removeObserver(gMainWindow._loginObserver);
        gApplication.deviceManager.removeObserver(gMainWindow._deviceObserver);
        gMainWindow.statusbar.deviceStateDisplay.teardown();
    }

    if (gApplication.settings.isOSMacOSX())
        gApplication.quitApplication(false);
}
function LoginObserver(mainwin)
{
    this.mainwin = mainwin;
}
LoginObserver.prototype =
{
    changed : function()
    {
        this.mainwin._updateLoginUI();
    }
}
function DeviceObserver(mainwin)
{
    this.mainwin = mainwin;
}
DeviceObserver.prototype =
{
    changed : function(deviceChanged, locationChanged)
    {
        this.mainwin._updateDeviceUI(deviceChanged, locationChanged);
    }
}
