/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function ActivateLocalItem()
{
    ttSubTask.apply(this, arguments);
}
ActivateLocalItem.prototype =
{
    name : "activateLocalItem",
_historyMarker : null,

    start : function()
    {
        ttSubTask.prototype.start.apply(this, arguments);
        this._task.needDevice(makeCallback(this, this.showScanPage));
    },

    showScanPage : function()
    {
        this._historyMarker = this._ttwizard.getHistoryMarker();
        this._ttwizard.loadPage(
            this._constructPageURL("scanPage"),
            null,
            makeCallback(this, this.startDeviceScan),
            null,
            function() {}
            );
    },

    startDeviceScan : function()
    {
        runAsync(makeCallback(this, function()
        {
            this._task.doDeviceScan(makeCallback(this, this.deviceScanDone), errorAbortTask);
        }));
    },

    deviceScanDone : function()
    {
        this._ttwizard.rewindHistory(this._historyMarker);

        var itemList = new ttItemList();
        itemList.addFilter(new ttDependencyTreeBuilder());
        for each (let loc in gApplication.deviceManager.getInstallLocationsForDevice())
            this._addIncompleteItems(itemList, loc.deviceNavItems());
        this._addIncompleteItems(itemList, gApplication.homeServices.localNavItems());

        if (itemList.contents.length)
            this.activatePageLoad(itemList);
        else
            this.subtaskDone(null);
    },

    activatePageLoad : function(itemList)
    {
        this._ttwizard.loadPage(
            this._constructPageURL("activateItemPage"),
            null,
            makeCallback(this, this.activatePageLoadAsync, itemList),
            null,
            makeCallback(this, this.pageDone)
            );
    },

    activatePageLoadAsync : function(itemList, page)
    {
        page.inputStart(itemList);
        page.inputDone();
    },
_addIncompleteItems : function(itemList, dllList)
    {
        var incompleteItems = [];
        var items = gApplication.itemFactory.createItemListFromDLL(dllList);
        for each (var item in items)
        {
            if (item.drm && item.drmScheme == "durham" && item.drmNeedsKey && item instanceof ttMap)
                incompleteItems.push(item);
        }
        itemList.addItemListArray(incompleteItems);
    },

    pageDone : function(result)
    {
        this.subtaskDone(result);
    },

    __end : null
}
extend(ActivateLocalItem, ttSubTask);
