/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function AddonsPage()
{
    ttPage.apply(this, arguments);
}

AddonsPage.prototype =
{
    _listbox : null,
    _sb : null,
    _result : [],
    _contentType : null,

    inputOnLoad : function(contentType)
    {
        this._contentType = contentType;

        this._sb = E("strings");

        try {
            this.title = this._sb.getString("page.content-" + contentType + ".title");
            this.subtitle = this._sb.getString("page.content-" + contentType + ".subtitle");
        } catch(e) {}

        this._listbox = E("listbox");
        this._listbox.addObserver(this);

        var catServer = {id: "server", label: this._sb.getString("category.available." + contentType + ".label"), closed: false, priority: 0};
        var catLocalEnabled = {id: "computer-enabled", label: this._sb.getString("category.installed." + contentType + ".label"), closed: false, priority: 2};
        var catLocalDisabled = {id: "computer-disabled", label: this._sb.getString("category.disabled." + contentType + ".label"), closed: false, priority: 1};
        this._listbox.itemToCategoryMapper = function(item)
        {
            if (item.isServer)
                return catServer;
            else if (item.enabled)
                return catLocalEnabled;
            else
                return catLocalDisabled;
       }
        for (var i=0,l=this._listbox.columns.length; i<l; i++)
        {
            var column = this._listbox.columns[i];
            if (column.className == "col-button")
                column.setAttribute("flex", "30");
        }
    },

    inputStart : function(itemlist)
    {
        this._listbox.addItemList(itemlist);
    },

    addedListItem : function(listitem)
    {
        var model = listitem.modelitem;

        var me = this;

        if (model instanceof ttTheme && !model.enabled && model.isLocal)
        {
            var activateButton = listitem.addAuxiliaryButton(me._sb.getString("activateButton"), function(listitem)
            {
                me._result.push(["activate", model]);
                me.continue();
            });

            if (!model.isCompatible)
                activateButton.disabled = true;
        }

        if (model instanceof ttExtension && model.isLocal)
        {
            var enableAction = (model.enabled ? "disable" : "enable");
            var stringID = (model.enabled ? "disableButton" : "enableButton");
            listitem.addAuxiliaryButton(this._sb.getString(stringID), function(listitem)
            {
                me._result.push([enableAction, model]);
                me.continue();
            });
        }

        var installAction = null;
        if (model.isServer)
            installAction = "install";
        else if (model instanceof ttTheme && model.enabled)
            ;
        else if (model.canWriteToLocation() && !model.locked)
            installAction = "uninstall";

        if (installAction) {
            var stringID = installAction + "Button";
            var warningTitle = me._sb.getFormattedString(installAction + ".warning.title", [model.name]);
            var warningText = me._sb.getFormattedString(installAction + ".warning.text", [model.name]);
            var acceptLabel = me._sb.getString("warning.accept.label");
            var cancelLabel = me._sb.getString("warning.cancel.label");

            listitem.addButton(this._sb.getString(stringID), function(listitem)
            {
                ttMessageService().confirm(warningTitle, warningText, cancelLabel, acceptLabel, function()
                {
                    me._result.push([installAction, model]);
                    me.continue();
                }, function(){});
            });
        }
    },

    installFromLocalFile : function(file)
    {
        var modelType = gApplication.itemFactory.findSubtype("xmlTag", this._contentType).modelType;

        var model = new modelType();

        var messageService = ttMessageService(window);

        try {
            model.importFromLocalFile(file);
        } catch (e) {
            let [title, message] = [
                this._sb.getString("install.warning.title"),
                errorToText(e)
            ];

            messageService.alert(title, message);
            return;
        }

        let [title, message, acceptLabel, cancelLabel] = [
            this._sb.getString("restart.warning.title"),
            this._sb.getFormattedString("restart.warning.message", [model.name]),
            this._sb.getString("warning.accept.label"),
            this._sb.getString("warning.cancel.label")
        ];

        if (messageService.confirm(title, message , cancelLabel, acceptLabel))
        {
            this._result.push(["install", model]);
            this.continue();
        }
    },

    goUpdate : function()
    {
        this._result = [["update", null]];
        this.continue();
    },

    browseForLocalAddons : function()
    {
        var title = this._sb.getString("filepicker.content-" + this._contentType + ".title"),
            fp = Cc["@mozilla.org/filepicker;1"].createInstance( CI.nsIFilePicker );

        fp.init(window, title, CI.nsIFilePicker.modeOpen);
        var filter = (this._contentType == "theme" ? "*.jar" : "*.xpi");
        fp.appendFilter(this._sb.getString("filepicker.content-" + this._contentType + ".filter"), filter);

        if (fp.show() == CI.nsIFilePicker.returnOK )
            page.installFromLocalFile(fp.file);
    },

    result : function()
    {
        return this._result;
    }
};

extend(AddonsPage, ttPage);
window.page = new AddonsPage();
