/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function Backup()
{
    ttSubTask.apply(this, arguments);
}
Backup.prototype =
{
    name : "backup",
    _stringBundle : null,

    start : function()
    {
        ttSubTask.prototype.start.apply(this, arguments);
        this._stringBundle = getStringBundle("chrome://tthome/locale/ui/subtask/backup/backup.properties");
        this._task.needDevice(makeCallback(this, this.initiateBackupLoad));
    },

    initiateBackupLoad : function()
    {
        this._ttwizard.loadPage(
            this._constructPageURL("initiateBackup"),
            null,
            null,
            null,
            makeCallback(this, this.initiateBackupDone)
            );
    },

    initiateBackupDone : function()
    {
        var deviceid = gApplication.deviceManager.activeDevice.id;
        try
        {
            var backupFolder = gApplication.settings.backupsDir;
            var backup = getLatestBackup(true, backupFolder);
            if (!backup)
            {
                var backups = gApplication.homeServices.backups();
                backups.setFolder(backupFolder);
                backup = backups.createEmptyBackup(deviceid);
            }

            this._ttwizard.addCommit(
                makeCallback(this, this.backupCommit),
                backup,
                this._stringBundle.GetStringFromName("creating.backup"),
                this.commitPriority);
        }
        catch(e)
        {
            errorNonFatal(e);
        }
        this.subtaskDone();
    },

    backupCommit : function(backup, progressCallback, successCallback, errorCallback)
    {
        var errorStrOut = { value : null };
        var severity    = { value : null };
        backup.checkPreconditionsBackupOk(severity, { value: null }, errorStrOut);
        if (severity.value != 0 && severity.value != CI.ttIError.kSeverityWarning)
        {
            errorCallback(errorStrOut.value);
            return new NoOpAbortable();
        }

        var me = this;
        return new Abortable(backup.doBackup(new BaseListener(function(percent)
                {
                    progressCallback(percent * 0.1, me._stringBundle.GetStringFromName("scanning"));
                },
                function(errorCode) {},
                errorCallback),
            new CopyListener(function (percent, text)
                {
                    progressCallback(10 + (percent * 0.9), text)
                },
                successCallback,
                errorCallback)
        ));
    },

    __end : null
}
extend(Backup, ttSubTask);
