/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function BillingAddress()
{
    ttPage.apply(this, arguments);
}

BillingAddress.prototype = 
{
    _validFields : [],
    _loadFinished : false,

    inputOnLoad : function(args)
    {
        var firstname = E("firstname");
        var lastname = E("lastname");
        var gender = E("gender");
        var street = E("street");
        var zipCode = E("zipCode");
        var city = E("city");
        var state = E("state");
        var stateMandatory = E("state-mandatory");
        var country = E("country");

        this._validFields[firstname.id] = false;
        this._validFields[lastname.id] = false;
        this._validFields[street.id] = false;
        this._validFields[zipCode.id] = false;
        this._validFields[city.id] = false;
        this._validFields[state.id] = false;
        this._validFields[country.id] = false;

        if (args.firstname != "")
        {
            firstname.value = args.firstname;
            this._validFields[firstname.id] = true;
        }

        if (args.lastname != "")
        {
            lastname.value = args.lastname;
            this._validFields[lastname.id] = true;
        }

        if (args.gender != "")
        {
            gender.value = args.gender;
        }

        if (args.street != "")
        {
            street.value = args.street;
            this._validFields[street.id] = true;
        }

        if (args.zipCode != "")
        {
            zipCode.value = args.zipCode;
            this._validFields[zipCode.id] = true;
        }

        if (args.city != "")
        {
            city.value = args.city;
            this._validFields[city.id] = true;
        }

        if (args.state != "")
        {
            state.value = args.state;
        }
        this._validFields[state.id] = (args.state != "" || args.country != "US");

        if (args.country != "")
        {
            country.value = args.country;
            this._validFields[country.id] = true;
            if (country.value == "US")
            {
                state.removeAttribute("disabled");
                stateMandatory.hidden = false;
            }
        }

        this._loadFinished = true;

        this.taskCanContinue();
    },
    
    result : function()
    {
        return {
                firstname : E("firstname").value,
                lastname : E("lastname").value,
                gender : E("gender").value, 
                street : E("street").value,
                zipCode : E("zipCode").value,
                city : E("city").value,
                state : E("state").value == "XXX" ? "" : E("state").value,
                country : E("country").value
                };
    },
    checkStringMediumNotEmpty : function(aTextbox)
    {
        try
        {
            checkStringNotEmpty(aTextbox.value);
            checkStringMediumSyntax(aTextbox.value);
        }
        catch (e){
            this._markInvalid(aTextbox, errorToText(e));
            return;
        }
        this._markValid(aTextbox);
    },

    checkStringLongNotEmpty : function(aTextbox)
    {
        try
        {
            checkStringNotEmpty(aTextbox.value);
            checkStringLongSyntax(aTextbox.value);
        }
        catch (e){
            this._markInvalid(aTextbox, errorToText(e));
            return;
        }
        this._markValid(aTextbox);
    },

    checkStringShortNotEmpty : function(aTextbox)
    {
        try
        {
            checkStringNotEmpty(aTextbox.value);
            checkStringShortSyntax(aTextbox.value);
        }
        catch (e){
            this._markInvalid(aTextbox, errorToText(e));
            return;
        }
        this._markValid(aTextbox);
    },

    validateState : function(aTTListBox)
    {
        if (E("country").value != "US" || (aTTListBox.value && aTTListBox.value != "XXX"))
            this._markValid(aTTListBox);
        else
            this._markInvalid(aTTListBox);
    },

    validateCountry : function(aTTListBox)
    {
        var state = E("state");
        var stateMandatory = E("state-mandatory");
        if (aTTListBox.value == "US")
        {
            state.removeAttribute("disabled");
            stateMandatory.hidden = false;
this.validateState(state);
        }
        else
        {
            state.value = "XXX";
            state.setAttribute("disabled", "true");
            stateMandatory.hidden = true;
            this._markValid(state);
        }
        if (aTTListBox.value != "XXX")
        {
            this._markValid(aTTListBox);
            return;
        }
        this._markInvalid(aTTListBox);
    },

    taskCanContinue : function()
    {
        var allValid = true;

        for each (var valid in this._validFields)
        {
            if (!valid)
                allValid = false;
        }

        this.allowContinue(allValid);
    },

    _markInvalid: function(node, msg)
    {
        if (!this._loadFinished)
            return;

        this._validFields[node.id] = false;
        if (msg)
        {
            node.parentNode.lastChild.value = msg;
        }
        node.parentNode.setAttribute("invalid" , "true");
        this.taskCanContinue();
    },

    _markValid : function(node)
    {
        if (!this._loadFinished)
            return;

        this._validFields[node.id] = true;
        node.parentNode.removeAttribute("invalid");
        this.taskCanContinue();
    },

    __end : null

}
extend(BillingAddress, ttPage);
window.page = new BillingAddress();
