/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function Emulator()
{
    ttSubTask.apply(this, arguments);
}

Emulator.prototype =
{
    name : "emulator",
    _args : null,
    _emulator : null,
    _processingAddress : false,

    start : function(args)
    {
        ttSubTask.prototype.start.apply(this, arguments);
        this._args = args;
        this._task.needDevice(makeCallback(this, this.emulatorLoad));
    },

    emulatorLoad : function ()
    {
        this._ttwizard.loadPage(
            this._constructPageURL("emulatorPage"),
            this,
            null,
            null,
            makeCallback(this, this.emulatorDone)
            );
    },

    emulatorLoaded : function(emulator)
    {
this._emulator = emulator;

        if (!this._args)
            return;
        if (this._args.address)
            this.loadAddress(this._args.address);
    },
    
    stopProcessingAddress : function()
    {
        this._processingAddress = false;
    },

    loadAddress : function(address)
    {
        assert(address, "no address given");

        if (this._processingAddress)
        {
return;
        }

        if (!this._args)
        {
            this._args = {};
        }
        this._args.address = address;
        if (!this._emulator)
        {
            this._args.address = address;
            return;
        }
        this.doLoadAddress(address);
    },
    
    makesafeAddress : function(address)
    {
        for each (var field in ["city", "street", "housenumber", "postcode", "country"])
            if (!address[field])
                address[field] = "";
    },

    convertCountry : function(country, state)
    {
        if (country)
        {
            try {
                var sbC = getStringBundle("chrome://tthome/content/ui/subtask/emulator/2to3LetterCountryCode.properties");
                country = sbC.GetStringFromName(country);
            } catch (e) { unimportantError(e); }
        }
        country = country.toUpperCase();
        if ((country == "USA") && state)
            country = state;
        return country;
    },

    decorateCity : function(city, country, state)
    {
        
        country = country.toUpperCase();
        if (((country == "US") || (country == "CA")) && state) {
            var alternativeName = "";
            var index = city.lastIndexOf("(");
            if (index >= 0) {
                alternativeName = city.substr(index);
                city = city.substr(0, index).trimRight();
            }
            var stateSuffix = " " + state.toUpperCase();
            index = city.toUpperCase().lastIndexOf(stateSuffix);
            if ((index < 0) ||
                (index + stateSuffix.length < city.length)) {
                city += stateSuffix;
            }
            if (alternativeName) {
                city += " " + alternativeName;
            }
        }
        return city;
    },

    doLoadAddress : function(address, geocodedAddress)
    {
        assert(address, "no address given");

        this._processingAddress = true;

        if (!address._geo)
        {
            if (typeof geocodedAddress == "undefined")
            {
                if (!this._args)
                {
                    this._args = {};
                }
                this.makesafeAddress(address);
                this._args.address = address;
                var country = this.convertCountry(address.country, address.state);
                var city = this.decorateCity(address.city, address.country, address.state);
                this._emulator.geocode_address(city, address.street, address.housenumber, address.postcode, country);
                return;
            }
            else
            {
                var city = this.decorateCity(address.city, address.country, address.state);
                if ((city.toLowerCase() != geocodedAddress.city.toLowerCase()) ||
                    (address.street.toLowerCase() != geocodedAddress.street.toLowerCase()) ||
                    (address.housenumber.toLowerCase() != geocodedAddress.housenumber.toLowerCase()) ||
                    (address.postcode.toLowerCase() != geocodedAddress.postcode.toLowerCase()))
                {
                    var me = this;
                    this._task.trackDialog(top.gMainWindow.dialogs.openDialogAsPage(
                        "chrome://tthome/content/ui/subtask/emulator/addressURL/addressSelect.xul",
                        { requestedAddress : address, suggestedAddress : geocodedAddress },
                        null,
                        function(result)
                        {
if (!result)
                            {
                                me._processingAddress = false;
                                me.emulatorDone();
                                return;
                            }
                            result.action = "ask";
                            me.doLoadAddress(result, result.manualEntry ? undefined : result);
                        }));
                    return;
                }
            }
        }
        var action = address.action.toLowerCase();
        this._ttwizard.getTTPage().setAddress(address);

        if (action == "ask")
        {
            var params = null;
            if (address._geo)
                params = { geo : address };
            else
                params = { address : address };
            var me = this;
            this._task.trackDialog(top.gMainWindow.dialogs.openDialogAsPage(
                "chrome://tthome/content/ui/subtask/emulator/addressURL/addressAskAction.xul",
                params,
                null,
                function(result)
                {
if (!result)
                    {
                        me._processingAddress = false;
                        me.emulatorDone();
                        return;
                    }
                    var b = result;
                    if (b == 1)
                        address.action = "show";
                    else if (b == 2)
                        address.action = "navigateto";
                    else if (b == 3)
                        address.action = "addfavorite";
                    else
                        throw new NotReached(b);
                    me.doLoadAddress(address, geocodedAddress);
                }));
            return;
        }
        this._processingAddress = false;

        if (address._geo)
        {
            var longitude = (address.long * 100000).toFixed();
            var latitude = (address.lat * 100000).toFixed();

            if (action == "show")
                this._emulator.show_address_on_map_geo(longitude, latitude);
            else if (action == "navigateto")
            {
                if (!address.addressname)
                    address.addressname = "";
                this._emulator.navigate_to_address_geo(longitude, latitude, address.addressname);
            }
            else if (action == "addfavorite")
            {
                if (!address.addressname)
                {
address.action = "ask";
                    this.doLoadAddress(address, geocodedAddress);
                    return;
                }
                this._emulator.add_favorite_geo(address.addressname, longitude, latitude);
            }
            else
                throw new NotReached();
        }
        else
        {
            this.makesafeAddress(address);
            var country = this.convertCountry(address.country, address.state);
            var city = this.decorateCity(address.city, address.country, address.state);
            if (action == "show")
                this._emulator.show_address_on_map(
                        city, address.street, address.housenumber,
                        address.postcode, country);
            else if (action == "navigateto")
                this._emulator.navigate_to_address(
                        city, address.street, address.housenumber,
                        address.postcode, country);
            else if (action == "addfavorite")
            {
                if (!address.addressname)
                    address.addressname = address.street;
                this._emulator.add_favorite(
                        address.addressname, city, address.street, address.housenumber,
                        address.postcode, country);
            }
            else
                throw new NotReached();
        }
    },

    emulatorDone : function ()
    {
        this.subtaskDone();
    },

    __end : null
}
extend(Emulator, ttSubTask);
