/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


var currentAddress;
function EmulatorPage()
{
    ttPage.apply(this, arguments);
    currentAddress = null;
}
EmulatorPage.prototype =
{
    _subtask: null,
    _sb: null,
    _lockedDevice: null,
    emulator: null,
    emulatorTag: null,
inputOnLoad: function(subtask)
    {
        try
        {
            this._subtask = subtask;

            this._sb = E("stringbundle");
            var deviceModel = gApplication.deviceManager.activeDevice.model;
            var width = deviceModel.screenWidth;
            var height = deviceModel.screenHeight;

            E("emulator-box").setAttribute("aspect", width + "x" + height);

            this.emulatorTag = document.createElementNS("http://www.w3.org/1999/xhtml", "embed");
            this.emulatorTag.setAttribute("type", "application/x-tomtom-emulator-plugin");
            this.emulatorTag.setAttribute("width", width);
            this.emulatorTag.setAttribute("height", height);
            E("emulator-container").appendChild(this.emulatorTag);
            let hideCallback = makeCallback(this, function()
            {
                this.emulatorTag.setAttribute("height", 0);
                this.emulatorTag.setAttribute("width", 0);
                this.emulatorTag.setAttribute("hidden", "true");
            });
            let showCallback = makeCallback(this, function()
            {
                this.emulatorTag.setAttribute("height", height);
                this.emulatorTag.setAttribute("width", width);
                this.emulatorTag.setAttribute("hidden", "false");
            });
            window.parent.addEventListener("layerHide", hideCallback, false);
            window.parent.addEventListener("layerShow", showCallback, false);
            window.addEventListener("unload", function()
            {
                window.parent.removeEventListener("layerHide", hideCallback, false);
                window.parent.removeEventListener("layerShow", hideCallback, false);
            }, false);
            this.title = this._sb.getString("message.defaultPageTitle");

            this.findNewestEmulator();
        }
        catch (e)
        {
            this.handleError(e);
        }
    },
findNewestEmulator: function()
    {
        this.emulator = null;
        var items = ttEmulator.prototype.importItemsFromExtensionManager();
        for (var i = 0; i < items.length; i++)
        {
            if (!this.isCompatibleEmulator(items[i]))
                continue;

            if (!this.emulator || versionNewerThan(items[i].version, this.emulator.version))
            {
                this.emulator = items[i];
            }
        }
var device = gApplication.deviceManager.activeDevice;
        this.networkCall(rpc.call("shop", "getShopContent",
            {
                deviceModel: device.model.id,
                deviceNavcoreVersion : device.versionNavCore,
                deviceNavcoreBuild : device.buildNumberNavCore,
                operatingSystem : gApplication.settings.operatingSystemServerName,
                clientVersion : gApplication.settings.version,
                contentType : "emulator",
                publicBeta : prefService().getBoolPref("tomtom.app.showBetaVersions")
            }, null, RPC.METHOD_GET,
            makeCallback(this, this.processServerResult), makeCallback(this, this.handleError))
        );
    },
processServerResult: function(result)
    {
        try
        {
            assert(result, "server result is empty");

            var items = gApplication.itemFactory.createItemListFromServer(result);
            items.sort(function(item1, item2)
            {
                return (versionNewerThan(item1.version, item2.version) ? -1 : 1);
            });{}
var downloadItem = (items.length ? items[0] : null);

            if (downloadItem)
            {
                try
                {
                    var extensionManager = Cc["@mozilla.org/extensions/manager;1"].getService(CI.nsIExtensionManager);
                    var updateItem = extensionManager.getItemForID(downloadItem.idstr);
                    if (updateItem && updateItem.version == downloadItem.version)
                    {
                        downloadItem.updateLocalMetadata();

                        var localItem = new ttEmulator();
                        localItem.importFromExtensionManager(updateItem);
                        if (this.isCompatibleEmulator(localItem) &&
                            (!this.emulator || !versionNewerThan(this.emulator.version, localItem.version)))
                        {
                            this.emulator = localItem;
                        }
                    }
                } catch (e) { unimportantError(e); }
            }

            if (downloadItem && (!this.emulator || versionNewerThan(downloadItem.version, this.emulator.version)))
            {
                var me = this;

                var messageService = new MessageService();
                var message = this.emulator ? "message.update" : "message.download";
                messageService.confirm(this._sb.getString(message + "Title"), this._sb.getString(message + "Confirmation"),
                                        this._sb.getString("button.no"), this._sb.getString("button.yes"),
                                        function() { me.downloadEmulator(downloadItem); },
                                        function()
                                        {
                                            if (me.emulator)
                                                me.initEmulator();
                                            else
                                                parent.task.abort();
                                        });
            }
            else
            {
                if (this.emulator)
                    this.initEmulator();
                else
                    errorAbortTask(new InformativeException(this._sb.getString("message.noEmulatorAvailable.prompt")));
            }
        }
        catch (e)
        {
            this.handleError(e);
        }
    },
downloadEmulator: function(item)
    {
        this.title = this._sb.getString("message.downloadingTitle");
        this.subtitle = this._sb.getString("message.downloadingSubTitle");
        E("download-info").hidden = false;

        this.showContinueButton(false);

        this.networkCall(item.download(
            makeCallback(this, this.onDownloadProgress),
            makeCallback(this, this.onDownloadComplete),
            makeCallback(this, this.handleError)
        ));
    },

    onDownloadProgress: function(aPercentageCompleted, aEstimatedTimeOfArrival)
    {
        E("download-progress").mode = "determined";
        E("download-progress").value = aPercentageCompleted;
    },

    onDownloadComplete: function(item)
    {
        E("download-info").hidden = true;

        if (this.isCompatibleEmulator(item))
        {
            this.emulator = item;
            this.initEmulator();
        }
        else
        {
            this.handleError(this._sb.getString("message.invalidEmulatorDownloaded"));
        }
    },
initEmulator: function(error)
    {
        if (!this.lockDevice())
        {
            errorAbortTask(this._sb.getString("message.lockAccessProblem"))
            return;
        }

        try
        {
            this.title = this._sb.getString("message.defaultPageTitle");
            this.subtitle = this._sb.getString("message.defaultPageSubTitle");
            this.showContinueButton(true);

            var dev = gApplication.deviceManager.activeDevice;
            if (dev.hasCapability("NotAutomotiveEmbedded"))
            {
                E("emulator-buttons").removeAttribute("invisible");
            }

            var binary = this.emulator.binaryFile;
            this.emulatorTag.set_emulator_path(binary.parent.path);

            var resources = gApplication.settings.installDir;
            for each (var subdir in ["xul", "plugins", "emulator", "resources"])
                resources.append(subdir);
            this.emulatorTag.show_splash(resources.path);
            var installLocations = gApplication.deviceManager.getInstallLocationsForDevice();
            var dataFolder = installLocations.map(
                function (aInstallLocation)
                {
                    return aInstallLocation.path.path;
                }
            ).join('*');

            this.emulatorTag.startup_navigator(dev.serial,
                                            binary.leafName,
                                            dev.model.modelIDNavCore.toString(),
                                            dev.parameter("CharacterSet"),
                                            dataFolder);
            try {
                this._subtask.emulatorLoaded(this.emulatorTag);
            } catch (e) { errorNonFatal(e); }
        }
        catch (e)
        {
            errorAbortTask(e);
        }
    },
handleError: function(error)
    {
        if (this.emulator)
        {
            unimportantError(error);
            E("download-info").hidden = true;
            this.initEmulator();
        }
        else
        {
            errorAbortTask(error);
        }
    },
isCompatibleEmulator: function(item)
    {
        try
        {
            return item.canUseWithDevice(gApplication.deviceManager.activeDevice) && item.binaryFile.exists();
        }
        catch (e)
        {
            unimportantError(e);
            return false;
        }
    },
showContinueButton : function (bool)
    {
        this._wizard().allowContinue(bool);
    },
lockDevice : function ()
    {
        if (gApplication.deviceManager.activeDevice == this._lockedDevice)
        {
            return true;
        }
var result = gApplication.deviceManager.activeDevice.tryLock();
        if (result)
        {
this._lockedDevice = gApplication.deviceManager.activeDevice;
            window.addEventListener("unload", makeCallback(this, this.unlockDevice), false);
        }
        return result;
    },
unlockDevice : function ()
    {
        if (!this._lockedDevice)
        {
            return;
        }

        try {
            this.emulatorTag.shutdown_navigator();
        }
        catch(e) {
            unimportantError(e, "Emulator, error shutting down navigator: ");
        }
try {
            this._lockedDevice.releaseLock();
            this._lockedDevice = null;{}
}
        catch (e) {
            unimportantError(e, "Emulator, error unlocking device: ");
        }
    },

    setAddress : function (address)
    {
        if (address)
            currentAddress = address.city + ", " + address.street + " " + address.housenumber + ".";
    },

    resetCurrentLocation : function ()
    {
this.emulatorTag.reset_current_location();
    },

    handlePluginError : function (errorCode)
    {
        var messageService = new MessageService();
        if (errorCode == 0)
        {
            messageService.alert(this._sb.getString("message.coordNotReachableTitle"), this._sb.getString("message.coordNotReachableDescr"));
        }
        else if (errorCode == 1)
        {
            var address = this._subtask._args.address;
            if (address)
            {
                var addressStr = address.city + ", " + address.street + " " + address.housenumber + ".";
                messageService.alert(this._sb.getString("message.locationNotReachableTitle"), this._sb.getFormattedString("message.locationNotReachableLongDescr", [addressStr]));
            }
            else
                messageService.alert(this._sb.getString("message.locationNotReachableTitle"), this._sb.getString("message.locationNotReachableDescr"));{}
}
        else
            messageService.alert(this._sb.getString("message.unknownPluginErrorTitle"), this._sb.getFormattedString("message.unknownPluginErrorDescr", [errorCode]));
        this._subtask.stopProcessingAddress();
    },

    handleGeocodedAddress : function (aCity, aStreet, aCountry)
    {
try {
            var address = this._subtask._args.address;
            var geocodedAddress = { city: aCity, street: aStreet };
            if (aCountry)
            {
                try
                {
                    var sbC = getStringBundle("chrome://tthome/content/ui/subtask/emulator/2to3LetterCountryCode.properties");
                    var countryCodes = sbC.getSimpleEnumeration();
                    while (countryCodes.hasMoreElements())
                    {
                        var elem = countryCodes.getNext().QueryInterface(CI.nsIPropertyElement);
                        if (elem.value == aCountry)
                        {
                            geocodedAddress.country = elem.key;
                            break;
                        }
                    }
                } catch (e) { unimportantError(e); }
            }
            for (var key in address)
                if (!(key in geocodedAddress))
                    geocodedAddress[key] = address[key];

            this._subtask.doLoadAddress(address, geocodedAddress);
        } catch (e) { errorNonFatal(e); }
    }
}
extend(EmulatorPage, ttPage);
window.page = new EmulatorPage();
function plugin_error(errorCode)
{
    page.handlePluginError(errorCode);
}
function plugin_geocoded_address(aCity, aStreet, aCountry)
{
    page.handleGeocodedAddress(aCity, aStreet, aCountry);
}