/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


const kFreeSpaceBuffer = 262144;
function InstallSelectSome()
{
    ttSubTask.apply(this, arguments);
    this._stringBundle = getStringBundle("chrome://tthome/locale/ui/subtask/installSelectSome/installSelectSome.properties");
}
InstallSelectSome.prototype =
{
    name : "installSelectSome",
    _result : null,
    _stringBundle : null,
    _additionalSizeRequirements : null,
    _ignoreSize: false,
    _items : null,
_devItems : null,
_removableItems : null,
_installTargets : null,
_origLocationChangeMethod : null,
_observedDevice : null,
_restarting : false,
_itemsToDownload : null,
_unusedItemsToRemove : null,

    start : function(args)
    {
        ttSubTask.prototype.start.apply(this, arguments);

        if (args.items.length == 0)
        {
            this.subtaskDone([]);
            return;
        }

        this._items = args.items;
        this._additionalSizeRequirements = ("additionalSizeRequirements" in args ? args.additionalSizeRequirements : null);
        this._ignoreSize = ("ignoreSize" in args ? args.ignoreSize : false);

        var hasNavItems = args.items.some(function(item) { return (item instanceof ttNavItem); });
        if (hasNavItems)
        {
            this._task.needDevice(makeCallback(this, function()
            {
                this.registerLocationObserver();
                window.addEventListener("unload", makeCallback(this, this.unregisterLocationObserver), false);
                this._ttwizard.registerReversibleAction(makeCallback(this, this.unregisterLocationObserver));

                if (args.confirmSelection)
                {
                    this.selectInstallLoad(args.hideInstallLater);
                }
                else
                {
                    this.doDeviceScan(makeCallback(this, this.selectInstallDone, args.items));
                }
            }));
        }
        else
        {
            if (args.confirmSelection)
                this.selectInstallLoad(args.hideInstallLater);
            else
                this.doDeviceScan(makeCallback(this, this.selectInstallDone, args.items));
        }
    },
doDeviceScan: function(successCallback)
    {
        this._devItems = new ttItemList();
        this._task.addCleanupHandler(makeCallback(this, function() {
                this._devItems.destructor();
            }));

        this._devItems.addFilter(new ttDependencyTreeBuilder());
        this._task.doDeviceScan(makeCallback(this, function()
            {
               this._restarting = false;

                successCallback();
            }), errorAbortTask, this._devItems);
    },

    selectInstallLoad : function(hideInstallLater)
    {
        this._ttwizard.loadPage(
            this._constructPageURL("selectInstall"),
            { hideInstallLater: hideInstallLater },
            makeCallback(this, this.selectInstallAsyncLoad),
            null,
            makeCallback(this, this.selectInstallDone)
            );
    },

    selectInstallAsyncLoad : function(page)
    {
        this.doDeviceScan(makeCallback(this, function()
        {
            try {
                var itemList = new ttItemList();
                this._task.addCleanupHandler(function() {
                        itemList.destructor();
                    });
                itemList.addFilter(new ttDuplicateFilter());
                itemList.addFilter(new InstallSelectSomeFilter(this._devItems.contents));

                itemList.addFilter(new ttDependencyTreeBuilder());
                page.inputStart(itemList);

                itemList.addItemListArray(this._items);
            } catch (e) { errorAbortTask(e); }

            page.inputDone();
        }));
    },

    selectInstallDone : function(result)
    {
        var haveInstalls = false;
        var haveAddons = false;
        var haveNavcore = false;
        this._itemsToDownload = [];

        for (var i = 0; i < result.length; i++)
        {
            var item = result[i];
            if (item.hasNoDownload)
                continue;

            if (item instanceof ttNavItem)
                haveInstalls = true;
            else if (item instanceof ttAddon)
                haveAddons = true;
            if (item instanceof ttProgram)
                haveNavcore = true;
            if (!item.isLocal)
                this._itemsToDownload.push(item);
        }
        if (haveAddons)
        {
            this._ttwizard.addCommit(
                ttAddon.restartCommitFunction,
                null,
                getStringBundle("chrome://tthome/locale/logic/model/ttAddon.properties").GetStringFromName("commit.restart.label"),
                this.commitPriority);
        }
        if (haveNavcore)
        {
            this._task.addCleanupHandler(function(task, success, result)
            {
                if (success)
                {
                    runAsync(function()
                    {
                        top.gMainWindow.dialogs.openDialog(
                            "chrome://tthome/content/ui/dialogs/device/deviceLogicalDisconnectDialog.xul");
                    });
                }
            });
        }

        if (haveInstalls)
            this.checkSize(result);
        else
            this.subtaskDone(result);
    },
    checkSize : function(installItems)
    {
        this._result = installItems;

        let navItems = installItems.filter(function(item) item instanceof ttNavItem);

        this._removableItems = new ttItemList();
        this._task.addCleanupHandler(makeCallback(this, function() {
                this._removableItems.destructor();
            }));
        this._removableItems.addFilter(new SelectRemoveFilter(navItems));
        this._removableItems.addItemList(this._devItems);

        let installLocations = {__proto__: null};
        let installLocationsSizeInTotal = 0;

        for each (let installLocation in gApplication.deviceManager.getInstallLocationsForDevice())
        {
            installLocations[installLocation.path.path] = installLocation;
            installLocationsSizeInTotal += installLocation.sizeInTotal;
        }

        let willFit =  ttNavItem.willItemsFit(
            navItems,
            null,
            this._devItems.contents,
            this._additionalSizeRequirements,
            kFreeSpaceBuffer);

        if (willFit)
            this.selectCopyDone([]);
        else
        {
            let devItemsMap = {__proto__: null};
            for each(let item in this._devItems.contents)
                for each (let id in item.significantIDs)
                    devItemsMap[id] = true;

            let newItems = navItems.filter(function(item) !item.significantIDs.some(function(id) id in devItemsMap));
            let itemsWithoutFlavours = navItems.filter(function(item) !((item instanceof ttMap) && item.basemap));

            let isPocketPC = this._observedDevice.model.familyName == "PocketPC";
            let hasNewItem = newItems.length > 0;
            let hasOnlyFlavourableMaps = itemsWithoutFlavours.length == 0;

            let  shouldSuggestSDCard = this._observedDevice.hasEmptySDCardSlot && hasNewItem && !isPocketPC;

            let willPotentiallyFit = this._ignoreSize || hasOnlyFlavourableMaps ||
                ttNavItem.willItemsFit(
                    itemsWithoutFlavours,
                    this._removableItems.contents,
                    this._devItems.contents,
                    this._additionalSizeRequirements,
                    kFreeSpaceBuffer);

            if (willPotentiallyFit)
            {
                if (shouldSuggestSDCard)
                    this.suggestSDCard(true, navItems);
                else
                    this.smartRemoval(navItems);
            }
            else
            {
                if (shouldSuggestSDCard)
                    this.suggestSDCard(false, navItems);
                else
                {
                    let hasMultipleLocations = gApplication.deviceManager.getInstallLocationsForDevice().length > 1;
                    let message = this._stringBundle.GetStringFromName("notEnoughTotalSpace."+
                                                                       (hasMultipleLocations ? "multiple" : "single")+
                                                                       "Location.message");
                    this._task.abort();
                    ttMessageService().alert(
                        this._stringBundle.GetStringFromName("notEnoughTotalSpace.title"),
                        message);
                }
            }
        }
    },

    suggestSDCard: function(canSkip, items)
    {
        this._ttwizard.loadPage(
            this._constructPageURL("connectSDCard"),
            {canSkip : canSkip},
            makeCallback(this, this.connectSDCardAsync),
            makeCallback(this, this.connectSDCardCheck),
            makeCallback(this, this.connectSDCardDone, items)
        );
    },

    connectSDCardAsync: function(page)
    {
        this.unregisterLocationObserver(true);

        if (this._ttwizard.getHistoryMarker() != this._subtaskStartMarker)
            this._ttwizard.registerReversibleAction(makeCallback(this, this.registerLocationObserver));

        gApplication.deviceManager.pauseDeviceSelection();
        let resumeDevice = function() gApplication.deviceManager.resumeDeviceSelection();

        this._task.addCleanupHandler(resumeDevice);
        this._ttwizard.registerReversibleAction(resumeDevice);

        page.inputStart();
        page.inputDone();
    },

    connectSDCardCheck: function(result, successCallback, errorCallback, returnCallback)
    {
        if (result == "abortConditional")
            ttMessageService().confirm(
                this._stringBundle.GetStringFromName("cancel.installation.title"),
                this._stringBundle.GetStringFromName("cancel.installation.message"),
                null, null,
                successCallback,
                returnCallback);
        else
            successCallback();
    },

    connectSDCardDone: function(items, result)
    {
        gApplication.deviceManager.resumeDeviceSelection();

        if (result == "abortConditional")
        {
            this._task.abort();
        }
        else
        {
            this.registerLocationObserver();
            this.smartRemoval(items);
        }
    },

    smartRemoval : function(navItems)
    {
        let installingMaps = navItems.some(function(item) item instanceof ttMap);
        let smartItemsList = new ttItemList();
        this._task.addCleanupHandler(function() {
                smartItemsList.destructor();
            });
        smartItemsList.addFilter(new SmartRemovalFilter(navItems, this._devItems, installingMaps));
        smartItemsList.addItemList(this._devItems);

        let willItemsFit = ttNavItem.willItemsFit(navItems, smartItemsList.contents, this._devItems.contents,
                            this._additionalSizeRequirements, kFreeSpaceBuffer);
        if (willItemsFit)
        {
            this._ttwizard.loadPage(
                this._constructPageURL("smartRemoval"),
                {
                    list : smartItemsList,
                    installedItems : navItems,
                    additionalSizeRequirements : this._additionalSizeRequirements,
                    devItems : this._devItems,
                    freeSpaceBuffer : kFreeSpaceBuffer
                },
                makeCallback(this, this.smartRemovalAsyncLoad),
                makeCallback(this, this.smartRemovalCheck, navItems),
                makeCallback(this, this.smartRemovalDone, navItems)
            );
        }
        else
            this.mapFlavoursSubtaskLoad(navItems);
    },

    smartRemovalAsyncLoad : function(page)
    {
        page.inputStart();
        page.inputDone();
    },

    smartRemovalCheck : function(navItems, items, successCallback, errorCallback, returnCallback)
    {
        this._unusedItemsToRemove = items;

        if (ttNavItem.willItemsFit(navItems, items, this._devItems.contents,
                this._additionalSizeRequirements, kFreeSpaceBuffer))
        {
            this.confirmDeleteMsg(items, navItems, successCallback, returnCallback);
        }
        else
        {
            successCallback();
        }
    },

    smartRemovalDone : function(navItems, items)
    {
        let willItemsFit = ttNavItem.willItemsFit(navItems, items, this._devItems.contents,
                            this._additionalSizeRequirements, kFreeSpaceBuffer);

        if (willItemsFit)
        {
            this._ttwizard.addCommit(
                makeCallback(this, this.removeDeviceCommit),
                items,
                this._stringBundle.GetStringFromName("remove.commit.name"),
                this.commitPriority + 0.1);

            this.selectCopyLoad(items);
        }
        else
        {
            this.mapFlavoursSubtaskLoad(navItems);
        }
    },

    mapFlavoursSubtaskLoad : function(navItems)
    {
        let flavourableMap = null;

        for each(let navItem in navItems)
        {
            if (navItem instanceof ttMap &&
                navItem.basemap &&
                navItem.basemap == navItem.idstr)
            {
                flavourableMap = navItem;
                break;
            }
        }

        if (flavourableMap)
        {
            this.loadSubTask(new MapFlavours(), {
                    item: flavourableMap,
                    insideInstallFlow: true,
                    installedItems: navItems,
                    devItems: this._devItems,
                    additionalSizeRequirements: this._additionalSizeRequirements,
                    freeSpaceBuffer: kFreeSpaceBuffer
                }, makeCallback(this, function(flavouredMap) {
                       this.mapFlavoursSubtaskDone(flavouredMap, flavourableMap.idstr, navItems);
                }));
        }
        else
            this.selectRemoveLoad(navItems);
    },

    mapFlavoursSubtaskDone : function(flavouredMap, originalMapId, navItems)
    {
        assert(flavouredMap instanceof ttMap, "Flavoured map must be an instance of ttMap.");

        if (flavouredMap.idstr == originalMapId)
            this.selectRemoveLoad(navItems);
        else
        {
            let replaceMap = function(item) { return item.idstr == originalMapId ? flavouredMap : item; };
            navItems = navItems.map(replaceMap);
            this._result = this._result.map(replaceMap);
            this._itemsToDownload = this._itemsToDownload.map(replaceMap);

            let willItemsFit = ttNavItem.willItemsFit(navItems, null, this._devItems.contents,
                               this._additionalSizeRequirements, kFreeSpaceBuffer);

            if (willItemsFit)
                this.selectCopyDone([]);
            else
                this.selectRemoveLoad(navItems);
        }
    },

    selectRemoveLoad : function(installedItems)
    {
        this._ttwizard.loadPage(
            this._constructPageURL("selectRemove"),
            {
                preSelectedItems : this._unusedItemsToRemove,
                installedItems : installedItems,
                additionalSizeRequirements : this._additionalSizeRequirements,
                devItems : this._devItems,
                freeSpaceBuffer : kFreeSpaceBuffer
            },
            makeCallback(this, this.selectRemoveLoadAsync),
            makeCallback(this, this.selectRemoveCheck, installedItems),
            makeCallback(this, this.selectRemoveDone)
            );
    },

    selectRemoveLoadAsync : function(page)
    {
        page.inputStart(this._removableItems);
        page.inputDone();
    },

    selectRemoveCheck : function(installedItems, items, successCallback, errorCallback, returnCallback)
    {
        this.confirmDeleteMsg(items, installedItems, successCallback, returnCallback);
    },

    selectRemoveDone : function(items)
    {
        this._ttwizard.addCommit(
            makeCallback(this, this.removeDeviceCommit),
            items,
            this._stringBundle.GetStringFromName("remove.commit.name"),
            this.commitPriority + 0.1);

        this.selectCopyLoad(items);
    },

    confirmDeleteMsg : function(items, installedItems, successCallback, returnCallback)
    {
        let devContents = this._devItems.contents;
        let criticalMessages = [];

        if (!installedItems.some(function(el) el instanceof ttMap))
        {
            let mapsToDelete = (items.filter(function (el) el instanceof ttMap)).length;
            let mapsOnDevice = (devContents.filter(function (el) el instanceof ttMap)).length;
            if (mapsToDelete >= mapsOnDevice)
                criticalMessages.push(this._stringBundle.GetStringFromName("reallyDeleteWarningTextAllMaps"));
        }

        if (!installedItems.some(function(el) el instanceof ttVoice))
        {
            let voicesToDelete = (items.filter(function (el) el instanceof ttVoice)).length;
            let voicesOnDevice = (devContents.filter(function (el) el instanceof ttVoice)).length;
            if (voicesToDelete >= voicesOnDevice)
                criticalMessages.push(this._stringBundle.GetStringFromName("reallyDeleteWarningTextAllVoices"));
        }

        if (items.some(function (el) el instanceof ttProgram))
            criticalMessages.push(this._stringBundle.GetStringFromName("reallyDeleteWarningTextApplications"));

        let warningText;
        if (criticalMessages.length)
        {
            warningText = this._stringBundle.formatStringFromName("reallyDeleteWarningTextCriticals",
                                  [criticalMessages.join("\n")], 1);
        }
        else
        {
            warningText = this._stringBundle.GetStringFromName("reallyDeleteWarningText");
        }

        ttMessageService().confirm(
            this._stringBundle.GetStringFromName("reallyDeleteWarningTitle"),
            warningText,
            null, null,
            successCallback,
            returnCallback);
    },

    selectCopyLoad : function(removeItems)
    {
        var localItems = gApplication.itemFactory.createItemListFromDLL(gApplication.homeServices.localNavItems());
        var localItemsMap = {__proto__: null};
        for each (var item in localItems)
            localItemsMap[item.idurl] = item;

        var askCopyItems = removeItems.filter(function(element)
        {
            if (!element.sourceDLL.canCopyToComputer)
                return false;

            return (!(element.idurl in localItemsMap) ||
                    element.newerThan(localItemsMap[element.idurl]));
        });

        if (askCopyItems.length == 0)
        {
            this.selectCopyDone([]);
            return;
        }

        var itemlist = new ttItemList();
        this._task.addCleanupHandler(function() {
                itemlist.destructor();
            });
        itemlist.addFilter(new ttDependencyTreeBuilder());
        itemlist.addItemListArray(askCopyItems);

        this._ttwizard.loadPage(
            this._constructPageURL("selectCopy"),
            itemlist,
            null,
            makeCallback(this, ttNavItem.copyToPCCheck),
            makeCallback(this, this.selectCopyDone)
            );
    },
selectCopyDone : function(items)
    {
        for each(item in this._itemsToDownload)
        {
            if (!item.isLocal)
            {
                this._ttwizard.addCommit(
                    makeCallback(this, this.downloadCommit),
                    item,
                    this._stringBundle.formatStringFromName("commit.download.name", [item.name], 1),
                    this.commitPriority + 0.05);
            }
        }

        if (items.length > 0)
        {
            this._ttwizard.addCommit(
                makeCallback(this, this.removeCopyCommit),
                items,
                this._stringBundle.GetStringFromName("copy.commit.name"),
                this.commitPriority + 0.2);
        }
        let navItems = this._result.filter(function(item) item instanceof ttNavItem);

        let installLocations = {__proto__: null};
        for each (let installLocation in gApplication.deviceManager.getInstallLocationsForDevice())
            installLocations[installLocation.path.path] = installLocation;

        this._installTargets = ttNavItem.getItemsByTargetLocation(navItems, this._devItems.contents);
        for (let installLocationPath in this._installTargets)
        {
            this._ttwizard.addCommit(
                makeCallback(this, this.installCommit),
                installLocations[installLocationPath],
                this._stringBundle.formatStringFromName("commit.install.name", [installLocations[installLocationPath].name], 1),
                this.commitPriority);
        }

        this.unregisterLocationObserver();
        this.subtaskDone(this._result);
    },
handleInstallLocationChange : function()
    {
        if (!this._task.currentlyNeedDevice)
            return;
        if (this._restarting)
            return;

        this._restarting = true;
        this._ttwizard.allowContinue(true);

        this.restart();
    },
registerLocationObserver : function()
    {
        if (!this._origLocationChangeMethod)
        {
            this._origLocationChangeMethod = this._task._installLocationChanged;
            this._task._installLocationChanged = makeCallback(this, this.handleInstallLocationChange);
        }
        if (!this._observedDevice)
        {
            this._observedDevice = gApplication.deviceManager.activeDevice;
            this._observedDevice.installLocations().addObserver(this);
        }
    },
unregisterLocationObserver : function(keepLocationChangeObserver)
    {
        if (this._origLocationChangeMethod && !keepLocationChangeObserver)
        {
            this._task._installLocationChanged = this._origLocationChangeMethod;
            delete this._origLocationChangeMethod;
        }
        if (this._observedDevice)
        {
            try {
                this._observedDevice.installLocations().removeObserver(this);
            } catch (e) {
}
            delete this._observedDevice;
        }
    },
    added : function(installLocation)
    {
        this.handleInstallLocationChange();
    },
    removed : function(installLocation)
    {
        this.handleInstallLocationChange();
    },
    repopulated : function()
    {
        this.handleInstallLocationChange();
    },
    QueryInterface : function(iid)
    {
        if (iid.equals(CI.ttICollectionObserver) ||
            iid.equals(CI.nsISupportsWeakReference) ||
            iid.equals(CI.nsISupports))
            return this;
        throw Components.results.NS_ERROR_NO_INTERFACE;
    },
downloadCommit : function(serveritem, progressCallback, successCallback, errorCallback)
    {
        var resetBroken = true;
        const kBroken = "tomtom.account.brokenDownload";
        if (serveritem.locationType == 6)
        {
            try {
                if (prefService().getBoolPref(kBroken))
                    resetBroken = false;
            } catch (e) { unimportantError(e); };
            prefService().setBoolPref(kBroken, true);
        }

        let extendedSuccessCallback = makeCallback(this, function(item)
        {
            for each (let itemList in this._installTargets)
            {
                let index = itemList.indexOf(serveritem)
                if (index > -1)
                    itemList[index] = item;
            }

            if (resetBroken)
                prefService().setBoolPref(kBroken, false);

            successCallback(this._stringBundle.formatStringFromName(
                            "downloadedItems", [item.name], 1));
        });

        let extendedErrorCallback = function(e)
        {
            try {
                if (serveritem.locationType == 6)
                    prefService().setBoolPref("tomtom.account.brokenDownload", true);
            } catch (e) { unimportantError(e); }

            errorCallback(e);
        }

        let localItems = gApplication.itemFactory.createItemListFromDLL(gApplication.homeServices.localNavItems());
        let certificateLocation = serveritem.getCertificateLocation();
        let localItem = null;

        if (certificateLocation)
        {
            for each (let item in localItems)
            {
                if (item.idurl == serveritem.idurl && item.getCertificateLocation())
                {
                    localItem = item;
                    break;
                }
            }
        }

        if (localItem)
        {
            return new Downloader().download(certificateLocation.url, gApplication.settings.osTempDir,
                progressCallback,
                makeCallback(this, function(certificateFile)
                {
                    let copiedItem = localItem.createCopyWithDurhamCertificate(certificateFile);

                    this._task.addCleanupHandler(function() removeFile(certificateFile, false));

                    extendedSuccessCallback(copiedItem);
                }),
                extendedErrorCallback);
        }
        else
        {
            return serveritem.download(progressCallback, extendedSuccessCallback, extendedErrorCallback);
        }
    },
installCommit : function(installLocation, progressCallback, successCallback, errorCallback)
    {
        let items = this._installTargets[installLocation.path.path];
        return ttNavItem.installOnDevice(installLocation, items, progressCallback,
            makeCallback(this, function()
            {
                successCallback(this._stringBundle.formatStringFromName(
                                "installedItems", [items.length], 1));
            }),
            errorCallback);
    },
removeDeviceCommit : function(items, progressCallback, successCallback, errorCallback)
    {
        var devItems = gApplication.deviceManager.activeInstallLocation.deviceNavItems();
        var iterator = new ArrayIterator(items, function(item) item.sourceDLL);
        var deleter = devItems.createItemDeleter(iterator);
        var dl = new DeleteListener(progressCallback, successCallback, errorCallback);
        dl.successText = this._stringBundle.formatStringFromName("remove.commit.done",
                         [items.length], 1);
        return new Abortable(deleter.doDelete(dl));
    },
removeCopyCommit : function(items, progressCallback, successCallback, errorCallback)
    {
        return ttNavItem.copyToPC(items, progressCallback, makeCallback(this, function()
        {
            successCallback(this._stringBundle.GetStringFromName("copy.commit.done"));
        }),
        errorCallback);
    },

    __end : null
}
extend(InstallSelectSome, ttSubTask);
function InstallSelectSomeFilter(devItems)
{
    ttItemListFilter.apply(this);

    this._devItems = {__proto__: null};
    for each (var item in devItems)
    {
        this._devItems[item.idurl] = item;
        this._devItems[item.idstrlong] = item;
    }
}
InstallSelectSomeFilter.prototype =
{
    _devItems : null,

    checkItem : function(item)
    {
        if ((item.idurl in this._devItems && !item.newerThan(this._devItems[item.idurl])) ||
            (item.idstrlong in this._devItems && !item.newerThan(this._devItems[item.idstrlong])))
        {
            return [];
        }
        return [item];
    }
}
extend(InstallSelectSomeFilter, ttItemListFilter);
function SelectRemoveFilter(doNotShowItems)
{
    ttItemListFilter.apply(this);

    this._blacklist = {};
    if (doNotShowItems)
    {
        for each (let item in doNotShowItems)
            for each (let id in item.significantIDs)
                this._blacklist[id] = item;
    }
}
SelectRemoveFilter.prototype =
{
    _blacklist : null,

    checkItem : function(item)
    {
        if (item.significantIDs.some(function(id) id in this._blacklist, this) ||
            item instanceof top.ttPartialUpdate ||
            !item.sourceDLL.canDeleteFromDevice ||
            item instanceof ttProgram)
        {
            return [];
        }

        return [item];
    }
}
extend(SelectRemoveFilter, ttItemListFilter);
function SmartRemovalFilter(doNotShowItems, devItems, considerAllMaps)
{
    SelectRemoveFilter.call(this, doNotShowItems);
    this._considerAllMaps = considerAllMaps;
    this._devItems = devItems;

    for each(let devItem in this._devItems.contents)
    {
        if (devItem instanceof ttVoice &&
            devItem.sourceDLL.active == CI.ttINavItem.kActive)
        {
            this._activeVoice = devItem;
            break;
        }
    }
}
SmartRemovalFilter.prototype =
{
    _activeVoice : null,
    _considerAllMaps : null,
_rules : [
        function(item)
        {
            if (item instanceof ttZipcode || item instanceof ttSatImage)
                return "mapitems";
            else
                return null;
        },
        function(item)
        {
            if (item instanceof ttMap)
                if (this._considerAllMaps || item.sourceDLL.active != CI.ttINavItem.kActive)
                    return "maps";
            return null;
        },
        function(item)
        {
            if (item instanceof ttVoice)
            {
                if(this._activeVoice && (this._activeVoice.language == item.language))
                {
                    return "activelanguageitems";
                }
                return "languageitems";
            }
            else
                return null;
        }
    ],

    checkItem : function(item)
    {
        let result = SelectRemoveFilter.prototype.checkItem.call(this, item);
        if (result.length == 0)
          return result;

        for each (let rule in this._rules)
        {
            let category = rule.call(this, item);
            if (category)
            {
                item.disposableCategory = category;
                return [item];
            }
        }

        return [];
    }
}
extend(SmartRemovalFilter, SelectRemoveFilter);