/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function SelectRemove()
{
    ttPage.apply(this, arguments);
    this._willItemsFitData = { __proto__ : null };
}

SelectRemove.prototype =
{
    _installedItems : null,
    _additionalSizeRequirements : null,
    _devItems : null,
    _freeSpaceBuffer : null,
    _referenceData : null,
    _willItemsFitData : null,
    _preSelectedItems : null,

    inputOnLoad : function(args)
    {
        this.allowContinue(false);

        this._sb = E("stringbundle");

        let listbox = E("listbox");
        listbox.addObserver(this);
        if (gApplication.deviceManager.getInstallLocationsForDevice().length <= 1)
            listbox.setAttribute("hiddencolumns", listbox.getAttribute("hiddencolumns") + " location");

        this._installedItems = args.installedItems;
        this._additionalSizeRequirements = args.additionalSizeRequirements;
        this._devItems = args.devItems;
        this._freeSpaceBuffer = args.freeSpaceBuffer;
        this._preSelectedItems = {__proto__: null};

        for each (let item in args.preSelectedItems)
        {
            this._preSelectedItems[item.idurl] = true;
            this._preSelectedItems[item.idstrlong] = true;
        }

        this._referenceData = ttNavItem.getInstalledSizeDelta(this._installedItems, null, this._devItems.contents);

        for each (let installLocation in gApplication.deviceManager.getInstallLocationsForDevice())
            this._willItemsFitData[installLocation.path.path] = this.getSpaceToFreeUp(this._referenceData, installLocation) > 0;
    },

    inputStart : function(items)
    {
        E("listbox").addItemList(items);

        this.updateSelected();
    },

    addedListItem : function(listitem)
    {
        let installLocationPath = listitem.modelitem.sourceDLL.installLocation.path.path;
        listitem.disabled = !this._willItemsFitData[installLocationPath];
        listitem.selected = (listitem.modelitem.idurl in this._preSelectedItems || listitem.modelitem.idstrlong in this._preSelectedItems);

        listitem.addToggleButton(
            null, null,
            makeCallback(this, this.updateSelected),
            makeCallback(this, this.updateSelected));
    },

    updateSelected : function()
    {
        if (this._updateTimeout)
            clearTimeout(this._updateTimeout);
        this._updateTimeout = setTimeout(makeCallback(this, this._updateSelectedInternal), 0);
    },

    getSpaceToFreeUp : function(data, installLocation)
    {
        let installLocationPath = installLocation.path.path;

        let available = installLocation.sizeInBytesFree;
        let required = this._freeSpaceBuffer + data[installLocationPath];

        if (this._additionalSizeRequirements && installLocationPath in this._additionalSizeRequirements)
            required += this._additionalSizeRequirements[installLocationPath];

        return Math.max(0, required - available);
    },

    _updateTimeout : null,
    _updateSelectedInternal : function()
    {
        this._updateTimeout = null;

        let installLocations = {__proto__: null};
        for each (let installLocation in gApplication.deviceManager.getInstallLocationsForDevice())
            installLocations[installLocation.path.path] = installLocation;

        let data = ttNavItem.getInstalledSizeDelta(this._installedItems, E("listbox").selectedModelitems, this._devItems.contents);

        let willFit = true;
        let spacebarData = [];
        for (let installLocationPath in data)
        {
            let installLocation = installLocations[installLocationPath];

            let extra = this.getSpaceToFreeUp(data, installLocation);
            let selected = this._referenceData[installLocationPath] - data[installLocationPath];
            let added = this._referenceData[installLocationPath] - extra;

            spacebarData.push({
                installLocation: installLocation,
                selected: Math.max(0, selected),
                added: Math.max(0, added),
                extra: extra
            });

            if (extra > 0)
                willFit = false;
        }
        E("spacebar").setInstallLocationData(spacebarData);

        this.allowContinue(willFit);
    },

    result : function()
    {
        return E("listbox").selectedModelitems;
    },
}
extend(SelectRemove, ttPage);
window.page = new SelectRemove();
