/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function SmartRemoval()
{
    ttPage.apply(this, arguments);
    this._sb = getStringBundle("chrome://tthome/locale/ui/subtask/installSelectSome/smartRemoval.properties");
    this._unselectedCategories = {__proto__: null, activelanguageitems: true};
    this._willItemsFitData = { __proto__ : null };
}

SmartRemoval.prototype =
{
    _sb : null,
    _smartItemList : null,
    _installedItems : null,
    _additionalSizeRequirements : null,
    _devItems : null,
    _freeSpaceBuffer : null,
    _referenceData : null,
    _categoryPriorities : {
        maps : 3,
        mapitems : 2,
        languageitems : 1,
        activelanguageitems : 0
    },
_unselectedCategories : null,
    _willItemsFitData : null,

    inputOnLoad : function(params)
    {
        assert(params.list instanceof ttItemList, "Need list parameter that is a ttItemList");

        let listbox = E("listbox");
        listbox.addObserver(this);
        listbox.itemToCategoryMapper = makeCallback(this, function(item)
        {
            let dispCategory = item.disposableCategory;
            let category = { id: dispCategory,
                             label: "",
                             closed: (dispCategory in this._unselectedCategories),
                             priority: this._categoryPriorities[dispCategory] };

            try {
                category.label = this._sb.GetStringFromName("category." + dispCategory);
            } catch(e) {
                throw new Bug("The item" + item.name + " uses unknown category for smart removal: " + dispCategory, "Install/SmartRemove");
            }

            return category;
        });

        this._installedItems = params.installedItems;
        this._additionalSizeRequirements = params.additionalSizeRequirements;
        this._devItems = params.devItems;
        this._freeSpaceBuffer = params.freeSpaceBuffer;

        this._referenceData = ttNavItem.getInstalledSizeDelta(this._installedItems, null, this._devItems.contents);

        for each (let installLocation in gApplication.deviceManager.getInstallLocationsForDevice())
            this._willItemsFitData[installLocation.path.path] = this.getSpaceToFreeUp(this._referenceData, installLocation) > 0;

        listbox.addItemList(params.list);

        this.updateSelected();
    },

    addedListItem : function(listitem)
    {
        let installLocationPath = listitem.modelitem.sourceDLL.installLocation.path.path;
        listitem.disabled = !this._willItemsFitData[installLocationPath];
        listitem.selected = !listitem.disabled && !(listitem.modelitem.disposableCategory in this._unselectedCategories)

        listitem.addToggleButton(null, null,
            makeCallback(this, this.updateSelected),
            makeCallback(this, this.updateSelected));
    },

    updateSelected : function()
    {
        if (this._updateTimeout)
            clearTimeout(this._updateTimeout);
        this._updateTimeout = setTimeout(makeCallback(this, this._updateSelectedInternal), 0);
    },

    getSpaceToFreeUp : function(data, installLocation)
    {
        let installLocationPath = installLocation.path.path;

        let available = installLocation.sizeInBytesFree;
        let required = this._freeSpaceBuffer + data[installLocationPath];

        if (this._additionalSizeRequirements && installLocationPath in this._additionalSizeRequirements)
            required += this._additionalSizeRequirements[installLocationPath];

        return Math.max(0, required - available);
    },

    _updateTimeout : null,
    _updateSelectedInternal : function()
    {
        this._updateTimeout = null;

        let installLocations = {__proto__: null};
        for each (let installLocation in gApplication.deviceManager.getInstallLocationsForDevice())
            installLocations[installLocation.path.path] = installLocation;

        let data = ttNavItem.getInstalledSizeDelta(this._installedItems, E("listbox").selectedModelitems, this._devItems.contents);

        let willFit = true;
        let spacebarData = [];
        for (let installLocationPath in data)
        {
            let installLocation = installLocations[installLocationPath];

            let extra = this.getSpaceToFreeUp(data, installLocation);
            let selected = this._referenceData[installLocationPath] - data[installLocationPath];
            let added = this._referenceData[installLocationPath] - extra;

            spacebarData.push({
                installLocation: installLocation,
                selected: Math.max(0, selected),
                added: Math.max(0, added),
                extra: extra
            });

            if (extra > 0)
                willFit = false;
        }
        E("spacebar").setInstallLocationData(spacebarData);
    },

    result : function()
    {
        return E("listbox").selectedModelitems;
    }
}
extend(SmartRemoval, ttPage);
window.page = new SmartRemoval();

