/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function LatestMapGuarantee()
{
    ttSubTask.apply(this, arguments);

    this._stringBundle = getStringBundle("chrome://tthome/locale/ui/subtask/latestMapGuarantee/latestMapGuarantee.properties");
}
LatestMapGuarantee.prototype =
{
    name : "latestMapGuarantee",

    _stringBundle : null,
    _doUpdate : false,
    _items : null,

    start : function ()
    {
        ttSubTask.prototype.start.apply(this, arguments);
        this._task.needDevice(makeCallback(this, this.queryForMapLoad));
    },

    queryForMapLoad : function ()
    {
        this._ttwizard.loadPage(
            this._constructPageURL("queryForMap"),
            null,
            makeCallback(this, this.scanDevice),
            null,
            makeCallback(this, this.queryForMapDone));
    },
scanDevice : function (aPage)
    {
        this._task.doDeviceScan(makeCallback(this, this.queryForMapLoadPrecheck, aPage), errorAbortTask);
    },

    queryForMapLoadPrecheck : function (aPage)
    {
        var me = this;
        var dev = gApplication.deviceManager.activeDevice;
        var uploadBody = new XML(dev.latestMapGuarantee);

        this.networkCall(rpc.call("shop", "latestMapGuarantee",
            {
                eligibilityOnly: true,
                deviceModel: dev.model.id,
                deviceSerial: dev.serial,
                deviceCode: dev.deviceCode,
                deviceCapabilities: gApplication.deviceManager.activeDeviceCapabilitiesString,
                deviceParameters: gApplication.deviceManager.activeDeviceParametersString,
                deviceNavcoreVersion: dev.versionNavCore,
                operatingSystem : gApplication.settings.operatingSystemServerName
            },
            uploadBody,
            RPC.METHOD_POST,
            function (aResult)
            {
var eligibility = makeSafe.enumeration(makeSafe.integer(aResult.@eligible), [0, 1, 2]);
                switch (eligibility)
                {
                    case 0:
                        me.queryForMapLoadPrecond(aPage);
                        break;
                    case 1:
                        prefService().setBoolPref("tomtom.app.lmg_process_done", true);
                        aPage.inputDone({
                            title: me._stringBundle.GetStringFromName("lmg_expired.title"),
                            body: me._stringBundle.GetStringFromName("lmg_expired.body"),
                            doUpdate: false
                        });
                        break;
                    case 2:
                        prefService().setBoolPref("tomtom.app.lmg_process_done", true);
                        aPage.inputDone({
                            title: me._stringBundle.GetStringFromName("lmg_unsupported.title"),
                            body: me._stringBundle.GetStringFromName("lmg_unsupported.body"),
                            doUpdate: false
                        });
                        break;
                }
            },
            errorAbortTask));
    },

    queryForMapLoadPrecond : function (aPage)
    {
        var me = this;
        this.networkCall(this._task.needLogin(function()
        {
            me.queryForMapLoadAsync(aPage);
        }));
    },

    queryForMapLoadAsync : function (aPage)
    {
        var dev = gApplication.deviceManager.activeDevice;
        var uploadBody = new XML(dev.latestMapGuarantee);
        var me = this;

        this.networkCall(rpc.call("shop", "latestMapGuarantee",
            {
                deviceModel: dev.model.id,
                deviceSerial: dev.serial,
                deviceCode: dev.deviceCode,
                deviceCapabilities: gApplication.deviceManager.activeDeviceCapabilitiesString,
                deviceParameters: gApplication.deviceManager.activeDeviceParametersString,
                deviceNavcoreVersion: dev.versionNavCore,
                operatingSystem : gApplication.settings.operatingSystemServerName
            },
            uploadBody,
            RPC.METHOD_POST, function (aResult)
            {
var eligible = makeSafe.enumeration(makeSafe.integer(aResult.@eligible), [0, 1, 2]);
                var updateAvailable = makeSafe.bool(aResult.@updateavailable);

                var title = makeSafe.label(aResult.title);
                var body = makeSafe.label(aResult.text);

                if (updateAvailable)
                {
                    me._items = gApplication.itemFactory.createItemListFromServer(aResult);
                    me._doUpdate = (me._items.length != 0);
                }

                aPage.inputDone({ title: title, body: body, doUpdate: me._doUpdate });
            },
            errorAbortTask));
    },

    queryForMapDone : function ()
    {
        this.subtaskDone({ doUpdate: this._doUpdate, mapsToUpdate: this._items });
    },

    __end : null
}
extend(LatestMapGuarantee, ttSubTask);
