/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/



function LoginPage()
{
    ttPage.apply(this, arguments);
    this._stringBundle = getStringBundle("chrome://tthome/locale/ui/subtask/login/loginPage.properties");
}
LoginPage.prototype =
{
    _stringBundle: null,
    _inputData: null,
    _passwordBlurred: false,
    _disposition: "login",
    _items: null,
inputOnLoad: function(inputData)
    {
        var wizard = this._wizard();

        this._inputData = inputData;
        this._passwordBlurred = false;

        var items = {
            loggedInBox: E("login.loggedin.box"),
            optionalBox: E("login.optional.box"),
            emailField: E("login.email.field"),
            passwordField: E("login.password.field"),
            rememberCheckbox: E("login.remember.checkbox"),
            loggedInLabel: E("login.loggedin.label")

        };
        this._items = items;

        function inputDataDefault(name, defaultValue)
        {
            return (name in inputData) ? inputData[name] : defaultValue;
        }

        if (inputDataDefault("loginOptional", false))
        {
            wizard._wizfooter.getLeftButton().label = this._stringBundle.GetStringFromName("dontLogin");
            items.optionalBox.hidden = false;
        }

        var username = "";
        var password = "";
        var rememberPassword = true;
        try {
            username = gApplication.login.getDefaultUsername();
            password = gApplication.login.getPassword(username);
            rememberPassword = prefService().getBoolPref("tomtom.account.rememberPassword");
        } catch (e) {}

        username = inputDataDefault("username", username);
        rememberPassword = inputDataDefault("rememberPassword", rememberPassword);

        try {
            var emailField = items.emailField;
            emailField.value = username;
            if (rememberPassword)
            {
                items.passwordField.value = password;
            }
            items.rememberCheckbox.checked = rememberPassword;
            emailField.focus();
        } catch (e) {
            error(e);
        }
        this.validateFields();

        this.checkLogin();
    },
result: function()
    {
        var items = this._items;
        return {
            disposition: this._disposition,
            username: items.emailField.value,
            password: items.passwordField.value,
            rememberPassword: items.rememberCheckbox.checked
        };
    },
newAccount: function()
    {
        var items = this._items;

        this._disposition = "newAccount";
        this._inputData.username = items.emailField.value;
        this._inputData.rememberPassword = items.rememberCheckbox.checked;

        this.continue();
    },
checkLogin: function()
    {
        if (gApplication.login.isLoggedIn)
        {
            var username = gApplication.login.currentUsername;
            var items = this._items;
            items.loggedInLabel.textContent = this._stringBundle.formatStringFromName("alreadyLoggedin", [username], 1);
            items.loggedInBox.removeAttribute("hidden");
            window.outerHeight += items.loggedInLabel.boxObject.height;
        }
    },
forgotPassword: function()
    {
        this.validateFields();
        var emailField = this._items.emailField;
        var username = emailField.value;

        if (emailField.parentNode.getAttribute("invalid"))
        {
            var title = this._stringBundle.GetStringFromName("invalidUsernameTitle");
            var text = this._stringBundle.GetStringFromName("invalidUsername");
            ttMessageService().alert(title, text);
            return;
        }
        else
        {
            top.gMainWindow.dialogs.openDialog(
                "chrome://tthome/content/ui/dialogs/login/resetPassword.xul",
                { username: username },
                null, null, false, top);
        }
    },
_checkEmailValid: function()
    {
        var emailField = this._items.emailField;
        try
        {
            checkEmailAddressSyntax(emailField.value);
        }
        catch (e)
        {
            unimportantError(e);
            this._markInvalid(emailField);
            return false;
        }
        this._markValid(emailField);
        return true;
    },
_checkPasswordValid: function()
    {
        var passwordField = this._items.passwordField;
        var ok = passwordField.value.length > 0;

        if (ok || !this._passwordBlurred)
        {
            this._markValid(passwordField);
        }
        else
        {
            this._markInvalid(passwordField);
        }

        return ok;
    },
validateFields: function()
    {
        var emailValid = this._checkEmailValid();
        var passwordValid = this._checkPasswordValid();
        this.allowContinue(emailValid && passwordValid);
    },
blurPassword: function(event)
    {
        if (event.target == this._items.passwordField) return;

        this._passwordBlurred = true;
        this.validateFields();
    },
_markValid: function(node)
    {
        node.parentNode.removeAttribute("invalid");
    },
_markInvalid: function(node)
    {
        node.parentNode.setAttribute("invalid", "true");
    },
passwordKey: function(event)
    {
        if (event.keyCode == CI.nsIDOMKeyEvent.DOM_VK_RETURN)
        {
            this._tryLogIn();
        }
    },
_tryLogIn: function()
    {
        if (!this._checkEmailValid()) {
            ttMessageService().alert(
                this._stringBundle.GetStringFromName("invalidEmail"),
                this._stringBundle.GetStringFromName("invalidEmailMessage"));
            return;
        }

        if (!this._checkPasswordValid()) {
            ttMessageService().alert(
                this._stringBundle.GetStringFromName("invalidPassword"),
                this._stringBundle.GetStringFromName("invalidPasswordMessage"));
            return;
        }

        this._disposition = "login";

        this.continue();
    }
}
extend(LoginPage, ttPage);
window.page = new LoginPage();
