/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/



function NewAccountPage()
{
    ttPage.apply(this, arguments);
    this._stringBundle = getStringBundle("chrome://tthome/locale/ui/subtask/login/newAccountPage.properties");
}
NewAccountPage.prototype =
{
    _stringBundle: null,
    _inputData: null,
    _emailValid: false,
    _passwordFocused: false,
    _passwordConfirmFocused: false,
    _items: null,
inputOnLoad: function(inputData)
    {
        this._inputData = inputData;

        function inputDataDefault(name, defaultValue)
        {
            return (name in inputData) ? inputData[name] : defaultValue;
        }

        var devCapabilities = gApplication.deviceManager.activeDeviceCapabilitiesString;
        var isMarigot = (devCapabilities && devCapabilities.split(" ").indexOf("NotAutomotiveEmbedded") == -1);
        var tomtomWorkEnabled = this._isTomTomWorkEnabled();
        var username = inputDataDefault("username", "");
        var rememberPassword = inputDataDefault("rememberPassword", false);
        var tomtomNews = inputDataDefault("tomtomNews", !isMarigot);
        var tomtomWork = inputDataDefault("tomtomWork", tomtomWorkEnabled);

        var items = {
            emailField: E("newAccount.email.field"),
            emailLabel: E("newAccount.email.label"),
            passwordField: E("newAccount.password.field"),
            passwordLabel: E("newAccount.password.label"),
            passwordConfirmField: E("newAccount.passwordConfirm.field"),
            passwordConfirmLabel: E("newAccount.passwordConfirm.label"),
            rememberCheckbox: E("newAccount.remember.checkbox"),
            tomtomNewsCheckbox: E("newAccount.tomtomNews.checkbox"),
            tomtomWorkCheckbox: E("newAccount.tomtomWork.checkbox")
        };
        this._items = items;

        try {
            items.emailField.value = username;
            items.passwordField.value = "";
            items.passwordConfirmField.value = "";
            items.rememberCheckbox.checked = rememberPassword;
            items.tomtomNewsCheckbox.checked = tomtomNews;
            items.tomtomWorkCheckbox.hidden = !tomtomWorkEnabled;
            items.tomtomWorkCheckbox.checked = tomtomWork;

            items.emailField.focus();

            items.rememberCheckbox.addEventListener("CheckboxStateChange", makeCallback(this, this._checkboxChanged), false);
            items.tomtomNewsCheckbox.addEventListener("CheckboxStateChange", makeCallback(this, this._checkboxChanged), false);
            items.tomtomWorkCheckbox.addEventListener("CheckboxStateChange", makeCallback(this, this._checkboxChanged), false);
        } catch (e) {
            error(e);
        }

        if (isMarigot) {
            this._changeToMarigotNewsletter();
        }

        this.validateEmail();
    },
_changeToMarigotNewsletter: function()
    {
        var checkbox = E("newAccount.tomtomNews.checkbox")
        checkbox.label = this._stringBundle.GetStringFromName("marigot.newsletter");
        var box = document.createElement("hbox");
        box.setAttribute("class", "automotive-disclaimer");
        var label = document.createElement("label");
        label.setAttribute("value", this._stringBundle.GetStringFromName("marigot.policy"));
        box.appendChild(label);
        var link = document.createElement("ttlink");
        link.setAttribute("type", "webid");
        link.setAttribute("urlid", "renaultPrivacy");
        link.setAttribute("label", this._stringBundle.GetStringFromName("marigot.link"));
        box.appendChild(link);
        checkbox.parentNode.appendChild(box);
    },
_isTomTomWorkEnabled: function()
    {
        return gApplication.deviceManager.activeDevice &&
               gApplication.deviceManager.activeDevice.hasCapability("WorkEnabled");
    },
result: function()
    {
        var items = this._items;
        return {
            username: items.emailField.value,
            password: items.passwordField.value,
            rememberPassword: items.rememberCheckbox.checked,
            tomtomNews: items.tomtomNewsCheckbox.checked,
            tomtomWork: items.tomtomWorkCheckbox.checked
        };
    },
validateEmail: function()
    {
        var items = this._items;
        var emailField = items.emailField;

        this._onBlurInvalidate(emailField);

        try {
            checkEmailAddressSyntax(emailField.value);
        } catch (e) {
            this._setInvalid(emailField, items.emailLabel, errorToText(e));
            this._emailValid = false;
            this._validatePasswords();
            return;
        }

        this._setValid(emailField);
        this._emailValid = true;
        this._validatePasswords();

        this._copyValuesToInputData();
    },
validateEmailBlur: function(event)
    {
        var emailField = this._items.emailField;
        if (event.target == emailField) return;

        this._onBlurValidate(emailField);
    },
validatePassword: function()
    {
        this._validatePasswords();
    },
validatePasswordFocusChange: function(event)
    {
        if (event.target == this._items.passwordField) return;

        this._passwordFocused = (event.type == "focus");
        this._validatePasswords();
    },
validatePasswordConfirm: function()
    {
        this._validatePasswords();
    },
validatePasswordConfirmFocusChange: function(event)
    {
        if (event.target == this._items.passwordConfirmField) return;

        this._passwordConfirmFocused = (event.type == "focus");
        this._validatePasswords();
    },
_validatePasswords: function()
    {
        var items = this._items;
        var passwordField = items.passwordField;
        var password = passwordField.value;
        var passwordConfirmField = items.passwordConfirmField;
        var passwordConfirm = passwordConfirmField.value;

        if (password == "")
        {

            this._setValid(passwordField);
            if (passwordConfirm == "")
            {
                this._setValid(passwordConfirmField);
            }
            else
            {
                this._setInvalid(passwordConfirmField,
                                 items.passwordConfirmLabel,
                                 this._stringBundle.GetStringFromName("passwordValidityReq3"));
            }
            this._onBlurInvalidate(passwordField);
            this._onBlurInvalidate(passwordConfirmField);

            this._allowContinue(false);

            return;
        }
        try {
            checkNewPasswordSyntax(password, this._passwordFocused);
        } catch (e) {

            this._setInvalid(passwordField, items.passwordLabel, errorToText(e));
            this._setValid(passwordConfirmField);
            this._onBlurInvalidate(passwordField);
            this._onBlurInvalidate(passwordConfirmField);

            this._allowContinue(false);

            return;
        }
        var passwordValid = true;
        var passwordError = null;
        try {
            checkNewPasswordSyntax(password, false);
        } catch (e) {
            passwordValid = false;
            passwordError = errorToText(e);
        }

        if (this._passwordConfirmFocused)
        {

            if (passwordValid && password == passwordConfirm)
            {

                this._setValid(passwordField);
                this._setValid(passwordConfirmField);
                this._onBlurValidate(passwordField);
                this._onBlurValidate(passwordConfirmField);
                this._allowContinue(
                    !items.emailField.parentNode.hasAttribute("invalid"));

                return;
            }

            if (password.substring(0, passwordConfirm.length) == passwordConfirm)
            {

                this._setValid(passwordField);
                this._setValid(passwordConfirmField);
                this._onBlurValidate(passwordField);
                this._onBlurInvalidate(passwordConfirmField);
                this._allowContinue(false);

                return;
            }
        }

        if (passwordValid || this._passwordFocused)
        {

            this._setValid(passwordField);

            if (passwordValid && password == passwordConfirm)
            {

                this._setValid(passwordConfirmField);
                this._onBlurValidate(passwordField);
                this._onBlurValidate(passwordConfirmField);
                this._allowContinue(
                    !items.emailField.parentNode.hasAttribute("invalid"));

                return;
            }
        }
        else
        {

            this._setInvalid(passwordField,
                             items.passwordLabel,
                             passwordError);
        }

        if (this._passwordConfirmFocused)
        {

            this._setInvalid(passwordConfirmField,
                            items.passwordConfirmLabel,
                            this._stringBundle.GetStringFromName("passwordValidityReq3"));
        }
        else
        {

            this._setValid(passwordConfirmField);
        }

        if (passwordValid)
        {

            this._onBlurValidate(passwordField);
        }
        else
        {

            this._onBlurInvalidate(passwordField);
        }

        this._onBlurInvalidate(passwordConfirmField);

        this._allowContinue(false);

    },
_onBlurValidate: function(node)
    {
        if (!node.parentNode.hasAttribute("invalid"))
        {
            node.parentNode.setAttribute("blurvalid", "true");
        }
    },
_setValid: function(node)
    {
        node.parentNode.removeAttribute("invalid");
    },
_setInvalid: function(node, messageTarget, message)
    {
        messageTarget.textContent = message;
        node.parentNode.setAttribute("invalid", "true");
    },
_onBlurInvalidate: function(node)
    {
        node.parentNode.removeAttribute("blurvalid");
    },
_checkboxChanged: function()
    {
        this._copyValuesToInputData();
    },
_copyValuesToInputData: function()
    {

        var items = this._items;
        this._inputData["username"] = items.emailField.value;
        this._inputData["rememberPassword"] = items.rememberCheckbox.checked;
        this._inputData["tomtomNews"] = items.tomtomNewsCheckbox.checked;
        if (this._isTomTomWorkEnabled())
        {
            this._inputData["tomtomWork"] = items.tomtomWorkCheckbox.checked;
        }
    },
_allowContinue: function(flag)
    {
        this._wizard().allowContinue(flag);
    }

}
extend(NewAccountPage, ttPage);
window.page = new NewAccountPage();
