/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function MapFlavourChoice()
{
    ttPage.apply(this, arguments);
}
MapFlavourChoice.prototype =
{
    _maps : null,
    _basemap : null,
    _devItems : null,
    _installedItems : null,
    _additionalSizeRequirements : null,
    _freeSpaceBuffer : null,

    get selectedMap()
    {
        if (this._maps && E("radio_flavours").selectedItem.value in this._maps)
            return this._maps[E("radio_flavours").selectedItem.value];
        return null;
    },

    inputOnLoad : function(params)
    {
        this._maps = params.maps;
        this._installedItems = params.installedItems;
        this._devItems = params.devItems;
        this._basemap = params.basemap;
        this._additionalSizeRequirements = params.additionalSizeRequirements;
        this._freeSpaceBuffer = params.freeSpaceBuffer;

        let radioGroup = E("radio_flavours");

        for(let i = 0; i < this._maps.length; i++)
            radioGroup.appendItem(this._maps[i].name, i);

        E("basemapName").setAttribute("value", this._basemap.name);

        if (radioGroup.itemCount > 0)
            radioGroup.selectedIndex = 0;

        radioGroup.addEventListener("select", makeCallback(this, function(event) {
                E("flavourDescription").textContent = this.selectedMap.description;
                this.updateSelected();
            }), false);

        E("flavourDescription").textContent = this._maps[radioGroup.selectedItem.value].description;
        E("spacebar").flavours = true;

        this.updateSelected();
    },

    updateSelected : function()
    {
        if (this._updateTimeout)
            clearTimeout(this._updateTimeout);
        this._updateTimeout = setTimeout(makeCallback(this, this._updateSelectedInternal), 0);
    },

    getSpaceToFreeUp : function(data, installLocation)
    {
        let installLocationPath = installLocation.path.path;

        let available = installLocation.sizeInBytesFree;
        let required = this._freeSpaceBuffer + data[installLocationPath];

        if (this._additionalSizeRequirements && installLocationPath in this._additionalSizeRequirements)
            required += this._additionalSizeRequirements[installLocationPath];

        return Math.max(0, required - available);
    },

    _updateTimeout : null,
    _updateSelectedInternal : function()
    {
        this._updateTimeout = null;

        let installLocations = {__proto__: null};
        for each (let installLocation in gApplication.deviceManager.getInstallLocationsForDevice())
            installLocations[installLocation.path.path] = installLocation;

        let newItems = this._installedItems.map(function(item) item == this._basemap ? this.selectedMap : item, this);
        let data = ttNavItem.getInstalledSizeDelta(newItems, null, this._devItems.contents);
        let spacebarData = [];
        for (let installLocationPath in data)
        {
            let installLocation = installLocations[installLocationPath];

            let extra = this.getSpaceToFreeUp(data, installLocation);
            let added = data[installLocationPath] - extra;
            spacebarData.push({
                installLocation: installLocation,
                selected: 0,
                added: Math.max(0, added),
                extra: extra
            });
        }
        E("spacebar").setInstallLocationData(spacebarData);
    },

    result : function()
    {
        return this.selectedMap;
    }
}
extend(MapFlavourChoice, ttPage);
window.page = new MapFlavourChoice();
