/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function MapFlavours()
{
    ttSubTask.apply(this, arguments);
    this._stringBundle = getStringBundle("chrome://tthome/locale/ui/subtask/mapFlavours/mapFlavours.properties");
}
MapFlavours.prototype =
{
    _stringBundle : null,
    name : "mapFlavours",
_flavours : null,
    _basemap : null,
    _installedItems : null,
    _devItems : null,
    _freeSpaceBuffer : null,
    _additionalSizeRequirements : null,

    start : function(params)
    {
        this.networkCall(this._task.needLogin(makeCallback(this, this.getFlavours, params)));
    },

    getFlavours : function(params)
    {
        assert(params && params.item && params.item instanceof ttMap && params.item.basemap,
               "The item passed to the mapFlavours subtask must be a flavoured/favourable ttMap.");
        assert(typeof params.insideInstallFlow != "undefined", "The context for the map flavours task should be specified in the parameters");

        this._basemap = params.item;
        this._installedItems = params.installedItems;
        this._devItems = params.devItems;
        this._freeSpaceBuffer = params.freeSpaceBuffer;
        this._additionalSizeRequirements = params.additionalSizeRequirements;
        var dev = gApplication.deviceManager.activeDevice;
        var args =
        {
            deviceCode: dev.deviceCode,
            deviceSerial: dev.serial,
            deviceModel: dev.model.id,
            deviceCapabilities: gApplication.deviceManager.activeDeviceCapabilitiesString,
            deviceParameters: gApplication.deviceManager.activeDeviceParametersString,
            deviceNavcoreVersion : dev.versionNavCore,
            deviceNavcoreBuild : dev.buildNumberNavCore,
            publicBeta : prefService().getBoolPref("tomtom.app.showBetaVersions")
        };

        var me = this;
        addSubscriptionsRPCArgs(args);
        this.networkCall(rpc.call("shop", "getAccountLicensedContent",
            args, null, RPC.METHOD_GET & ~RPC.USE_CACHE,
            function(result)
            {
                let items = gApplication.itemFactory.createItemListFromServer(result);
                if (items.length > 0)
                {
                    me._flavours = items.filter(function(el) (el.basemap == me._basemap.basemap &&
                                                              el.idstr   != me._basemap.idstr));
                }
                else
                {
                    me._flavours = [];
                }
                me._flavours.unshift(me._basemap);
                if (me._flavours.length == 1)
                    throw new InformativeException(me._stringBundle.GetStringFromName("flavours.notfound"));

                if (params.insideInstallFlow)
                    me.showFlavoursIntroScreen();
                else
                    me.showFlavoursChoice();
            },
            makeCallback(this, function(e)
            {
                if (params.insideInstallFlow)
                {
                    unimportantError(e);
                    this.subtaskDone(this._basemap);
                }
                else
                    errorAbortTask(e);
            })));
    },

    showFlavoursIntroScreen : function()
    {
        this._ttwizard.loadPage(
            this._constructPageURL("mapFlavourIntroScreen"),
            null,
            makeCallback(this, this.flavourIntroScreenDone),
            null,
            makeCallback(this, this.showFlavoursChoice)
            );
    },

    flavourIntroScreenDone : function(page)
    {
        page.inputDone();
    },

    showFlavoursChoice : function()
    {
        this._ttwizard.loadPage(
            this._constructPageURL("mapFlavourChoice"),
                  { maps : this._flavours,
                    basemap : this._basemap,
                    installedItems : this._installedItems,
                    devItems : this._devItems,
                    freeSpaceBuffer : this._freeSpaceBuffer,
                    additionalSizeRequirements :this._additionalSizeRequirements },
            makeCallback(this, this.showFlavoursChoiceAsync),
            null,
            makeCallback(this, this.showFlavoursChoiceDone)
            );
    },

    showFlavoursChoiceAsync : function(page)
    {
        page.inputDone();
    },

    showFlavoursChoiceDone : function(flavour)
    {
        this.subtaskDone(flavour);
    },

    __end : null
}
extend(MapFlavours, ttSubTask);
