/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function ShareContent()
{
    ttSubTask.apply(this, arguments);
    this._stringBundle = getStringBundle("chrome://tthome/locale/ui/subtask/shareContent/shareContent.properties");
}
ShareContent.prototype =
{
    name : "shareContent",

    _stringBundle : null,
    _item : null,
_deviceItem : null,
_localItem : null,
_itemXML : null,
    _uploadData : null,
_myServerItems : null,
_allDeviceItems : null,

    start : function ()
    {
        ttSubTask.prototype.start.apply(this, arguments);

        this._task.needDevice(makeCallback(this, this.showItemsLoad));
    },

    betaWarningLoad : function ()
    {
        var me = this;
        ttMessageService().confirm(
            this._stringBundle.GetStringFromName("betaWarning.title"),
            this._stringBundle.GetStringFromName("betaWarning.prompt"),
            this._stringBundle.GetStringFromName("betaWarning.cancel"),
            this._stringBundle.GetStringFromName("betaWarning.continue"),
            makeCallback(this, this.showItemsLoad),
            function () { me._task.abort() });
    },

    showItemsLoad : function ()
    {
        this._ttwizard.loadPage(
            this._constructPageURL("showItems"),
            { contentType: this._task.contentType },
            makeCallback(this, this.showItemsPrecond),
            null,
            makeCallback(this, this.showItemsDone)
            );
    },

    showItemsPrecond : function(aPage)
    {
        this.networkCall(this._task.needLogin(makeCallback(this, this.showItemsLoadAsync, aPage)));
    },

    showItemsLoadAsync : function (aPage)
    {
        var itemlist = new ttItemList();
        aPage.inputStart(itemlist);

        this._myServerItems = new ttItemList();
        var myServerItems = this._myServerItems;
        this._allDeviceItems = new ttItemList();
        var allLocalItems = this._allDeviceItems;

        var dev = gApplication.deviceManager.activeDevice;

        var outstandingCalls = 0;

        var me = this;
        var inputDone = function ()
        {
            if (--outstandingCalls > 0)
                return;
            var hashedDeviceSerial = me._computeHashSHA1(dev.serial);
            var serverOnlyItems = new ttItemList();
            var myLocalItems = new ttItemList();
            var unknownLocalItems = new ttItemList();
            var allLocalItemsMap = new Map();
            var items = allLocalItems.contents;
            for (var i = 0; i < items.length; i++)
                allLocalItemsMap.addValue(items[i].idurl, items[i]);
            var myServerItemsMap = new Map();
            var items = myServerItems.contents;
            for (var i = 0; i < items.length; i++)
                myServerItemsMap.addValue(items[i].idurl, items[i]);
items = myServerItems.contents;
            for (var i = 0; i < items.length; i++)
            {
                if (!allLocalItemsMap.hasValue(items[i].idurl))
                {
                    serverOnlyItems.addItem(items[i]);
                    items[i].isUpdate = true;
                    items[i].isMetadataOnly = true;
                }
            }
items = allLocalItems.contents;
            for (var i = 0; i < items.length; i++)
            {
                if (items[i].creatingDeviceID == hashedDeviceSerial)
                {
                    myLocalItems.addItem(items[i]);
                    if (myServerItemsMap.hasValue(items[i].idurl))
                        items[i].isUpdate = true;
                }
var serverItem = myServerItemsMap.getValue(items[i].idurl);
                if (serverItem)
                {
                    if (serverItem.preview)
                        items[i].preview = ttImage.prototype.createFromServer(serverItem.preview.exportToXML());
                    if (serverItem.audioSample && serverItem.audioSampleMimetype)
                    {
                        items[i].audioSample = serverItem.audioSample;
                        items[i].audioSampleMimetype = serverItem.audioSampleMimetype;
                    }
                }
            }
items = allLocalItems.contents;
            for (var i = 0; i < items.length; i++)
            {
                if (items[i].isShareable && !items[i].creatingDeviceID)
                    unknownLocalItems.addItem(items[i]);
            }
            itemlist.addItemListArray(serverOnlyItems.contents);
            itemlist.addItemListArray(myLocalItems.contents);
            itemlist.addItemListArray(unknownLocalItems.contents);

            aPage.inputDone();
        };
        var contentType = "";
        if (this._task.contentType)
            contentType = this._task.contentType;
        outstandingCalls++;
        this.networkCall(rpc.call("sharing", "getUserContent",
            {
                deviceserial: dev.serial,
                deviceModel: dev.model.id,
                deviceCapabilities: gApplication.deviceManager.activeDeviceCapabilitiesString,
                deviceParameters: gApplication.deviceManager.activeDeviceParametersString,
                deviceNavcoreVersion: dev.versionNavCore,
                deviceNavcoreBuild: dev.buildNumberNavCore,
                contentType: contentType,
                onlymine: true,
                sortby: "rating"
            }, null, RPC.METHOD_GET,
            function (aResult)
            {
                myServerItems.addItemListFromServer(aResult);
                inputDone();
            },
            errorAbortTask));

        outstandingCalls++;
        this._task.doDeviceScan(makeCallback(this,
            function ()
            {
                for each (let loc in gApplication.deviceManager.getInstallLocationsForDevice())
                    allLocalItems.addItemListFromDLL(loc.deviceNavItems(), contentType);
                inputDone();
            }), errorAbortTask);
    },
showItemsDone : function (aItem)
    {
        assert(aItem, "item must not be null");

        this._item = aItem;
        this.editItemDataLoad(aItem);
    },

    editItemDataLoad : function (aItem)
    {
        this._ttwizard.loadPage(
            this._constructPageURL("editItemData"),
            aItem,
            makeCallback(this, this.editItemDataLoadAsync),
            makeCallback(this, this.editItemDataCheck),
            makeCallback(this, this.editItemDataDone)
        );
    },

    editItemDataLoadAsync : function (aPage)
    {
        aPage.inputDone();
    },
editItemDataCheck : function (aData, aSuccessCallback, aErrorCallback, aReturnCallback)
    {
        if (aData.stopSharing)
            aSuccessCallback(aData);
        aData.additionMode = this._item.isMetadataOnly ? "newmetadata" : (this._item.isUpdate ? "newversion" : "newitem");

        if (this._item.isUpdate && !(this._item.isMetadataOnly))
            this._incrementVersion(this._item);

        var dev = gApplication.deviceManager.activeDevice;
this._item.isSharing = true;
        this._item.creatingDeviceID = this._computeHashSHA1(dev.serial);
        this._item.name = aData.name;
        this._item.description = aData.description;
        this._item.tags = aData.tags;
        this._item.authorName = aData.userHandle;
        this._item.idstr = this._convertNameToIDSTR(aData.name);

        if (aData.additionMode != "newmetadata")
        {
            var dlURI = getIOService().newURI("sharedfile:none", null, null);
            this._item.locations = [ { url: dlURI, content: "main", size: "0" } ];
            this._item.size = this._item.sourceDLL.sizeInBytes;
        }

        if (this._item instanceof ttVoice)
        {
            this._item.language = aData.spokenLanguage;
            this._item.categories = aData.spokenLanguage;
        }
        else if (aData.category)
            this._item.categories = aData.category;

        if (aData.preview && aData.preview instanceof CI.nsIFileURL)
        {
            aData.previewMimeType = this._getMimeTypeForURI(aData.preview);
            this._item.preview = new ttImage(getIOService().newURI("sharedfile:none", null, null).spec,
                aData.previewMimeType, aData.previewWidth, aData.previewHeight);
        }
        else if (aData.additionMode == "newitem")
        {
this._item.preview = null;
            aData.preview = null;
        }

        if (aData.sample && aData.sample instanceof CI.nsIFileURL)
        {
            this._item.audioSample = getIOService().newURI("sharedfile:none", null, null);
aData.sampleMimeType = "audio/x-wav";
            this._item.audioSampleMimetype = aData.sampleMimeType;
        }
        else if (aData.additionMode == "newitem")
        {
this._item.audioSample = null;
            aData.sample = null;
        }
var iconImageURL = null;
        try {
            iconImageURL = this._item.icon ? getIOService().newURI(this._item.icon.url, null, null) : null;
        } catch (e) { unimportantError(e); }
        if (aData.additionMode == "newitem" ||
            (aData.preview && aData.preview instanceof CI.nsIFileURL) ||
            (iconImageURL instanceof CI.nsIFileURL))
        {
            this._item.icon = null;
        }
        aData.itemXML = this._item.exportToXML();

        this._addItemDryrun(aData, aSuccessCallback, aErrorCallback, aReturnCallback);
    },

    _addItemDryrun : function (aData, aSuccessCallback, aErrorCallback, aReturnCallback)
    {
        var dev = gApplication.deviceManager.activeDevice;
        var addItemBody = <addItem/>;
        addItemBody.appendChild(aData.itemXML.copy());

        var me = this;
        this.networkCall(rpc.call("sharing", "addItem",
            {
                deviceserial: dev.serial,
                devicecode: dev.deviceCode,
                devicemodel: dev.model.id,
                deviceCapabilities: gApplication.deviceManager.activeDeviceCapabilitiesString,
                deviceParameters: gApplication.deviceManager.activeDeviceParametersString,
                additionmode: aData.additionMode,
                userid: aData.userHandle ? aData.userHandle : ""
            },
            addItemBody,
            RPC.METHOD_POST | RPC.DRY_RUN,
            function (aResult)
            {
                aSuccessCallback(aData);
            },
            function (e)
            {
                switch (e.code)
                {
                    case 535:
if (aData.additionMode == "newversion")
                        {
                            aErrorCallback(e);
                            return;
                        }
var items = me._myServerItems.contents;
                        var foundItem = null;
                        for (var i = 0; i < items.length; i++)
                        {
                            if (items[i].idstr.toLowerCase() == me._item.idstr.toLowerCase())
                            {
                                foundItem = items[i];
                                break;
                            }
                        }
                        if (!foundItem)
                        {
                            aErrorCallback(e);
                            return;
                        }
me.showReplaceItemPrompt(function ()
                            {
                                aData.additionMode = "newversion";
                                me._item.idurl = foundItem.idurl;
                                me._incrementVersion(me._item);
                                aData.itemXML = me._item.exportToXML();

                                me._addItemDryrun(aData, aSuccessCallback, aErrorCallback, aReturnCallback);
                            }, function ()
                            {
aReturnCallback();
                            });

                        break;
                    case 537:
                    case 538:
                        aErrorCallback(e);
                        break;
                    default:
                        errorAbortTask(e);
                }
            }));
    },
showReplaceItemPrompt : function (aSuccessCallback, aCancelCallback)
    {
        ttMessageService().confirm(
            this._stringBundle.GetStringFromName("replaceItem.title"),
            this._stringBundle.GetStringFromName("replaceItem.text"),
            this._stringBundle.GetStringFromName("replaceItem.cancel"),
            this._stringBundle.GetStringFromName("replaceItem.ok"),
            aSuccessCallback,
            aCancelCallback);
    },

    _incrementVersion : function(item)
    {
        var version = makeSafe.integer(item.version.replace(/\..*/, ""));
        item.version = String(++version);
    },

    editItemDataDone : function (aData)
    {
        gApplication.login.removeObserver(this);
        this._uploadData = aData;

        if (aData.stopSharing)
        {
            this._ttwizard.addCommit(
                makeCallback(this, this.removeItemCommit),
                { item: this._item },
                this._stringBundle.formatStringFromName("commit.remove.name", [this._item.name], 1),
                this.commitPriority);

            this.subtaskDone();
            return;
        }

        this._ttwizard.loadPage(
            this._constructPageURL("uploadDisclaimer"),
            null,
            null,
            null,
            makeCallback(this, this.uploadDisclaimerDone)
            );
    },

    uploadDisclaimerDone : function (aData)
    {
        if (aData.abort)
        {
            this._task.abort();
            return;
        }

        var data = this._uploadData;
        if (this._item.isLocal && this._item.sourceDLL.id != this._item.idstr)
        {
var itemIDStr = this._item.idstr.toLowerCase();
            var oldItem = null;
            for each (var localItem in this._allDeviceItems.contents)
            {
                if (localItem != this._item && localItem.idstr.toLowerCase() == itemIDStr)
                {
                    oldItem = localItem;
                    break;
                }
            }
            if (oldItem)
            {
                this._ttwizard.addCommit(
                    makeCallback(this, this.copyOldItemAwayCommit),
                    [oldItem],
                    this._stringBundle.GetStringFromName("commit.copyOldItemAway.name"),
                    this.commitPriority);
                this._ttwizard.addCommit(
                    makeCallback(this, this.removeOldItemAwayCommit),
                    oldItem,
                    this._stringBundle.GetStringFromName("commit.removeOldItemAway.name"),
                    this.commitPriority);
            }

            this._ttwizard.addCommit(
                makeCallback(this, this.renameItemCommit),
                this._item,
                this._stringBundle.formatStringFromName("commit.renameItemCommit.name", [this._item.name], 1),
                this.commitPriority);
        }

        if (this._item.locationType == 1)
        {
            this._deviceItem = this._item;
            if (data.additionMode != "newmetadata")
            {
                this._ttwizard.addCommit(
                    makeCallback(this, this.copyItemCommit),
                    this._deviceItem,
                    this._stringBundle.formatStringFromName("commit.copy.name", [this._item.name], 1),
                    this.commitPriority);
            }
        }
        else if (this._item.isLocal)
        {
            this._localItem = this._item;
        }

        this._ttwizard.addCommit(
            makeCallback(this, this.addItemCommit),
            { itemXML: data.itemXML, additionMode: data.additionMode, userHandle: data.userHandle,
              preview: data.preview, previewWidth: data.previewWidth, previewHeight: data.previewHeight,
              previewMimeType: data.previewMimeType, sample: data.sample, sampleMimeType: data.sampleMimeType },
            this._stringBundle.formatStringFromName("commit.addItem.name", [this._item.name], 1),
            this.commitPriority);

        if (data.additionMode != "newmetadata")
        {
            this._ttwizard.addCommit(
                makeCallback(this, this.uploadItemCommit),
                null,
                this._stringBundle.formatStringFromName("commit.upload.name", [this._item.name], 1),
                this.commitPriority);
        }

        if (data.preview && data.preview instanceof CI.nsIFileURL)
        {
            this._ttwizard.addCommit(
                makeCallback(this, this.uploadPreviewImageCommit),
                { preview: data.preview.QueryInterface(CI.nsIFileURL), mimeType: data.previewMimeType },
                this._stringBundle.formatStringFromName("commit.uploadPreview.name", [this._item.name], 1),
                this.commitPriority);
        }

        if (data.sample && data.sample instanceof CI.nsIFileURL)
        {
            this._ttwizard.addCommit(
                makeCallback(this, this.uploadAudioSampleCommit),
                { sample: data.sample.QueryInterface(CI.nsIFileURL), mimeType: data.sampleMimeType },
                this._stringBundle.formatStringFromName("commit.uploadSample.name", [this._item.name], 1),
                this.commitPriority);
        }

        this._ttwizard.addCommit(
            makeCallback(this, this.persistItemDataCommit),
            null,
            this._stringBundle.formatStringFromName("commit.persist.name", [this._item.name], 1),
            this.commitPriority);

        this._ttwizard.addCommit(
            makeCallback(this, this.uploadConfirmationCommit),
            null,
            this._stringBundle.GetStringFromName("commit.confirmation.name"),
            this.commitPriority);

        this.subtaskDone();
    },

    copyOldItemAwayCommit : function (aItems, aProgressCallback, aSuccessCallback, aErrorCallback)
    {
        var me = this;
        ttNavItem.copyToPC(aItems, aProgressCallback, function()
                {
                    aSuccessCallback(me._stringBundle.GetStringFromName("copyOldItemAwayFinished"));
                },
                aErrorCallback);
    },
renameItemCommit : function (aItem, aProgressCallback, aSuccessCallback, aErrorCallback)
    {
        aProgressCallback(0, this._stringBundle.GetStringFromName("commitInitialising"));

        var renameError = { value: null };
        try {
            aItem.sourceDLL.rename(aItem.idstr, aItem.name, renameError);
        } catch (e) {
            switch (e.result)
            {
                case CI.ttIErrorCode.kRenameNotPossible:
                    throw new Exception(this._stringBundle.GetStringFromName("renameNotPossibleException"));
                    break;
                case CI.ttIErrorCode.kRenameInvalidID:
                    throw new Exception(this._stringBundle.GetStringFromName("renameInvalidIDException"));
                    break;
                case CI.ttIErrorCode.kRenameExistingID:
                    throw new Exception(this._stringBundle.GetStringFromName("renameExistingIDException"));
                    break;
                default:
                    throw e;
            }
        }

        aProgressCallback(100);
        aSuccessCallback(this._stringBundle.GetStringFromName("renameItemFinished"));

        return new NoOpCall();
    },
removeOldItemAwayCommit : function (aDeviceItem, aProgressCallback, aSuccessCallback, aErrorCallback)
    {
        var devItems = gApplication.deviceManager.activeInstallLocation.deviceNavItems();
        var iterator = new ArrayIterator([aDeviceItem], function(item) { return item.sourceDLL; });
        var deleter = devItems.createItemDeleter(iterator);
        var dl = new DeleteListener(aProgressCallback, aSuccessCallback, aErrorCallback);
        dl.successText = this._stringBundle.GetStringFromName("removeOldItemAway");
        return new Abortable(deleter.doDelete(dl));
    },
copyItemCommit : function (aDeviceItem, aProgressCallback, aSuccessCallback, aErrorCallback)
    {
var targetFolder = gApplication.settings.sharingItemsDir.clone();
        var localItems = gApplication.homeServices.localNavItems()
                     .QueryInterface(CI.ttILocalItems);
        var iterator = new ArrayIterator([aDeviceItem], function (item) { return item.sourceDLL; });
        var installer = localItems.createDeviceToLocalInstaller(iterator, targetFolder)
                        .QueryInterface(CI.ttIInstaller);
        var errorStrOut = { value: null };
        if (!installer.checkPreconditionsOk({ value: null }, errorStrOut))
        {
            aErrorCallback(errorStrOut.value);
            return;
        }
        var localItem = null;
        var observer =
        {
            added : function (aItem)
            {
aItem = aItem.QueryInterface(CI.ttIItem);
                localItem = gApplication.itemFactory.createItemFromDLL(aItem);
                localItems.removeObserver(observer);
            },
            removed : function () {},
            repopulated : function () {},
            QueryInterface : function (iid)
            {
                if (iid.equals(CI.ttICollectionObserver) ||
                    iid.equals(CI.nsISupportsWeakReference) ||
                    iid.equals(CI.nsISupports))
                    return this;
                throw Components.results.NS_NOINTERFACE;
            }
        };
        localItems.addObserver(observer);

        var me = this;
        return new Abortable(installer.doInstall(new CopyListener(aProgressCallback, function()
            {
                if (!localItem)
                {
                    aErrorCallback(new Exception(me._stringBundle.GetStringFromName("copyObserverNotCalledException")));
                    return;
                }
                if (localItem.sourceDLL.id != aDeviceItem.sourceDLL.id)
                {
                    aErrorCallback(new Exception(me._stringBundle.formatStringFromName("differingIDException",
                        [ localItem.sourceDLL.id, aDeviceItem.sourceDLL.id ], 2)));{}
return;
                }
                me._localItem = localItem;
                aSuccessCallback(me._stringBundle.GetStringFromName("copiedItemsFinished"));
            },
            aErrorCallback)));
    },
addItemCommit : function (aData, aProgressCallback, aSuccessCallback, aErrorCallback)
    {
var item = gApplication.itemFactory.createItemFromServer(aData.itemXML);

        if (aData.additionMode != "newmetadata")
        {
            var contentFile = this._getItemContentFile(this._localItem);
            var contentDlURI = getIOService().newURI("sharedfile:upload/" + makeSafeEscape.filename(contentFile.leafName), null, null);
            item.locations = [ { url: contentDlURI, content: "main", size: contentFile.fileSize } ];
        }

        if (aData.preview && aData.preview instanceof CI.nsIFileURL)
        {
            var previewDlURI = getIOService().newURI("sharedfile:upload/" + makeSafeEscape.filename(aData.preview.fileName), null, null);
            item.preview = new ttImage(previewDlURI.spec, aData.previewMimeType, aData.previewWidth, aData.previewHeight);
        }

        if (aData.sample && aData.sample instanceof CI.nsIFileURL)
        {
            item.audioSample = getIOService().newURI("sharedfile:upload/" + makeSafeEscape.filename(aData.sample.fileName), null, null);
            item.audioSampleMimetype = aData.sampleMimeType;
        }
        var addItemBody = <addItem/>;
        addItemBody.appendChild(item.exportToXML());

        var dev = gApplication.deviceManager.activeDevice;
        var userHandle = ""
        if (aData.userHandle)
            userHandle = aData.userHandle;

        var me = this;
        return rpc.call("sharing", "addItem",
            {
                deviceserial: dev.serial,
                devicecode: dev.deviceCode,
                devicemodel: dev.model.id,
                deviceCapabilities: gApplication.deviceManager.activeDeviceCapabilitiesString,
                deviceParameters: gApplication.deviceManager.activeDeviceParametersString,
                additionmode: aData.additionMode,
                userid: userHandle
            },
            addItemBody,
            RPC.METHOD_POST,
            function (aResult)
            {
                var item = gApplication.itemFactory.createItemFromServer(aResult.children()[0]);
                me._itemXML = item.exportToXML();
rpc.clearCache();

                aSuccessCallback(me._stringBundle.GetStringFromName("addItemFinished"));
            },
            aErrorCallback);
    },
uploadItemCommit : function (aData, aProgressCallback, aSuccessCallback, aErrorCallback)
    {
        aProgressCallback(-1, this._stringBundle.GetStringFromName("commitInitialising"));
        var contentFile = this._getItemContentFile(this._localItem);
        var mimeType = "application/x-zip-compressed";

        var uri = makeSafe.url(this._itemXML.download.url.@location);

        var me = this;
        return new Uploader().upload(contentFile, uri, mimeType, aProgressCallback, function ()
            {
                aProgressCallback(100, me._stringBundle.GetStringFromName("uploadItemFinished"));
                aSuccessCallback(me._stringBundle.GetStringFromName("uploadItemFinished"));
            },
            aErrorCallback);
    },
uploadPreviewImageCommit : function (aData, aProgressCallback, aSuccessCallback, aErrorCallback)
    {
        aProgressCallback(-1, this._stringBundle.GetStringFromName("commitInitialising"));
        var ttPreview = null;
        for each (var preview in this._itemXML.image.(@usage == "preview"))
        {
            ttPreview = ttImage.prototype.createFromServer(preview);
            break;
        }
        var uri = getIOService().newURI(ttPreview.url, null, null);

        var me = this;
        return new Uploader().upload(aData.preview.file, uri, aData.mimeType, aProgressCallback, function ()
            {
                aProgressCallback(100, me._stringBundle.GetStringFromName("uploadPreviewFinished"));
                aSuccessCallback(me._stringBundle.GetStringFromName("uploadPreviewFinished"));
            },
            aErrorCallback);
    },
uploadAudioSampleCommit : function (aData, aProgressCallback, aSuccessCallback, aErrorCallback)
    {
        aProgressCallback(-1, this._stringBundle.GetStringFromName("commitInitialising"));
        var uri = null;
        for each (var sample in this._itemXML.audio.(@usage == "preview"))
        {
            uri = makeSafe.url(sample.@url);
            break;
        }

        var me = this;
        return new Uploader().upload(aData.sample.file, uri, aData.mimeType, aProgressCallback, function ()
            {
                aProgressCallback(100, me._stringBundle.GetStringFromName("uploadSampleFinished"));
                aSuccessCallback(me._stringBundle.GetStringFromName("uploadSampleFinished"));
            },
            aErrorCallback);
    },
persistItemDataCommit : function (aData, aProgressCallback, aSuccessCallback, aErrorCallback)
    {
        aProgressCallback(0, this._stringBundle.GetStringFromName("persistStoring"));

        try
        {
            if (this._deviceItem)
            {
                this._deviceItem.importFromXML(this._itemXML);
                this._deviceItem.saveMetadata();
            }
            if (this._localItem)
            {
                var mainLoc = this._getItemContentFile(this._localItem);
                this._localItem.importFromXML(this._itemXML);
                this._localItem._locations = [
                    {
                        url: mainLoc,
                        size: mainLoc.fileSize,
                        content: "main"
                    } ];
                this._localItem.saveMetadata();
            }

            aProgressCallback(100);
            aSuccessCallback(this._stringBundle.GetStringFromName("persistItemDataFinished"));
        }
        catch (e)
        {
            aErrorCallback(e);
        }

        return new NoOpCall();
    },
removeItemCommit : function (aData, aProgressCallback, aSuccessCallback, aErrorCallback)
    {
        var dev = gApplication.deviceManager.activeDevice;

        var me = this;
        return rpc.call("sharing", "removeItem",
            {
                deviceserial: dev.serial,
                devicecode: dev.deviceCode,
                devicemodel: dev.model.id,
                item: aData.item.idurl
            },
            null, RPC.METHOD_POST,
            function ()
            {
                aSuccessCallback(me._stringBundle.GetStringFromName("removeItemDataFinished"));
            },
            aErrorCallback);
    },
uploadConfirmationCommit : function (ignored0, ignored1, aSuccessCallback, ignored2)
    {
        try {
            this._ttwizard._wizbrowser.contentDocument
                .loadOverlay("chrome://tthome/content/ui/subtask/shareContent/uploadConfirmationOverlay.xul", null);
        } catch (e) {
}

        aSuccessCallback(this._stringBundle.GetStringFromName("uploadConfirmationFinished"));

        return new NoOpCall();
    },
_computeHashSHA1 : function (aString)
    {
        var stream = Cc['@mozilla.org/io/string-input-stream;1']
            .createInstance(CI.nsIStringInputStream);
        stream.setData(aString, aString.length);

        try {
            var cryptoEngine = Cc["@mozilla.org/security/hash;1"]
                .createInstance(CI.nsICryptoHash);
            cryptoEngine.init(CI.nsICryptoHash.SHA1);
            cryptoEngine.updateFromStream(stream, stream.available());
            return cryptoEngine.finish(true);
        } finally {
            stream.close();
        }
    },
_getItemContentFile : function (aLocalItem)
    {
        var toc = aLocalItem.getTOCXML();
        var tocURI = getIOService().newFileURI(aLocalItem.sourceDLL.tocFile);
        var itemLocURI = null;
        for each (var loc in toc..Location)
        {
            if (loc.@content == "main")
            {
                itemLocURI = getIOService().newURI(loc.text(), null, tocURI);
                break;
            }
            else if (!loc.hasOwnProperty("@content") && !itemLocURI)
            {
                itemLocURI = getIOService().newURI(loc.text(), null, tocURI);
            }
        }

        var contentFile = null;
        if (itemLocURI)
            contentFile = itemLocURI.QueryInterface(CI.nsIFileURL).file.clone();

        return contentFile;
    },
_getMimeTypeForURI : function (aURI)
    {
        var mimeService = Cc["@mozilla.org/mime;1"].createInstance(CI.nsIMIMEService);
        return mimeService.getTypeFromURI(aURI);
    },
_convertNameToIDSTR : function (aName)
    {
        return makeSafeEscape.filename(aName);
    },

    __end: null
}
extend(ShareContent, ttSubTask);
