/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function ShowItems()
{
    ttPage.apply(this, arguments);
}
ShowItems.prototype =
{
    _contentType : null,
    _selectedItem : null,
    _newItem : false,
    _typeToSuffixMap :
    {
        poi: "*.ov2",
        voice: "*.chk",
        colorscheme: "*.clr",
        satimage: "*.ver",
        itinerary: "*.itn",
        ringtone: "*.ogg",
        startupscreen: "*.bmp",
        suspendscreen: "*.bmp",
        arrivalsound: "*.wav",
        warningsound: "*.wav;*.ogg",
        messagereceived: "*.ogg",
        carsymbol: "*.bmp"
    },

    inputOnLoad : function(aArgs)
    {
        this._listbox = E("listbox");
        this._listbox.addObserver(this);
        this._sb = E("strings");
        this._contentType = aArgs.contentType;
        if (!this._contentType)
        {
            this._wizard().removeAttribute("contenttype");
            return;
        }
        this.title = this._sb.getString("page.title.generic");
        this._wizard().setAttribute("contenttype", this._contentType);
        E("listbox").setAttribute("createcategories", "false");
},

    inputStart : function(itemlist)
    {
        this._listbox.addItemList(itemlist);
    },

    addedListItem : function(listitem)
    {
        var me = this;
        if (!listitem.modelitem.isServer)
        {
            if (!this._checkSizeOK(listitem.modelitem))
                listitem.errorMessage = this._sb.getString("badItemSize");

            if (listitem.modelitem.isUpdate)
            {
                listitem.addButton(this._sb.getString("updateItem.label"), function (listitem)
                {
                    me._selectedItem = listitem.modelitem;
                    me.continue();
                });
            }
            else
            {
                listitem.addButton(this._sb.getString("shareItem.label"), function (listitem)
                {
                    me._selectedItem = listitem.modelitem;
                    me.continue();
                });
            }
        }
        else
        {
            listitem.addButton(this._sb.getString("editItem.label"), function (listitem)
            {
                me._selectedItem = listitem.modelitem;
                me.continue();
            });
        }
    },

    browseForItem : function()
    {
        var picker = Cc["@mozilla.org/filepicker;1"].createInstance(CI.nsIFilePicker);
        var title = this._sb.getString("file.picker.title");
        picker.init(window, title, CI.nsIFilePicker.modeOpen);
        var filter = this._typeToSuffixMap[this._contentType];
        if (!filter)
        {
            error(this._sb.getString("browsing.not.supported"));
            return;
        }
        picker.appendFilter(this._sb.getString(this._contentType + ".suffix.name"), filter);

        if (picker.show() != CI.nsIFilePicker.returnOK)
            return;

        var file = picker.file.QueryInterface(CI.nsILocalFile);
        var fileSuffix = "*" + file.leafName.match(/\..+$/).toLowerCase();
        var suffixList = filter.split(";");
        if (!suffixList.some(function (aVal) aVal == fileSuffix))
        {
            error(this._sb.getString("invalid.selection"));
            return;
        }

        var itemType = gApplication.itemFactory.findSubtype("xmlTag", this._contentType).itemtypeEnum;
        var errorCode = { value: null };
        var errorString = { value: null };
        var item = null;
        try {
            item = gApplication.homeServices.getItemFromFile(file, itemType, errorCode, errorString);
        } catch (e) {
            error(new ExceptionWithCustomMessage(
                this._sb.getFormattedString("item.creation.exception", [file.path, errorCode.value, errorString.value]), e));
            return;
        }

        this._selectedItem = gApplication.itemFactory.createItemFromDLL(item);
        this.continue();
    },

    _typeToContentSizeMap :
    {
        poi: [264, 15839232],
        voice: [20481, 3249152],
        colorscheme: [256, 32768],
        satimage: [100, 2097152],
        itinerary: [1, 131072],
        ringtone: [100, 2097152],
        startupscreen: [102400, 409600],
        suspendscreen: [102400, 409600],
        arrivalsound: [500, 2097152],
        warningsound: [100, 2097152],
        messagereceived: [100, 2097152],
        carsymbol: [100, 98304],
        buddysymbol: [100, 98304],
        homesymbol: [100, 98304],
        favouritesymbol: [100, 98304],
        shutdownsound: [100, 2097152],
        startupsound: [100, 2097152]
    },
    _checkSizeOK : function(item)
    {
        var size = this._typeToContentSizeMap[item.typeID];
        if (!size)
            size = [0, 15728640];

        var itemSize = item.size;
        return (itemSize >= size[0] && itemSize <= size[1]);
    },

    result : function()
    {
        return this._selectedItem;
    }
}
extend(ShowItems, ttPage);
window.page = new ShowItems();
