/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/


function ShopSelect()
{
    ttSubTask.apply(this, arguments);
    this._stringBundle = getStringBundle("chrome://tthome/locale/ui/subtask/shopSelect/shopSelect.properties");
    this._shopItems = [];
    this._sharingItems = [];
}
ShopSelect.prototype =
{
    name : "shopSelect",
    contentType : null,
    _kItemsPerPage : 20,
    _itemlist : null,
_filter : null,
    _pageH : null,
    _stringBundle : null,
_sharingAllowed : false,
    _sharingEnabled : true,
    _callsOutstanding : 0,
    _sortOrder : null,
    _currentPage : null,
    _numPages : null,
    _localItems : null,
    _shopItems : null,
    _sharingItems : null,
    _params: null,
    _offerMapSubscription : true,
_searchString : null,
    _downloadDisclaimerVersion : "2.7",

    start : function(params)
    {
        ttSubTask.prototype.start.apply(this, arguments);

        this.contentType = params.contentType;
        this._searchString = params.searchString;{}
this._sharingAllowed = ttItem.isShareable(this.contentType);

        this._task.needDevice(makeCallback(this, this.serverListLoad));

        this.checkBrokenPaidDownload();
    },

    checkBrokenPaidDownload : function()
    {
        try {
            const kBroken = "tomtom.account.brokenDownload";
            if (!prefService().getBoolPref(kBroken))
                return;
            ttMessageService().alert(
                this._stringBundle.GetStringFromName("brokenDownloadWarningTitle"),
                this._stringBundle.GetStringFromName("brokenDownloadWarningText"));
            prefService().setBoolPref(kBroken, false);
        } catch (e) { unimportantError(e); }
    },

    serverListLoad : function()
    {
        var params = {
            sortOrder : "location",
            recommendationsOnly : true,
            category : "",
            currentPage : 1,
            search : "",
            language : ""
        };

        if (this._searchString)
        {
            params.search = this._searchString;
            params.recommendationsOnly = false;
        }

        this._itemlist = new ttItemList();
        this._filter = new ShopSelectFilter();
        this._itemlist.addFilter(this._filter);
        this._itemlist.addFilter(new ttDuplicateFilter());
        this._itemlist.addFilter(new ttDependencyTreeBuilder());
        this._ttwizard.loadPage(
                this._constructPageURL("serverList"),
                { contentType : this.contentType,
                  itemlist : this._itemlist,
                  refresh : makeCallback(this, this.fetchLists),
                  sharingAllowed : this._sharingAllowed,
                  ratingAllowed : ttItem.isRateable(this.contentType),
                  sortOrder : params.sortOrder,
                  recommendationsOnly : params.recommendationsOnly,
                  search: params.search
                },
                makeCallback(this, this.serverListLoadAsync, params),
                makeCallback(this, this.serverListLogin),
                makeCallback(this, this.serverListDone)
            );
    },

    serverListLoadAsync : function(params, page)
    {
        this._pageH = page;
        this._task.doDeviceScan(makeCallback(this, this.fetchLists, params), errorAbortTask);
    },

    fetchLists : function(params)
    {
        this._params = params;
        this._pageH.inputStart();
        this._itemlist.clear();
        this._sortOrder = params.sortOrder;

        this._localItems = {};
        this._localItems.__proto__ = null;

        this.deviceListFetch(params);
        this.localListFetch(params);
        this.shopListFetch(params);
        this.sharingListFetch(params);
    },

    deviceListFetch : function(params)
    {
        for each (let loc in gApplication.deviceManager.getInstallLocationsForDevice())
        {
            let items = gApplication.itemFactory.createItemListFromDLL(loc.deviceNavItems(), this.contentType);
            this._filter.addKnownItems(items);
        }
    },

    localListFetch : function(params)
    {
        var itemlist = new ttItemList();
        itemlist.addFilter(new ttDuplicateFilter());
        itemlist.addItemListFromDLL(gApplication.homeServices.localNavItems(), this.contentType);

        var items = itemlist.contents;

        var sortFunction = this._sortFunctions[this._sortOrder];
        if (sortFunction)
            items.sort(sortFunction);

        this._filter.addKnownItems(items);
if (items.length && params.currentPage == 1 && params.sortOrder == "location" && !params.search && !params.category)
        {
            var uploadBody = <getcontentratings><contentidlist/></getcontentratings>;
            for each (var item in items)
            {
                uploadBody.contentidlist.appendChild(<content idurl={item.idurl}/>);
            }

            var dev = gApplication.deviceManager.activeDevice;
            this._callsOutstanding++;
            this.networkCall(rpc.call("sharing", "getContentRatings",
                {
                    deviceSerial: dev.serial,
                    deviceCode: dev.deviceCode
                },
                uploadBody, RPC.METHOD_POST,
                makeCallback(this, function(result)
                {
                    var knownItems = this._filter.knownItems;
                    for each (var resultItem in result.contentidlist.content)
                    {
                        if (resultItem.@idurl in knownItems)
                        {
                            try
                            {
                                var localItem = knownItems[resultItem.@idurl];
                                localItem.rating = makeSafe.rangeInt(resultItem.@rating, 0, 5000);
                                localItem.votes = makeSafe.integer(resultItem.@votes);
                            } catch (e) {
}
                        }
                    }

                    this._itemlist.addItemListArray(items, true);
                    this.callSucceeded();
                }),
                makeCallback(this, function(e)
                {
                    unimportantError(e);
                    this._itemlist.addItemListArray(items, true);
                    this.callSucceeded();
                })));
        }
    },

    shopListFetch : function(params)
    {
        var dev = gApplication.deviceManager.activeDevice;
        var serverargs =
        {
            contentType: this.contentType,
            price: "all",
            deviceModel: dev.model.id,
            deviceCode: dev.deviceCode,
            deviceCapabilities: gApplication.deviceManager.activeDeviceCapabilitiesString,
            deviceParameters: gApplication.deviceManager.activeDeviceParametersString,
            deviceNavcoreVersion: dev.versionNavCore,
            recommendationsOnly: params.recommendationsOnly,
            category: params.category,
            search: params.search,
            language: params.language,
            publicBeta: prefService().getBoolPref("tomtom.app.showBetaVersions")
        };
        addSubscriptionsRPCArgs(serverargs);

        this._callsOutstanding++;
        this.networkCall(rpc.call("shop", "getShopContent", serverargs,
            null, RPC.METHOD_GET,
            makeCallback(this, function(result)
            {
                this._shopItems = gApplication.itemFactory.createItemListFromServer(result);
                this.callSucceeded();
            }),
            makeCallback(this, this.callFailed)));
    },

    sharingListFetch : function(params)
    {
        if (!this._sharingAllowed)
            return;

        var dev = gApplication.deviceManager.activeDevice;

        this._callsOutstanding++;
        this.networkCall(rpc.call("sharing", "getUserContent",
            {
                deviceserial: dev.serial,
                deviceModel: dev.model.id,
                deviceNavcoreVersion: dev.versionNavCore,
                deviceNavcoreBuild: dev.buildNumberNavCore,
                deviceCapabilities: gApplication.deviceManager.activeDeviceCapabilitiesString,
                deviceParameters: gApplication.deviceManager.activeDeviceParametersString,
                contentType: this.contentType,
                start: (params.currentPage - 1) * this._kItemsPerPage,
                showcount: this._kItemsPerPage + 1,
                sortby: (params.sortOrder == "location" ? "name" : params.sortOrder),
                category: params.category,
                search: params.search,
                recommendationsOnly: params.recommendationsOnly
            }, null, RPC.METHOD_GET,
            makeCallback(this, function(result)
            {
                var totalcount = makeSafe.integer(result.@totalcount);
                var start = makeSafe.integer(result.@start);
                this._currentPage = Math.floor(start / this._kItemsPerPage) + 1;
                this._numPages = Math.ceil(totalcount / this._kItemsPerPage);

                this._sharingItems = gApplication.itemFactory.createItemListFromServer(result);
                this.callSucceeded();
            }),
            makeCallback(this, function(e)
            {
                if (e.code == -5)
                    this._sharingEnabled = false;
                unimportantError(e);
                this.callSucceeded();
            })));
    },

    callSucceeded : function(error)
    {
        if (--this._callsOutstanding <= 0)
            this.requestsFinished();
    },

    callFailed : function(error)
    {
        errorNonFatal(error);
        if (--this._callsOutstanding <= 0)
            this.requestsFinished();
    },
requestsFinished : function()
    {
        var sortFunction = this._sortFunctions[this._sortOrder];
        var sharingItems = (sortFunction ? this._sharingItems.sort(sortFunction) : this._sharingItems);

        var items = sharingItems.concat(this._shopItems);
        if (sortFunction)
            items.sort(sortFunction);
        if (this._currentPage >= 2)
        {
            var cutOffItem = sharingItems[0];
            for (var i = 0; i < items.length; i++)
            {
                if (items[i] == cutOffItem)
                {
                    items.splice(0, i);
                    break;
                }
            }
        }
        if (this._currentPage < this._numPages)
        {
            var cutOffItem = sharingItems[sharingItems.length - 1];
            for (var i = items.length - 1; i >= 0; i--)
            {
                if (items[i] == cutOffItem)
                {
                    items.splice(i);
                    break;
                }
            }
        }

        this._itemlist.addItemListArray(items, true);

        if (this.contentType == "map" && this._offerMapSubscription)
        {
            try {
                this.networkCall(top.MapSubscription.offerMapSubscriptionDeal(true, "mapshop"));
                this._offerMapSubscription = false;
            } catch (e) {
            }
        }

        this._pageH.inputDone({
            sharingEnabled : this._sharingEnabled,
            currentPage : this._currentPage,
            numPages : this._numPages
        });
    },
serverListLogin : function(result, successCallback, errorCallback, returnCallback, skipWarning)
    {
        if (result.some(function (item) (item.isServer && (!item.price || item.price.free))))
        {
            this.networkCall(this._task.needLogin(
                    makeCallback(this, this.serverListCheck, result, successCallback, errorCallback, returnCallback, skipWarning),
                    returnCallback));
        }
        else
            this.serverListCheck(result, successCallback, errorCallback, returnCallback, skipWarning);
    },
serverListCheck : function(result, successCallback, errorCallback, returnCallback, skipWarning)
    {
        var showDownloadDisclaimer = true;
        try
        {
            showDownloadDisclaimer = prefService().getBoolPref('tomtom.' + this._downloadDisclaimerVersion + '.showDownloadDisclaimer');
        } catch(e) {}

        if (!skipWarning && result.some(function (item) item.isSharing) && showDownloadDisclaimer)
        {
            this._task.trackDialog(top.gMainWindow.dialogs.openDialogAsPage(
                "chrome://tthome/content/ui/subtask/shareContent/downloadDisclaimer.xul",
                null,
                null,
                makeCallback(this, function([doContinue, showDownloadDisclaimer])
                {
                    if (doContinue)
                    {
                        if (!showDownloadDisclaimer)
                        {
                            try
                            {
                                prefService().setBoolPref('tomtom.' + this._downloadDisclaimerVersion + '.showDownloadDisclaimer', false);
                            }
                            catch(e)
                            {
                                unimportantError(e);
                            }
                        }
                        this.serverListCheck(result, successCallback, errorCallback, returnCallback, true);
                    }
                    else
                        returnCallback();
                })));
            return;
        }
        if (result.some(function (item) item instanceof ttMap &&
                                        item.basemap == item.idstr &&
                                        item.size > gApplication.deviceManager.activeInstallLocation.sizeInBytesTotal))
        {
            let alertType = gApplication.deviceManager.activeDevice.hasEmptySDCardSlot ? "Alternative" : "Serious";
            ttMessageService().confirm(
                this._stringBundle.GetStringFromName("flavours." + alertType + ".PrePurchaseWarningTitle"),
                this._stringBundle.GetStringFromName("flavours." + alertType + ".PrePurchaseWarningBody"),
                this._stringBundle.GetStringFromName("flavours.Cancel"),
                this._stringBundle.GetStringFromName("flavours.Continue"),
                makeCallback(this, successCallback, result),
                function() {
                    for each (var item in result)
                        gApplication.cart.removeItem(item);
                    returnCallback();
                }, MessageService.SEVERITY_WARNING, "mapflavours");
        }
        else
        {
            var cartTotalSize = 0;
            for each (item in gApplication.cart.contentsFlat)
                cartTotalSize += item.size;
            if (cartTotalSize > gApplication.deviceManager.activeInstallLocation.sizeInBytesFree)
            {
                this._task.trackDialog(gMainWindow.dialogs.openDialogAsPage(
                    "chrome://tthome/content/ui/subtask/shopSelect/sizeWarning.xul",
                    { newItems : result },
                    null,
                    function(buttonPressed)
                    {
                        switch (buttonPressed)
                        {
                            case 1:
                                successCallback(result);
                                break;
                            case 2:
                                for each (var item in result)
                                    gApplication.cart.removeItem(item);
                                returnCallback();
                                break;
                            case 3:
                                returnCallback();
                                break;
                            default:
                                throw new NotReached();
                        }
                    }));
            }
            else
                successCallback(result);
        }
    },

    serverListDone : function(result)
    {
        this.subtaskDone(result);
    },

    _sortFunctions : {
        location : function(item1, item2)
            {
                var locationPriority =
                {
                    1 : 3,
                    2 : 3,
                    3 : 3,
                    4 : 1,
                    6 : 2,
                    __end: null
                };
                var locPriority1 = (item1.isServer && item1.isSharing ? 1 : locationPriority[item1.locationType] || 0)
                var locPriority2 = (item2.isServer && item2.isSharing ? 1 : locationPriority[item2.locationType] || 0)
                return (locPriority2 - locPriority1) || ShopSelect.compareString(item1.name, item2.name);
            },
        rating : function(item1, item2)
            {
                return (item2.rating - item1.rating) || ShopSelect.compareString(item1.name, item2.name);
            },
        submissiondate : function(item1, item2)
            {
                var date1 = (item1.lastModification || new Date(0));
                var date2 = (item2.lastModification || new Date(0));
                return (date2.getTime() - date1.getTime()) || ShopSelect.compareString(item1.name, item2.name);
            },
        downloadcount : function(item1, item2)
            {
                return (item2.downloads - item1.downloads) || ShopSelect.compareString(item1.name, item2.name);
            },
        name : function(item1, item2)
            {
                return ShopSelect.compareString(item1.name, item2.name);
            },
    },

    __end : null
}
extend(ShopSelect, ttSubTask);
ShopSelect.compareString = function(str1, str2)
{
    str1 = str1.toLowerCase();
    str2 = str2.toLowerCase();
    if (str1 < str2)
        return -1;
    else if (str1 > str2)
        return 1;
    else
        return 0;
}
function ShopSelectFilter()
{
    ttItemListFilter.apply(this);
    this.resetAll();
}
ShopSelectFilter.prototype =
{
    _knownItems: null,
get knownItems()
    {
        return this._knownItems;
    },
addKnownItems: function(items)
    {
        for each (var item in items)
        {
            if (item instanceof ttNavItem && item.canInstallOn(gApplication.deviceManager.activeDevice) != 0)
                continue;

            if (!(item.idurl in this._knownItems) || item.newerThan(this._knownItems[item.idurl]))
                this._knownItems[item.idurl] = item;
            if (!(item.idstrlong in this._knownItems) || item.newerThan(this._knownItems[item.idstrlong]))
                this._knownItems[item.idstrlong] = item;
        }
    },

    checkItem: function(item)
    {
        if (item instanceof ttNavItem && item.canInstallOn(gApplication.deviceManager.activeDevice) != 0)
            return [];

        var existingItem = null;
        if (item.idurl in this._knownItems)
            existingItem = this._knownItems[item.idurl];
        else if (item.idstrlong in this._knownItems)
            existingItem = this._knownItems[item.idstrlong];

        if (!existingItem || existingItem == item)
            return [item];

        if (item.isServer)
        {
            if (existingItem.downloads != item.downloads)
                existingItem.downloads = item.downloads;
            if (existingItem.lastModification != item.lastModification)
                existingItem.lastModification = item.lastModification;
            if (existingItem.rating != item.rating)
                existingItem.rating = item.rating;
            if (existingItem.votes != item.votes)
                existingItem.votes = item.votes;

            this.itemlist.updateItem(existingItem);
        }
        if (item.newerThan(existingItem) || existingItem.canInstallOn(gApplication.deviceManager.activeDevice) != 0)
            return [existingItem, item];
        else
            return [existingItem];
    },

    resetItem: function(item)
    {
        if (item.idurl in this._knownItems && this._knownItems[item.idurl] == item)
            delete this._knownItems[item.idurl];
        if (item.idstrlong in this._knownItems && this._knownItems[item.idstrlong] == item)
            delete this._knownItems[item.idstrlong];
    },

    resetAll: function()
    {
        this._knownItems = {__proto__: null};
    }
}
extend(ShopSelectFilter, ttItemListFilter);
