/*
  @Copyright 2006-2009 TomTom, BV
  TomTom is hiring experienced mozilla developers! - contact us at xul-jobs@tomtom.com
*/

function assertRunnable(params)
{
    var dev = gApplication.deviceManager.activeDevice;
    if (!dev)
        throw new DeviceAbsentException();

    switch(params.contentType)
    {
        case "map":
        case "safetycamera":
        case "voice":
        case "poi":
        case "colorscheme":
            break;
        case "program":
        case "rdstmcsubscription":
        case "trail":
        case "htmlpack":
        case "ephemeris":
        case "phonedb":
        case "zipcode":
        case "partialupdate":
        case "mapasr":
            break;
        case "satimage":
            if (!deviceSupportsCapabilitySet(dev, "MapOverlays"))
                throw new UnsupportedCapabilityException();
            break;
        case "warningsound":
            if (!deviceSupportsCapabilitySet(dev, "WarningSounds"))
                throw new UnsupportedCapabilityException();
            break;
        case "traffic":
            if (!deviceSupportsCapabilitySet(dev, "Traffic"))
                throw new UnsupportedCapabilityException();
            break;
        case "fuelprice":
            if (!deviceSupportsCapabilitySet(dev, "PlusFuelPrices"))
                throw new UnsupportedCapabilityException();
            break;
        case "liveservices":
            if (!deviceSupportsCapabilitySet(dev, "LiveServices"))
                throw new UnsupportedCapabilityException();
            break;
        case "itinerary":
            if (!deviceSupportsCapabilitySet(dev, "Itinerary"))
                throw new UnsupportedCapabilityException();
            break;
        case "localsearch":
            if (!deviceSupportsCapabilitySet(dev, "LiveServices"))
                throw new UnsupportedCapabilityException();
            break;
        case "carsymbol":
            if (!deviceSupportsCapabilitySet(dev, "CarSymbol"))
                throw new UnsupportedCapabilityException();
            break;
        case "startupscreen":
            if (!deviceSupportsCapabilitySet(dev, "StartupImage"))
                throw new UnsupportedCapabilityException();
            break;
        case "suspendscreen":
            if (!deviceSupportsCapabilitySet(dev, "SuspendImage"))
                throw new UnsupportedCapabilityException();
            break;
        case "homesymbol":
        case "buddysymbol":
        case "favouritesymbol":
            if (!deviceSupportsCapabilitySet(dev, "UserSkin"))
                throw new UnsupportedCapabilityException();
            break;
        case "messagereceived":
            if (!deviceSupportsCapabilitySet(dev, "SmsReceivedSound"))
                throw new UnsupportedCapabilityException();
            break;
        case "ringtone":
            if (!deviceSupportsCapabilitySet(dev, "Ringtone"))
                throw new UnsupportedCapabilityException();
            break;
        case "startupsound":
        case "shutdownsound":
            if (!deviceSupportsCapabilitySet(dev, "ExtraSounds"))
                throw new UnsupportedCapabilityException();
            break;
        case "arrivalsound":
            if (!deviceSupportsCapabilitySet(dev, "ArrivalSounds"))
                throw new UnsupportedCapabilityException();
            break;
        case "loquendovoice":
            if (!deviceSupportsCapabilitySet(dev, "TTSLoquendo*"))
                throw new UnsupportedCapabilityException();
            break;
        case "vocalizervoice":
            if (!deviceSupportsCapabilitySet(dev, "TTSNuance*"))
                throw new UnsupportedCapabilityException();
            break;
        default:
            throw new TaskPreconditionsUnmetException();
    }
}
